#!/usr/bin/perl
# generate 16bits to 16bits translater
# Copyright (c) 1999 FURUKAWA Yo. All rights reserved.
# $Id: gen16to16.pl,v 1.1 1999/02/28 07:56:46 furukawa Exp $

sub gen16to16 {

# --- --- --- --- --- --- --- --- --- --- --- --- --- --- --- ---
# THE FIRST STAGE: find min-max for src's lo and hi bytes.

$hi_min = 0xff;
$hi_max = 0x00;
$lo_min = 0xff;
$lo_max = 0x00;

open(TABLEFILE, $infile_name) || die "cannot open file";
while (<TABLEFILE>){
    if (!/^#/){
	@fields = split;
	$src_no = hex(@fields[$src_field]);
	$hi = $src_no / 256;
	$lo = $src_no % 256;
	if ($hi_max < $hi){
	    $hi_max = $hi;
	}
	if ($hi_min > $hi){
	    $hi_min = $hi;
	}
	if ($lo_max < $lo){
	    $lo_max = $lo;
	}
	if ($lo_min > $lo){
	    $lo_min = $lo;
	}
	$key = sprintf("0x%02X%02X", $hi, $lo);
	$dst_no = hex(@fields[$dst_field]);
	$hi = $dst_no / 256;
	$lo = $dst_no % 256;
	$val = sprintf("0x%02X%02X", $hi, $lo);
	$conv_table{$key} = $val;
    }
}
close(TABLEFILE);

#printf("min-max -> hi:%02X-%02X lo:%02X-%02X\n",
#       $hi_min, $hi_max, $lo_min, $lo_max);

# --- --- --- --- --- --- --- --- --- --- --- --- --- --- --- ---
# THE SECOND STAGE: generate convertion table.

printf("/* this is an automatically generated file. do not edit. */\n");
printf("\n");
printf("\n");
printf("#define NODATA 0x0000\n");
printf("\n");

printf("static unsigned short table%sto%s[] = {\n", $src_name, $dst_name);
for ($hi = $hi_min; $hi <= $hi_max; $hi++){
    printf("    /* 0x%02X%02X - 0x%02X%2X */\n", $hi, $lo_min, $hi, $lo_max);
    printf("    ");
    $n = 0;
    for ($lo = $lo_min; $lo <= $lo_max; $lo++){
	$key = sprintf("0x%02X%02X", $hi, $lo);
	if (defined($conv_table{$key})){
	    printf("%s, ", $conv_table{$key});
	}else{
	    printf("NODATA, ");
	}
	$n++;
	if ($n >= 8){
	    printf("\n    ");
	    $n = 0;
	}
    }
    printf("\n");
}
printf("};\n");

# --- --- --- --- --- --- --- --- --- --- --- --- --- --- --- ---
# THE THIRD STAGE: generate convertion fucntion.

printf("\n");
printf("unsigned short\n");
printf("conv_%sto%s(unsigned short src)\n", $src_name, $dst_name);
printf("{\n");
printf("    unsigned short hi, lo;\n");
printf("    hi = src >> 8;\n");
printf("    lo = src & 0xff;\n");
printf("    if (0x%02X <= hi && hi <= 0x%02X\n", $hi_min, $hi_max);
printf("        && 0x%02X <= lo && lo <= 0x%02X){\n", $lo_min, $lo_max);
printf("        return table%sto%s[((hi-(0x%02X))*((0x%02X)-(0x%02X)+1))+(lo-(0x%02X))];\n",
       $src_name, $dst_name, $hi_min, $lo_max, $lo_min, $lo_min);
printf("    }\n");
printf("\n");
printf("    return NODATA;\n");
printf("}\n");
printf("\n");

}

1;
