/*
   calendar routines
   Copyright (c) 1997 FURUKAWA Yo.
   $Id: calendar.h,v 1.1.1.1 1998/12/15 03:42:44 furukawa Exp $
   */

#ifndef _CALENDAR_H_
#define _CALENDAR_H_

#include "arch.h"
#include "util.h"

/* -- global variables */

extern uint8 gDayOfWeekBit[];
extern uint8 gNthWeekBit[];

/* -- macros */

#define DATE_UNDEF	0
#define DATE_THE_BEGIN	1
#define DATE_THE_END	UINT16_MAX

#define DayOfWeek_1Jan1900	1	/* 1 Jan 1900 is Monday */

#define IsLeap(year) (!((year) % 4) && ((year) % 100) || !((year) % 400))

#define Calendar_GetDayOfWeekByNo(dayNo) ((DayOfWeek_1Jan1900 + ((dayNo) - 1)) % 7)

#define Calendar_GetMonthNo(year, month) (((year) - 1900) * 12 + (month) - 1)

/* -- prototypes */

uint16
Calendar_GetDayOfWeek(uint16 year, uint16 month, uint16 day);
uint16
Calendar_GetNumOfDays(uint16 year, uint16 month);

uint16
Calendar_GetDayNo(uint16 year, uint16 month, uint16 day);
uint16
Calendar_GetYearByNo(uint16 dayNo);
uint16
Calendar_GetMonthByNo(uint16 dayNo);
uint16
Calendar_GetDayByNo(uint16 dayNo);
uint16
Calendar_GetNumOfDaysByNo(uint16 dayNo);
void
Calendar_GetDateByNo(uint16 dayNo, 
		     uint16 *out_year, uint16 *out_month, uint16 *out_day);
void
Calendar_GetMonthDayByNo(uint16 dayNo, 
			 uint16 *out_month, uint16 *out_day);

char *
Calendar_GetNameOfMonth(uint16 month);
char *
Calendar_GetNameOfWeek(uint16 dayOfWeek);

#endif
