/*
   parse date & time
   Copyright (c) 1998 FURUKAWA Yo.
   $Id: parse.c,v 1.1.1.1 1998/12/15 03:42:45 furukawa Exp $
   */

#include "arch.h"
#include "token.h"
#include "parse.h"
#include <string.h>
#include <stdlib.h>
#include <stdio.h>

/*
   դȻΥѡ
   ʸΥƥ
     άξϡʸδȤ
   ԤΥƥ
     ŪˤϹñ̡ҤȤĤιԤĤդϴ֤򤢤魯
     ܤάξϡҤȤܤˤ
   */

/* -- macros */
#define PARSE_MAX_LINELEN	80

/* -- global variables */

/* -- file local types */

/* -- file local variables */

/* -- file local methods */
static void
Parse_ParseLine(ParseCTX *ctx, uint8 *token, uint16 *token_attr, int tail);
static bool
Parse_ParseDate_Jap(ParseCTX *ctx, uint8 *token, uint16 *token_attr, int *cur, int tail);

/* -- methods */

/*  */
void
Parse_Init(ParseCTX *ctx)
{
    memset(ctx, 0, sizeof(ParseCTX));
}

/* ǽĴ򤷤ơ̤֤ */
void
Parse_Finish(ParseCTX *ctx)
{
}

/* Ԥä */
void
Parse_FeedLine(ParseCTX *self, char *line)
{
    uint8 token[PARSE_MAX_LINELEN];
    int16 token_attr[PARSE_MAX_LINELEN];
    int i, num;
    char *p;

    /* Ĵ */
    if (strlen(line) >= PARSE_MAX_LINELEN){
	line[PARSE_MAX_LINELEN-1] = '\0';
    }

    /* ȡʬ */
    num = 0;
    p = line; 
    while (NULL != (p = Token_GetNext(p, &(token[num]), &(token_attr[num])))){
	num++;
    }

#if 1
    for (i = 0; i < num; i++){
	if (token[i] == TOK_WHITE){
	    fprintf(stdout, ".");
	}else if (token[i] != TOK_UNKNOWN){
	    fprintf(stdout, "[%d:%d]", token[i], token_attr[i]);
	}else if (token[i] == TOK_UNKNOWN){
	    fprintf(stdout, "_");
	}else{
	    fprintf(stdout, "?");
	}
    }
    fprintf(stdout, "\n");
#endif

    Parse_ParseLine(self, token, token_attr, num);
}

/* Ԥѡ */
static void
Parse_ParseLine(ParseCTX *ctx,
		uint8 *token, uint16 *token_attr, int tail)
{
    int cur, p;
    bool r;

    ctx->line_start_date_valid = false;
    ctx->line_start_time_valid = false;
    ctx->line_end_date_valid = false;
    ctx->line_end_time_valid = false;

    for (cur = 0; cur < tail; cur++){
	switch (token[cur]){
	    case TOK_NENGOU:
	    r = Parse_ParseDate_Jap(ctx, token, token_attr, &cur, tail);
	    break;

#if 0	    
	    case TOK_NUMBER:
	    for (p = cur + 1; p < tail && token[p] == TOK_WHITE; p++);
	    break;
#endif
	}
    }
}

/* ݡݡݡݡݡݡݡݡݡݡݡݡݡݡݡݡݡݡݡݡݡݡݡݡݡ */

#define JYearToYear(jyear)	((jyear)+1988)
#define YearToYear(year)	((year)<100?(year)+1900:(year))
#define IsYearNumber(num)	((((num)>=0)&&((num)<100))||(((num)>=1970)&&((num)<2050)))
#define IsMonthNumber(num)	(((num)>=1)&&((num)<=12))
#define IsDayNumber(num)	(((num)>=1)&&((num)<=31))

#define ST_NONE			0
#define ST_PENDING		1
#define ST_INVALID		2
#define ST_END			3
#define ST_NEXT_IS_JYEAR	4

static bool
Parse_ParseDate_Jap(ParseCTX *ctx,
		    uint8 *token, uint16 *token_attr,
		    int *cur, int tail)
{
    int p;
    bool state, isJYear, pending;
    int16 pending_number;
    int16 year1, month1, day1;
    int16 year2, month2, day2;

    state = ST_NONE;
    pending = false;
    isJYear = false;
    pending_number = 0;
    year1 = month1 = day1 = -1;
    year2 = month2 = day2 = -1;

    for (p = *cur; p < tail; p++){
	switch (token[p]){
	    case TOK_WHITE:
	    fprintf(stdout, "[WHITE]");
	    /* ɤФ */
	    break;

	    case TOK_NENGOU:
	    fprintf(stdout, "[NENGOU]");
	    isJYear = true;
	    break;

	    case TOK_NEN:
	    fprintf(stdout, "[NEN]");
	    /* ǯ  ˿Ϥ */
	    if (pending && IsYearNumber(pending_number)){
		if (isJYear){
		    if (year1 < 0){
			year1 = JYearToYear(pending_number);
		    }else if (year2 < 0){
			year2 = JYearToYear(pending_number);
		    }
		}else{
		    if (year1 < 0){
			year1 = YearToYear(pending_number);
		    }else if (year2 < 0){
			year2 = YearToYear(pending_number);
		    }
		}
		state = ST_NONE;
	    }else{
		state = ST_INVALID;
	    }
	    break;

	    case TOK_GATU:
	    fprintf(stdout, "[GATU]");
	    /*   ˿Ϥ */
	    if (pending && IsMonthNumber(pending_number)){
		if (month1 < 0){
		    month1 = pending_number;
		}else if (month2 < 0){
		    month2 = pending_number;
		}
		state = ST_NONE;
	    }else{
		state = ST_INVALID;
	    }
	    break;

	    case TOK_NITI:
	    fprintf(stdout, "[NITI]");
	    /*   ˿Ϥ */
	    if (pending && IsDayNumber(pending_number)){
		if (day1 < 0){
		    day1 = pending_number;
		}else if (day2 < 0){
		    day2 = pending_number;
		}
		state = ST_NONE;
	    }else{
		state = ST_INVALID;
	    }
	    break;

	    case TOK_NUMBER:
	    fprintf(stdout, "[NUMBER]");
	    pending = true;
	    pending_number = token_attr[p];
	    state = ST_PENDING;
	    break;

	    case TOK_SEPARATE:
	    fprintf(stdout, "[SEPARATE]");
	    if (token_attr[p] == TOKATTR_HYPHEN
		|| token_attr[p] == TOKATTR_KARA){
		/* CONTINUE */
	    }else{
		/* EXIT */
		state = ST_END;
	    }
	    break;

	    default:
	    fprintf(stdout, "[--EXIT--]");
	    /* EXIT */
	    state = ST_END;
	    break;
	}

	if (state == ST_END || state == ST_INVALID){
	    fprintf(stdout, "\n");
	    break;
	}
    }

    fprintf(stdout, ">>raw detection>>  %d/%d/%d - %d/%d/%d\n",
	    year1, month1, day1, year2, month2, day2);

    if (state == ST_END){
	/* Ǥ⣱ȡϾ񤷤Ϥ */
	*cur = p;
	return true;
    }else{
	*cur = p;
	return false;
    }
}

/* ݡݡݡݡݡݡݡݡݡݡݡݡݡݡݡݡݡݡݡݡݡݡݡݡݡշ */
/* ٣٣٣ǯͣͷģ */
/* ٣ǯͣͷģ */

/* ͣͷģ */

/* ٣٣٣١ͣ͡ģ */
/* ٣١ͣ͡ģ */

/* ٣٣٣١ͣ͡ģ */
/* ٣١ͣ͡ģ */

/* ͣ͡ģġ٣٣٣ */
/* ͣ͡ģġ٣ */

/* ģġͣ͡٣٣٣ */
/* ģġͣ͡٣ */

/* ͣ͡ģ */

/* ģġͣ */

/* ʿˣ٣ǯͣͷģ */
/* ʿˣ٣١ͣ͡ģ */

/* ʣʣˣģġ٣٣٣ */
/* ʣʣˣģġ٣ */
/* ģġʣʣˡ٣٣٣ */
/* ģġʣʣˡ٣ */
/* ģġʣʣˣ٣٣٣ */
/* ģġʣʣˣ٣ */
/* ʣʣˣģ */
/* ģġʣʣ */

/* ٣٣٣١ݣͣ͡ݣģ */
/* ٣١ݣͣ͡ݣģ */
/* ʿˣ٣١ݣͣ͡ݣģ */

/* ݡݡݡݡݡݡݡݡݡݡݡݡݡݡݡݡݡݡݡݡݡݡݡݡݡݻ */
/* ʸˣȣȻͣʬ */
/* ȣȻͣʬ */
/* ȣȻȾ */
/* ȣȻ */

/* ȣȡͣ */
/* ȣȡͣ͡ʣ͡*/
/* ʣ͡ˣȣȡͣ*/

#if 1
int main(void)
{
    char buf[1024];
    ParseCTX pdt;
    
    Parse_Init(&pdt);
    while (NULL != fgets(buf, sizeof(buf), stdin)){
#if 1
	fprintf(stdout, buf);
#endif
	Parse_FeedLine(&pdt, buf);
    }
    Parse_Finish(&pdt);
    return 0;
}
#endif
