/*
   function key
   Copyright (c) 1997,98 FURUKAWA Yo.
   $Id: funckey.c,v 1.1.1.1 1998/12/15 03:42:46 furukawa Exp $
   */

#include "global.h"
#include "arch.h"
#include "taskmg.h"
#include "taskid.h"
#include "view.h"
#include "jump.h"
#include "info.h"
#include "additem.h"
#include "funckey.h"
#include "context.h"
#include <stdio.h>
#include <stdlib.h>
#include <u-k.h>

/* -- file local variables */

/* t@NVL[ */
static HWND hFuncKey;
static FUNCTBL funcTable[] = {
	{1,	" wv ",	ID_FUNC_HELP},
	{2,	"  ǉ  ",	ID_FUNC_ADD_SCHEDULE},
	{3,	" ^XN ",	ID_FUNC_ADD_TASK},
	{4,	"Wv",	ID_FUNC_JUMP},
	{5,	"      ",	ID_FUNC_NOW},
	{6,	"  \  ",	ID_FUNC_SIZE},
	{7,	" R ",	ID_FUNC_MONTH},
	{8,	" T ",	ID_FUNC_WEEKS},
	{9,	"  T  ",	ID_FUNC_WEEK},
	{10,	"      ",	ID_FUNC_DAY},
	{11,	"    ",	ID_FUNC_SEL_LABEL0},
	{12,	" ނP ",	ID_FUNC_SEL_LABEL1},
	{13,	" ނQ ",	ID_FUNC_SEL_LABEL2},
	{14,	" ނR ",	ID_FUNC_SEL_LABEL3},
	{15,	" ނS ",	ID_FUNC_SEL_LABEL4},
	{16,	"JX^",	ID_FUNC_SEL_LABEL_CUST},
	{17,	" ",		0},
	{18,	" ",		0},
	{19,	"    ",	ID_FUNC_FIND},
	{20,	"  ",	ID_FUNC_FINDNEXT},
	{21,	"t@C",	ID_FUNC_FILER},
	{22,	"uEY",	ID_FUNC_BROWSE},
	{23,	" [ ",	ID_FUNC_MAILER},
	{24,	" N ",	ID_FUNC_LINK},
	{25,	"N",	ID_FUNC_UNLINK},
	{26,	" ",		0},
	{27,	" ",		0},
	{28,	"ݒ",	ID_FUNC_ENV},
	{0, "", 0}
};
static FUNCTBL funcAddTable[] = {
	{1,	" wv ",	ID_FUNC_HELP},
	{2,	" ",		0},
	{3,	" ",		0},
	{4,	"    ",	ID_FUNC_OK},
	{5,	"    ",	ID_FUNC_CANCEL},
	{6,	" ",		0},
	{7,	" ",		0},
	{8,	" ",		0},
	{9,	" ",		0},
	{10,	" ",		0},
	{11,	"    ",	ID_FUNC_LABEL0},
	{12,	" ނP ",	ID_FUNC_LABEL1},
	{13,	" ނQ ",	ID_FUNC_LABEL2},
	{14,	" ނR ",	ID_FUNC_LABEL3},
	{15,	" ނS ",	ID_FUNC_LABEL4},
	{16,	" ",		0},
	{17,	" ",	 	0},
	{18,	" ",		0},
	{19,	" ",		0},
	{20,	" ",		0},
	{21,	" ",		0},
	{22,	" ",		0},
	{23,	" ",		0},
	{24,	" ",		0},
	{25,	" ",		0},
	{26,	" ",		0},
	{27,	" ",		0},
	{28,	" ",		0},
	{0, "", 0}
};
static FUNCTBL funcInvalidateTable[] = {
	{1,	" wv ",	ID_FUNC_HELP},
	{2,	" ",		0},
	{3,	" ",		0},
	{4,	" ",		0},
	{5,	" ",		0},
	{6,	" ",		0},
	{7,	" ",		0},
	{8,	" ",		0},
	{9,	" ",		0},
	{10,	" ",		0},
	{11,	" ",		0},
	{12,	" ",		0},
	{13,	" ",		0},
	{14,	" ",		0},
	{15,	" ",		0},
	{16,	" ",		0},
	{17,	" ",	 	0},
	{18,	" ",		0},
	{19,	" ",		0},
	{20,	" ",		0},
	{21,	" ",		0},
	{22,	" ",		0},
	{23,	" ",		0},
	{24,	" ",		0},
	{25,	" ",		0},
	{26,	" ",		0},
	{27,	" ",		0},
	{28,	" ",		0},
	{0, "", 0}
};

static FUNCTBL *curFuncTable;

/* -- methods */

/* t@NVL[̏ */
void
FuncKey_Initialize(void)
{
    int i;

    /* t@NVL[̐ */
    hFuncKey = mgUInitGuideLine(ghTaskInstance, ghMainWin);

    /* t@NVL[̕t */
    for (i = 0; i < 5; i++){
	sprintf(funcTable[10+i].strName, Context_GetLabelName(i));
	sprintf(funcAddTable[10+i].strName, Context_GetLabelName(i));
    }

    /* t@NVL[̐ݒ */
    curFuncTable = funcTable;
    mgUSetGuideLine(hFuncKey, (LPFUNCTBL)curFuncTable);
}

/* t@NVL[̕Еt */
void
FuncKey_Finilize(void)
{
    /* t@NVL[̍폜 */
    mgUQuitGuideLine(hFuncKey);
}

/* t@NVL[R}hǂ */
bool
FuncKey_IsFuncCommand(WPARAM wParam)
{
    if (ID_FUNC_START < wParam && wParam < ID_FUNC_END){
	return true;
    }else{
	return false;
    }
}

/* t@NVL[̖ */
void
FuncKey_Invalidate(void)
{
    mgUModGuideLine(hFuncKey, (LPFUNCTBL)funcInvalidateTable);
}

/* t@NVL[̗L */
void
FuncKey_Validate(void)
{
    mgUModGuideLine(hFuncKey, (LPFUNCTBL)curFuncTable);
}

/* t@NVL[̐ݒiCj */
void
FuncKey_SetMainMode(void)
{
    curFuncTable = funcTable;
    mgUModGuideLine(hFuncKey, (LPFUNCTBL)curFuncTable);
}

/* t@NVL[̗L */
void
FuncKey_SetAddMode(void)
{
    curFuncTable = funcAddTable;
    mgUModGuideLine(hFuncKey, (LPFUNCTBL)curFuncTable);
}

/* t@NVL[ */
LRESULT
FuncKey_Dispatch(HWND hSelf, UINT msg, WPARAM wParam, LPARAM lParam)
{
    uint16 prevMode;

    if (HIWORD(lParam) == BN_CLICKED){
	switch (wParam){
	    case ID_FUNC_HELP:
	    prevMode = gMode;
	    gMode = MODE_HELP;
	    mgUniHelp(hSelf, NULL, 0);
	    gMode = prevMode;
	    return 1;
	    break;

	    case ID_FUNC_OK:
	    case ID_FUNC_CANCEL:
	    case ID_FUNC_LABEL0:
	    case ID_FUNC_LABEL1:
	    case ID_FUNC_LABEL2:
	    case ID_FUNC_LABEL3:
	    case ID_FUNC_LABEL4:
	    if (gMode == MODE_ADD){
		/* ̓EBhEɃ_CNg */
		mgSendMessage(ghAddWin, WM_COMMAND, wParam, lParam);
	    }else if (gMode == MODE_ENV){
		/* ݒEBhEɃ_CNg */
		mgSendMessage(ghEnvWin, WM_COMMAND, wParam, lParam);
	    }else{
		/* ėp_CAOɃ_CNg */
		mgSendMessage(ghGenDlgWin, WM_COMMAND, wParam, lParam);
	    }
	    return 1;
	    break;

	    case ID_FUNC_ADD_SCHEDULE:
	    case ID_FUNC_ADD_TASK:
	    case ID_FUNC_ADD_HOLIDAY:
	    case ID_FUNC_JUMP:
	    case ID_FUNC_NOW:
	    case ID_FUNC_SIZE:
	    case ID_FUNC_MONTH:
	    case ID_FUNC_WEEKS:
	    case ID_FUNC_WEEK:
	    case ID_FUNC_DAY:
	    case ID_FUNC_SEL_LABEL0:
	    case ID_FUNC_SEL_LABEL1:
	    case ID_FUNC_SEL_LABEL2:
	    case ID_FUNC_SEL_LABEL3:
	    case ID_FUNC_SEL_LABEL4:
	    case ID_FUNC_SEL_LABEL_CUST:
	    case ID_FUNC_FIND:
	    case ID_FUNC_FINDNEXT:
	    case ID_FUNC_ENV:
	    case ID_FUNC_BROWSE:
	    case ID_FUNC_LINK:
	    case ID_FUNC_UNLINK:
	    case ID_FUNC_FILER:
	    case ID_FUNC_MAILER:
	    case ID_FUNC_EDITOR:
	    return View_Command(hSelf, wParam, lParam);
	    break;

	    case ID_FUNC_DICT:
	    case ID_FUNC_CALC:
	    case ID_FUNC_LIST:
	    Info_NotImplemented(hSelf);
	    break;

	    case ID_FUNC_DEBUG:
	    Info_DisplayDebug(hSelf);
	    return 1;
	    break;
	    case ID_FUNC_INFO:
	    Info_DisplayInformation(hSelf);
	    return 1;
	    break;
	    case ID_FUNC_ABOUT:
	    Info_DisplayAbout(hSelf);
	    return 1;
	    break;

	    default:
	    return 0;
	    break;
	}
    }
    return 0;
}
