/*
   generic dialog
   Copyright (c) 1997,98 FURUKAWA Yo.
   $Id: gendlg.c,v 1.1.1.1 1998/12/15 03:42:46 furukawa Exp $
   */

#define GENDLG
#include "global.h"
#include "taskmg.h"
#include "taskid.h"
#include "arch.h"
#include "funckey.h"
#include "calendar.h"
#include "gendlg.h"
#include <string.h>
#include <stdlib.h>
#include <stdio.h>
#include <u-k.h>

/* -- file local macros */
#define REGION_DIALOG_WIDTH	160
#define REGION_DIALOG_HEIGHT	70
#define REGION_DIALOG_LEFT	0
#define REGION_DIALOG_TOP	0
#define REGION_DIALOG_RIGHT	(REGION_DIALOG_WIDTH)
#define REGION_DIALOG_BOTTOM	(REGION_DIALOG_HEIGHT)

#define EDIT_1stLINE_TOP	(40+28*0)
#define REGION_START_DATE_LEFT	12

#define BUF_DESCRIPTION_LIMIT	13

/* -- file local variables */
/* GenDlgEBhE */
static char *nameGenDlg = "GenDlg";

static int16 string_len;
static char titleGenDlg[80];

/* -- file local methods */
static bool
GenDlg_Create(int16 mode, int16 arg);
static bool
GenDlg_Destroy(void);
static void
GenDlg_Redraw(void);
static bool
GenDlg_LostFocus(WPARAM id, WPARAM win);

/* -- methods */

/* GenDlg */
static bool
GenDlg_Create(int16 mode, int16 arg)
{
    D(mgDPrintf("GenDlg create\n"));

    /* ԕϐ */
    gMode = MODE_DIALOG;
    dialog_mode  = mode;
    string_len = arg;
    value_invalid = false;
    kanji_invalid = true;
    kanji_on = false;
    focus = next_focus = should_focus = 0;
    focus_min_val = focus_max_val = 0;
    focus_inc_type = INC_TYPE_NONE;
    focus_not_move = false;

    /* t@NVL[̐ݒ */
    FuncKey_SetAddMode();

    if (dialog_mode == GENDLG_STRING){
	/* LqRg[̍쐬 */
	hEditDescription =
	    mgCreateWindow(EDIT, (LPSTR)NULL, 
			   WS_CHILD|WS_VISIBLE|WS_BORDER|WS_TABSTOP|ES_LEFT,
			   (REGION_DIALOG_WIDTH-(string_len*8+4))/2,
			   EDIT_1stLINE_TOP,
			   string_len*8+4, 20,
			   ghGenDlgWin, (HMENU)ID_EDIT_DESCRIPTION,
			   ghTaskInstance);
	if (hEditDescription == NULL){
	    return false;
	}
	GenDlg_InitEditControl(hEditDescription, bufDescription,
			       BUF_DESCRIPTION_LIMIT, bufDescription);
	mgSetFocus(hEditDescription);
    }

    if (dialog_mode == GENDLG_DATE){
	uint16 year, month, day;
	char buf[10];

	/* tRg[̍쐬 */
	hEditStartYear =
	    mgCreateWindow(EDIT, (LPSTR)NULL, 
			   WS_CHILD|WS_VISIBLE|WS_BORDER|WS_TABSTOP|ES_RIGHT,
			   REGION_START_DATE_LEFT, EDIT_1stLINE_TOP,
			   BUF_START_YEAR_LEN*8+4, 20,
			   ghGenDlgWin, (HMENU)ID_EDIT_START_YEAR,
			   ghTaskInstance);
	if (hEditStartYear == NULL){
	    return false;
	}
	hEditStartMonth =
	    mgCreateWindow(EDIT, (LPSTR)NULL, 
			   WS_CHILD|WS_VISIBLE|WS_BORDER|WS_TABSTOP|ES_RIGHT,
			   REGION_START_DATE_LEFT+56, EDIT_1stLINE_TOP,
			   BUF_START_MONTH_LEN*8+4, 20,
			   ghGenDlgWin, (HMENU)ID_EDIT_START_MONTH,
			   ghTaskInstance);
	if (hEditStartMonth == NULL){
	    return false;
	}
	hEditStartDay =
	    mgCreateWindow(EDIT, (LPSTR)NULL, 
			   WS_CHILD|WS_VISIBLE|WS_BORDER|WS_TABSTOP|ES_RIGHT,
			   REGION_START_DATE_LEFT+96, EDIT_1stLINE_TOP,
			   BUF_START_DAY_LEN*8+4, 20,
			   ghGenDlgWin, (HMENU)ID_EDIT_START_DAY,
			   ghTaskInstance);
	if (hEditStartDay == NULL){
	    return false;
	}

	Calendar_GetDateByNo(gCursorDate, &year, &month, &day);
	sprintf(buf, "%d", year);
	GenDlg_InitEditControl(hEditStartYear, bufStartYear,
			       BUF_START_YEAR_LEN, buf);
	sprintf(buf, "%d", month);
	GenDlg_InitEditControl(hEditStartMonth, bufStartMonth,
			       BUF_START_MONTH_LEN, buf);
	sprintf(buf, "%d", day);
	GenDlg_InitEditControl(hEditStartDay, bufStartDay,
			       BUF_START_DAY_LEN, buf);
	mgSetFocus(hEditStartYear);
    }

    return true;
}

/* GenDlgЕt */
static bool
GenDlg_Destroy(void)
{
    D(mgDPrintf("GenDlg destroy\n"));

    if (kanji_on){
	IMESTRUCT imeStruct;
	/* IMEOFF */
	imeStruct.fnc = IME_SETOPEN;
	imeStruct.wParam = 0;
	mgSendIMEMessage(ghGenDlgWin, (LPARAM)&imeStruct);
    }
 
    if (dialog_mode == GENDLG_STRING){
	mgDestroyWindow(hEditDescription);
    }else{
	mgDestroyWindow(hEditStartYear);
	mgDestroyWindow(hEditStartMonth);
	mgDestroyWindow(hEditStartDay);
    }

    /* t@NVL[L */
    FuncKey_SetMainMode();

    gMode = MODE_VIEW;

    return true;
}

/* ^Cg̃Zbg */
void
GenDlg_SetTitle(char *title)
{
    sprintf(titleGenDlg, title);
}

/* ̃Zbg */
void
GenDlg_SetString(char *str)
{
    sprintf(bufDescription, str);
}

/* ̎擾 */
char *
GenDlg_GetString(void)
{
    return bufDescription;
}

/* t̎擾 */
uint16
GenDlg_GetDate(void)
{
    return getStartDateByBuf();
}

/* GfBbgRg[̏ݒ */
void
GenDlg_InitEditControl(HWND win, char *buf, uint16 size, char *init_str)
{
    memset(buf, 0, size+1);
    mgSendMessage(win, EM_SETFHANDLE, (WORD)(size+1), (LPARAM)(LPSTR)buf);
    mgSendMessage(win, EM_LIMITTEXT, (WORD)(size), (LPARAM)0);
    mgSendMessage(win, WM_SETTEXT, (WORD)0, (LPARAM)init_str);
}

/* GfBbgRg[̍̕Đݒ */
void
GenDlg_ResetControl(HWND win, char *buf)
{
    focus_not_move = true;
    mgSendMessage(win, EM_SETSEL, 0, MAKELPARAM(0, -1));
    mgSendMessage(win, WM_CLEAR, 0, 0L);
    mgSendMessage(win, WM_SETTEXT, (WORD)0, (LPARAM)buf);
    focus_not_move = false;
}

/* GenDlgEBhEĕ` */
static void
GenDlg_Redraw(void)
{
    HDC hDC;
    PAINTSTRUCT ps;

    hDC = mgBeginPaint(ghGenDlgWin, (LPPAINTSTRUCT)&ps);

    /* g */
    mgSelectStockObject(hDC, CL_WHITE|SOLID_PEN|SIZE1_PEN);
    mgMoveTo(hDC, REGION_DIALOG_LEFT, REGION_DIALOG_TOP);
    mgLineTo(hDC, REGION_DIALOG_RIGHT, REGION_DIALOG_TOP);
    mgMoveTo(hDC, REGION_DIALOG_LEFT, REGION_DIALOG_TOP);
    mgLineTo(hDC, REGION_DIALOG_LEFT, REGION_DIALOG_BOTTOM);
    mgMoveTo(hDC, REGION_DIALOG_LEFT, REGION_DIALOG_TOP+1);
    mgLineTo(hDC, REGION_DIALOG_RIGHT, REGION_DIALOG_TOP+1);
    mgMoveTo(hDC, REGION_DIALOG_LEFT+1, REGION_DIALOG_TOP);
    mgLineTo(hDC, REGION_DIALOG_LEFT+1, REGION_DIALOG_BOTTOM);
    mgSelectStockObject(hDC, CL_DKGRAY|SOLID_PEN|SIZE1_PEN);
    mgMoveTo(hDC, REGION_DIALOG_LEFT, REGION_DIALOG_BOTTOM-1);
    mgLineTo(hDC, REGION_DIALOG_RIGHT, REGION_DIALOG_BOTTOM-1);
    mgMoveTo(hDC, REGION_DIALOG_RIGHT-1, REGION_DIALOG_TOP);
    mgLineTo(hDC, REGION_DIALOG_RIGHT-1, REGION_DIALOG_BOTTOM);
    mgMoveTo(hDC, REGION_DIALOG_LEFT+1, REGION_DIALOG_BOTTOM-2);
    mgLineTo(hDC, REGION_DIALOG_RIGHT, REGION_DIALOG_BOTTOM-2);
    mgMoveTo(hDC, REGION_DIALOG_RIGHT-2, REGION_DIALOG_TOP+1);
    mgLineTo(hDC, REGION_DIALOG_RIGHT-2, REGION_DIALOG_BOTTOM);

    /* E */
    mgSelectStockObject(hDC, CL_BLACK|SOLID_PEN|SIZE1_PEN);
    mgMoveTo(hDC, REGION_DIALOG_LEFT+20, REGION_DIALOG_TOP+30);
    mgLineTo(hDC, REGION_DIALOG_RIGHT-20, REGION_DIALOG_TOP+30);

    /* ^Cg */
    mgSetBkMode(hDC, TRANSPARENT);
    mgSetTextColor(hDC, CL_BLACK);
    mgSelectStockObject(hDC, CL_BLACK|SOLID_PEN|SIZE1_PEN|F16_FNT);
    mgTextOut(hDC, (REGION_DIALOG_WIDTH - (8*strlen(titleGenDlg)))/2, 8,
	      titleGenDlg, strlen(titleGenDlg));

    if (dialog_mode == GENDLG_DATE){
	/* t̊ */
	mgTextOut(hDC, REGION_START_DATE_LEFT+38, EDIT_1stLINE_TOP+2, "N", 2);
	mgTextOut(hDC, REGION_START_DATE_LEFT+78, EDIT_1stLINE_TOP+2, "", 2);
	mgTextOut(hDC, REGION_START_DATE_LEFT+118, EDIT_1stLINE_TOP+2, "", 2);
    }

    mgEndPaint(ghGenDlgWin, (LPPAINTSTRUCT)&ps);
}

/* ł̒l̑ */
bool
GenDlg_ChangeByAllow(bool inc)
{
    uint16 val;
    char buf[10];

    D(mgDPrintf("GenDlg_ChangeByAllow()"));

    val = atoi(focus_buf);
    if (focus_inc_type == INC_TYPE_1){
	if (inc){
	    if (val >= focus_max_val){
		return false;
	    }
	    val++;
	}else{
	    if (val == focus_min_val){
		return false;
	    }
	    val--;
	}
    }else if (focus_inc_type == INC_TYPE_15){
	if (inc){
	    val = ((val / 15) * 15 + 15) % 60;
	}else{
	    val = (val / 15) * 15;
	    if (val == 0){
		val = 45;
	    }else{
		val = val - 15;
	    }
	}
    }
    sprintf(buf, "%d", val);
    GenDlg_ResetControl(focus, buf);

    /* SIɂ */
    mgSendMessage(focus, EM_SETSEL, 0, MAKELPARAM(0, -1));
}

/* l͈̔̓`FbN */
bool
GenDlg_CheckValueRange(WPARAM win)
{
    uint16 val;

    val = atoi(focus_buf);
    if (val < focus_min_val || val > focus_max_val){
	char buf[80];
	sprintf(buf, "lsł\n%d  %d ܂",
		focus_min_val, focus_max_val);
	mgMessageBox(win, buf, MB_OK);
	should_focus = win;
	value_invalid = true;
	return false;
    }else{
	value_invalid = false;
	return true;
    }
}

/* tH[JXȂȂƂ̏ */
static bool
GenDlg_LostFocus(WPARAM id, WPARAM win)
{
    bool r;
    static bool checking = false;

    if (checking){
	/* Qd`FbNh~ */
	return true;
    }

    /* l`FbN */
    switch (id){
	case ID_EDIT_DESCRIPTION:
	checking = false;
	return true;
	break;
    }
    checking = true;
    r = GenDlg_CheckValueRange(win);
    checking = false;
    if (r == false){
	char buf[5];
	sprintf(buf, "%d", focus_min_val);
	GenDlg_ResetControl(win, buf);
	mgSendMessage(win, EM_SETSEL, 0, MAKELPARAM(0, -1));
	return false;
    }

    return true;
}

/* tH[JX𓾂ꂽƂ̏ */
bool
GenDlg_GainFocus(WPARAM id, WPARAM win)
{
    /* ׂłȂƂ͖߂ */
    if (should_focus != 0){
	/* tH[JX߂ */
	mgSetFocus(should_focus);
	should_focus = 0;
	return false;
    }

    /* tH[JXꂽRg[̑ݒ */
    GenDlg_MoveFocus(id);

    /* SIɂ */
    mgSendMessage(win, EM_SETSEL, 0, MAKELPARAM(0, -1));

    /* ϊON/OFF */
    switch (id){
	case ID_EDIT_DESCRIPTION:
	kanji_invalid = false;
	if (!kanji_on){
	    IMESTRUCT imeStruct;
	    kanji_on = true;
	    D(mgDPrintf("kanji on"));
	    /* IMEON */
	    imeStruct.fnc = IME_SETOPEN;
	    imeStruct.wParam = 1;
	    mgSendIMEMessage(ghAddWin, (LPARAM)&imeStruct);
	}
	break;

	default:
	kanji_invalid = true;
	if (kanji_on){
	    IMESTRUCT imeStruct;
	    kanji_on = false;
	    D(mgDPrintf("kanji off"));
	    /* IMEOFF */
	    imeStruct.fnc = IME_SETOPEN;
	    imeStruct.wParam = 0;
	    mgSendIMEMessage(ghAddWin, (LPARAM)&imeStruct);
	}
	break;
    }
    
    return true;
}

/* tH[JXړ */
void
GenDlg_MoveFocus(WORD id)
{
    uint16 year, month;

    switch (id){
	case ID_EDIT_DESCRIPTION:
	focus = hEditDescription;
	if (dialog_mode == GENDLG_STRING){
	    next_focus = hEditDescription;
	}else{
	    next_focus = hEditStartYear;
	}
	focus_min_val = 0;
	focus_max_val = 0;
	focus_buf = bufDescription;
	focus_inc_type = INC_TYPE_NONE;
	break;
	case ID_EDIT_START_YEAR:
	focus = hEditStartYear;
	next_focus = hEditStartMonth;
	focus_min_val = 1970;
	focus_max_val = 2050;
	focus_buf = bufStartYear;
	focus_inc_type = INC_TYPE_1;
	break;
	case ID_EDIT_START_MONTH:
	focus = hEditStartMonth;
	next_focus = hEditStartDay;
	focus_min_val = 1;
	focus_max_val = 12;
	focus_buf = bufStartMonth;
	focus_inc_type = INC_TYPE_1;
	break;
	case ID_EDIT_START_DAY:
	focus = hEditStartDay;
	if (hasEndDate(dialog_mode)){
	    next_focus = hEditEndYear;
	}else if (hasRank(dialog_mode)){
	    next_focus = hEditRank;
	}else if (dialog_mode == GENDLG_DATE){
	    next_focus = hEditStartYear;
	}
	year = atoi(bufStartYear);
	month = atoi(bufStartMonth);
	focus_min_val = 1;
	focus_max_val = Calendar_GetNumOfDays(year, month);
	focus_buf = bufStartDay;
	focus_inc_type = INC_TYPE_1;
	break;
	case ID_EDIT_END_YEAR:
	focus = hEditEndYear;
	next_focus = hEditEndMonth;
	focus_min_val = 1970;
	focus_max_val = 2050;
	focus_buf = bufEndYear;
	focus_inc_type = INC_TYPE_1;
	break;
	case ID_EDIT_END_MONTH:
	focus = hEditEndMonth;
	next_focus = hEditEndDay;
	focus_min_val = 1;
	focus_max_val = 12;
	focus_buf = bufEndMonth;
	focus_inc_type = INC_TYPE_1;
	break;
	case ID_EDIT_END_DAY:
	focus = hEditEndDay;
	if (hasTime(dialog_mode)){
	    next_focus = hEditStartHour;
	}else if (hasRepeat(dialog_mode)){
	    next_focus = hListRepeat;
	}else if (dialog_mode == GENDLG_DATE){
	    next_focus = hEditStartYear;
	}
	year = atoi(bufEndYear);
	month = atoi(bufEndMonth);
	focus_min_val = 1;
	focus_max_val = Calendar_GetNumOfDays(year, month);
	focus_buf = bufEndDay;
	focus_inc_type = INC_TYPE_1;
	break;
	case ID_EDIT_START_HOUR:
	focus = hEditStartHour;
	next_focus = hEditStartMin;
	focus_min_val = 0;
	focus_max_val = 24;
	focus_buf = bufStartHour;
	focus_inc_type = INC_TYPE_1;
	break;
	case ID_EDIT_START_MIN:
	focus = hEditStartMin;
	next_focus = hEditEndHour;
	focus_min_val = 0;
	focus_max_val = 59;
	focus_buf = bufStartMin;
	focus_inc_type = INC_TYPE_15;
	break;
	case ID_EDIT_END_HOUR:
	focus = hEditEndHour;
	next_focus = hEditEndMin;
	focus_min_val = 0;
	focus_max_val = 24;
	focus_buf = bufEndHour;
	focus_inc_type = INC_TYPE_1;
	break;
	case ID_EDIT_END_MIN:
	focus = hEditEndMin;
	next_focus = hListRepeat;
	focus_min_val = 0;
	focus_max_val = 59;
	focus_buf = bufEndMin;
	focus_inc_type = INC_TYPE_15;
	break;
	case ID_EDIT_RANK:
	focus = hEditRank;
	next_focus = hEditDescription;
	focus_min_val = 1;
	focus_max_val = 9;
	focus_buf = bufRank;
	focus_inc_type = INC_TYPE_1;
	break;
	case ID_LIST_REPEAT:
	focus = hListRepeat;
	next_focus = hEditRepeatInterval;
	focus_min_val = 0;
	focus_max_val = 0;
	focus_buf = bufRepeat;
	focus_inc_type = INC_TYPE_NONE;
	break;
	case ID_EDIT_REPEAT_INTERVAL:
	focus = hEditRepeatInterval;
	next_focus = hEditDescription;
	focus_min_val = 1;
	focus_max_val = 99;
	focus_buf = bufRepeatInterval;
	focus_inc_type = INC_TYPE_NONE;
	break;
    }
}

/* lύXꂽƂ̏ */
bool
GenDlg_ValueChanged(WPARAM id, WPARAM win)
{
    uint16 val, len;

    if (focus != win){
	D(mgDPrintf("  GenDlg_ValueChanged() -- return"));
	return false;
    }else if (focus_not_move){
	D(mgDPrintf("  GenDlg_ValueChanged() -- not check & move"));
	return false;
    }else{
	D(mgDPrintf("  GenDlg_ValueChanged() -- checking values"));
    }


    val = atoi(focus_buf);
    len = strlen(focus_buf);
    D(mgDPrintf("                        -- val = %d, len = %d", val, len));

    /* l`FbN */
    if (len == 0){
	return true;
    }
    switch (id){
	case ID_EDIT_START_YEAR:
	case ID_EDIT_END_YEAR:
	case ID_EDIT_RANK:
	if (val >= focus_min_val && val <= focus_max_val){
	    mgSetFocus(next_focus);
	}
	break;
	case ID_EDIT_START_MONTH:
	case ID_EDIT_END_MONTH:
	if (val >= 2 && val <= focus_max_val){
	    mgSetFocus(next_focus);
	}
	break;
	case ID_EDIT_START_DAY:
	case ID_EDIT_END_DAY:
	if (val >= 4 && val <= focus_max_val){
	    mgSetFocus(next_focus);
	}
	break;
	case ID_EDIT_START_HOUR:
	case ID_EDIT_END_HOUR:
	if (val == 0 || (val >= 3 && val <= focus_max_val)){
	    mgSetFocus(next_focus);
	}
	break;
	case ID_EDIT_START_MIN:
	case ID_EDIT_END_MIN:
	if (val == 0 || (val >= 6 && val <= focus_max_val)){
	    mgSetFocus(next_focus);
	}
	break;
	case ID_EDIT_REPEAT_INTERVAL:
	if (val >= 10 && val <= focus_max_val){
	    mgSetFocus(next_focus);
	}
	break;
    }
    return true;
}

/* GenDlgEBhEvV[W */
LRESULT CALLBACK
GenDlgWinProc(HWND hSelf, UINT msg,
	      WPARAM wParam, LPARAM lParam,
	      POINT LPoint, POINT DPoint)
{
    bool r;

    switch (msg){
	case WM_INITDIALOG:		      /* _CAO */
	ghGenDlgWin = hSelf;
	r = GenDlg_Create(HIWORD(lParam), LOWORD(lParam));
	if (r){
	    return 0;			      /*  */
	}else{
	    return -1;			      /* ُ */
	}
	break;

	case WM_PAINT:			      /* ĕ` */
	GenDlg_Redraw();
	return 1;
	break;

	case WM_KEYDOWN:		      /* L[R[h */
	switch (wParam){
	    case VK_KANJI:
	    if (!kanji_invalid){
		IMESTRUCT imeStruct;
		if (kanji_on){
		    kanji_on = false;
		    D(mgDPrintf("kanji off"));
		    /* IMEOFF */
		    imeStruct.fnc = IME_SETOPEN;
		    imeStruct.wParam = 0;
		    mgSendIMEMessage(ghGenDlgWin, (LPARAM)&imeStruct);
		}else{
		    kanji_on = true;
		    D(mgDPrintf("kanji on"));
		    /* IMEON */
		    imeStruct.fnc = IME_SETOPEN;
		    imeStruct.wParam = 1;
		    mgSendIMEMessage(ghGenDlgWin, (LPARAM)&imeStruct);
		}
		return 1;
	    }
	    break;

	    case VK_RETURN:
	    mgEndDialog(hSelf, true);
	    return 1;
	    break;
	}

	case UWM_KEYALLOW:		      /*  */
	if (LOBYTE(lParam) == 2 && focus_inc_type != INC_TYPE_NONE){
	    /* ω */
	    GenDlg_ChangeByAllow(true);
	    return 1;
	}else if (LOBYTE(lParam) == 4 && focus_inc_type != INC_TYPE_NONE){
	    /* ω */
	    GenDlg_ChangeByAllow(false);
	}
	break;

	case WM_COMMAND:		      /* R}h */
	switch (wParam){
	    case ID_FUNC_OK:
	    mgEndDialog(hSelf, true);
	    return 1;
	    break;

	    case ID_FUNC_CANCEL:
	    mgEndDialog(hSelf, false);
	    return 1;
	    break;

	    case ID_KEY_ESCAPE:
	    D(mgDPrintf("got ESCAPE key"));
	    mgEndDialog(hSelf, false);
	    return 1;
	    break;

	    case ID_KEY_RETURN:
	    D(mgDPrintf("got RETURN key"));
	    mgSetFocus(next_focus);
	    return 1;
	    break;
	}
	if (HIWORD(lParam) == EN_SETFOCUS){
	    D(mgDPrintf("gain focus"));
	    GenDlg_GainFocus(wParam, LOWORD(lParam));
	    return 1;
	}else if (HIWORD(lParam) == EN_KILLFOCUS){
	    D(mgDPrintf("lost focus"));
	    GenDlg_LostFocus(wParam, LOWORD(lParam));
	    return 1;
	}else if (HIWORD(lParam) == EN_CHANGE){	/* EN_UPDATE? */
	    D(mgDPrintf("value changed"));
	    GenDlg_ValueChanged(wParam, LOWORD(lParam));
	    return 1;
	}
	break;

	case WM_CLOSE:			      /* _CAȌ */
	D(mgDPrintf("got WM_CLOSE"));
	mgEndDialog(hSelf, true);
	return 0;
	break;

	case WM_DESTROY:		      /* _CAO폜 */
	r = GenDlg_Destroy();
	if (r){
	    return 0;			      /*  */
	}else{
	    return -1;			      /* ُ */
	}
	break;
    }

    /* Ȃ */
    return 0;
}
