/*
   global variables, misc functions
   Copyright (c) 1997,98 FURUKAWA Yo.
   $Id: global.h,v 1.1.1.1 1998/12/15 03:42:46 furukawa Exp $
   */

#ifndef _GLOBAL_H_
#define _GLOBAL_H_

#include "arch.h"
#include <u-k.h>

#ifdef GLOBAL
#define global 
#else
#define global extern
#endif

/* -- global macros */
#define mmax(x, y) ((x)>(y)?(x):(y))
#define mmin(x, y) ((x)<(y)?(x):(y))

#ifdef DEBUG
#define D(x) x
#else
#define D(x)
#endif

#define MODE_VIEW	1
#define MODE_ADD	2
#define MODE_APCHANGE	3
#define MODE_HELP	4
#define MODE_DIALOG	5
#define MODE_ENV	6

#define COOP_NONE	0
#define COOP_FILER	1
#define COOP_MAILER	2

#define TASK_RECORD_FILE	"D:\\DATA\\VXe\\task.rec"
#define TASK_RECORD_DIR		"D:\\DATA\\VXe\\"
#define TASK_CONTEXT_FILE	"D:\\\\task.cnt"
#define TASK_LABEL_FILE		"D:\\DATA\\VXe\\task.tag"
#define TASK_CSV_FILE		"D:\\DATA\\VXe\\task.csv"
#define TASK_ACE_FILE		"D:\\DATA\\VXe\\ace.def"

#define HELPName_Task		"\\o^\\taskmg.hlp"
#define EXEName_Task		"\\o^\\taskmg.exe"
#define EXEName_Mailer		"I:\\AP\\MAIL.EXE"
#define EXEName_Filer		"I:\\AP\\FILER.EXE"
#define EXEName_Editor		"I:\\AP\\EW.EXE"
#define CFCName_Mailer		"D:\\SYS\\taskcfcm.sys"
#define CFCName_Filer		"D:\\SYS\\taskcfcf.sys"
#define CFCName_Editor		"D:\\SYS\\taskcfce.sys"

/* -- global variables */
global HINSTANCE ghTaskInstance;
global HWND ghMainWin, ghAddWin, ghGenDlgWin, ghEnvWin;
global uint16 gTodayDate, gTodayYear, gTodayMonth, gTodayDay;
global uint16 gCursorDate, gCursorHour, gCursorHourRange;
global uint16 gMode, gCPU, gLabel, gCoopMode;
global bool gDBDirty, gDebug, gNotUpdateView;

global bool gOpt_PowerOnToday;
global bool gOpt_WeeksStartsFromMonday;
global bool gOpt_TimeTableStartsNine;
global bool gOpt_SaturdayIsHoliday;
global bool gOpt_Label1Default;
global bool gOpt_SelectItemByPageUpDown;
global bool gOpt_LargeDialog;

global char gSelectedFolder[64];
global char gSelectedFile[64+13];

#ifndef GLOBAL
global char *nameDayWeek[];
#endif

#endif
