/*
   find & jump
   Copyright (c) 1997,98 FURUKAWA Yo.
   $Id: jump.c,v 1.1.1.1 1998/12/15 03:42:47 furukawa Exp $
   */

#include "arch.h"
#include "global.h"
#include "taskid.h"
#include "taskmg.h"
#include "gendlg.h"
#include "view.h"
#include "calendar.h"
#include "record.h"
#include "index.h"
#include "db.h"
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <u-k.h>

/* -- file local macros */

/* -- file local variables */
static char findString[80];
static int findStringLen;
static uint16 findCookie = 0;

/* -- file local methods */
static bool
Jump_FindString(void);
static uint16
Jump_FindFirstOccrence(Record *rec);

/* -- methods */

/*  */
bool
Jump_Find(HWND hSelf)
{
    bool r;

    D(mgDPrintf("Jump_Find()"));

    GenDlg_SetTitle("");

    r = mgDialogBoxParam(ghTaskInstance,
			 (LPCSTR)"GenDlg",
			 hSelf,
			 (DLGPROC)GenDlgWinProc,
			 MAKELPARAM(16, GENDLG_STRING));
    if (r){
	D(mgDPrintf("Jump_Find() -- got %s", GenDlg_GetString()));
	sprintf(findString, GenDlg_GetString());
	findStringLen = strlen(findString);
    }else{
	D(mgDPrintf("Jump_Find() -- dialog failure"));
	return false;
    }

    /* T[` */
    findCookie = Index_Rewind();
    r = Jump_FindString();
    if (r){
	return true;
    }else{
	mgMessageBox(hSelf, "܂ł", MB_OK);
	findCookie = Index_Rewind();
	return false;
    }
}

/*  */
bool
Jump_FindNext(HWND hSelf)
{
    bool r;

    D(mgDPrintf("Jump_FindNext()"));

    if (strlen(findString) == 0 || findCookie == 0){
	return false;
    }

    /* T[` */
    r = Jump_FindString();
    if (r){
	return true;
    }else{
	mgMessageBox(hSelf, "܂ł", MB_OK);
	findCookie = Index_Rewind();
	return false;
    }
}

/* ČWv */
static bool
Jump_FindString(void)
{
    Record *rec;
    int i;
    uint16 date;

    while (nil != (rec = Index_FindNext(&findCookie))){
	if (rec->type == RECORD_TYPE_DELETED){
	    /* Ă郌R[h͖ */
	    continue;
	}
	if (gLabel != 0 && rec->label != 0
	    && rec->label != gLabel){
	    /* xȂ */
	    continue;
	}
	if (findStringLen > (int)rec->descript_len){
	    continue;
	}
	for (i = 0; i <= ((int)rec->descript_len - findStringLen); i++){
	    if (0 == memcmp((rec->descript)+i, findString, findStringLen)){
		/*  */
		date = Jump_FindFirstOccrence(rec);
		D(mgDPrintf("found %s (continue:%u,date:%u)",
			    findString, findCookie-1, date));
		if (date > 0){
		    View_Destroy();
		    gCursorDate = date;
		    View_Create();
		    View_Redraw();
		    return true;
		}
	    }
	}
    }

    /* Ȃ */
    return false;
}

/* ŏ̏oT */
static uint16
Jump_FindFirstOccrence(Record *rec)
{
    uint16 year, month, day, date;
    uint16 monthNo;
    uint8 dayOfWeek, dayOfWeekBit;
    uint8 nthWeek, nthWeekBit;

    /* ^XN̏ꍇ */
    if (rec->type == RECORD_TYPE_TASK){
	if (rec->done_len > 0){
	    return rec->done[0];
	}else{
	    return rec->start_date;
	}
    }

    /* JԂȂꍇ */
    if (rec->repeat_type == REPEAT_TYPE_NONE){
	return rec->start_date;
    }
    
    /* JԂꍇ */
    for (date = rec->start_date; date <= rec->end_date; date++){
	/* Kvȓt߂ */
	Calendar_GetDateByNo(date, &year, &month, &day);
	dayOfWeek = Calendar_GetDayOfWeekByNo(date);
	dayOfWeekBit = gDayOfWeekBit[dayOfWeek];
	nthWeek = (day / 7) + ((day%7)?1:0);
	nthWeekBit = gNthWeekBit[nthWeek];
	monthNo = Calendar_GetMonthNo(year, month);
	/* NOTE: 񂱂vẐ͒x */

	/* JԂĂ邩𔻒肷 */
	switch (rec->repeat_type){
	    case REPEAT_TYPE_DAILY:
	    if ((date - rec->start_date) % rec->repeat_every == 0){
		return date;
	    }
	    break;

	    case REPEAT_TYPE_WEEKLY:
	    if (((date/7 - rec->start_date/7) % rec->repeat_every == 0)
		&& (dayOfWeekBit & rec->repeat_arg1)){
		return date;
	    }
	    break;

	    case REPEAT_TYPE_MONTHLYDAY:
	    if (((monthNo - rec->start_monthNo) % rec->repeat_every == 0)
		&& (day == rec->start_day)){
		return date;
	    }
	    break;

	    case REPEAT_TYPE_MONTHLYWEEK:
	    if (((monthNo - rec->start_monthNo) % rec->repeat_every == 0)
		&& (nthWeekBit & rec->repeat_arg1)
		&& (dayOfWeekBit & rec->repeat_arg2)){
		return date;
	    }
	    break;

	    case REPEAT_TYPE_YEARLYDAY:
	    if (((monthNo/12 - rec->start_monthNo/12) % rec->repeat_every == 0)
		&& (month == rec->start_month)
		&& (day == rec->start_day)){
		return date;
	    }
	    break;

	    case REPEAT_TYPE_YEARLYWEEK:
	    if (((monthNo/12 - rec->start_monthNo/12) % rec->repeat_every == 0)
		&& (month == rec->start_month)
		&& (nthWeekBit & rec->repeat_arg1)
		&& (dayOfWeekBit & rec->repeat_arg2)){
		return date;
	    }
	    break;
	    
	    default:
	    panic("MonthRec_GetByMonthNo(): Invalid repeat attribute");
	    break;
	}
    }
	
    return 0;
    /* NOTE: month.cƂقړ */
}

/* wWv */
bool
Jump_Jump(HWND hSelf)
{
    bool r;

    D(mgDPrintf("Jump_Jump()"));

    GenDlg_SetTitle("wɃWv");

    r = mgDialogBoxParam(ghTaskInstance,
			 (LPCSTR)"GenDlg",
			 hSelf,
			 (DLGPROC)GenDlgWinProc,
			 (LPARAM)MAKELPARAM(0, GENDLG_DATE));
    if (r){
	View_Destroy();
	gCursorDate = GenDlg_GetDate();
	View_Create();
	View_Redraw();
	return true;
    }else{
	return false;
    }
}

bool
Jump_Command(HWND hSelf, WPARAM wParam, LPARAM lParam)
{
    if (HIWORD(lParam) == BN_CLICKED){
	switch (wParam){
	    case ID_FUNC_JUMP:
	    case ID_MENUITEM_JUMP:
	    Jump_Jump(hSelf);
	    return 1;
	    break;
	    case ID_FUNC_FIND:
	    case ID_MENUITEM_FIND:
	    Jump_Find(hSelf);
	    return 1;
	    break;
	    case ID_FUNC_FINDNEXT:
	    case ID_MENUITEM_FINDNEXT:
	    Jump_FindNext(hSelf);
	    return 1;
	    break;
	}
    }
}
