/*
   view
   Copyright (c) 1997,98 FURUKAWA Yo.
   $Id: view.h,v 1.1.1.1 1998/12/15 03:42:48 furukawa Exp $
   */

#ifndef _VIEW_H_
#define _VIEW_H_

#include <u-k.h>

/* -- macros */
#define VIEW_6MONTH		1
#define VIEW_3MONTH		2
#define VIEW_5WEEK		3
#define VIEW_3WEEK		4
#define VIEW_2WEEK		5
#define VIEW_WEEK_L		6
#define VIEW_WEEK_S		7
#define VIEW_DAY_L		8
#define VIEW_DAY_S		9
#define VIEW_LIST_L		10
#define VIEW_LIST_S		11
#define VIEW_BROWSER		12

#define FOCUS_CALENDAR		1
#define FOCUS_TIMETABLE		2
#define FOCUS_ITEMLIST		3
#define FOCUS_BROWSER		4

/* -- global variable */
#ifdef VIEW
int cursor_focus, cursor_prev_focus;
uint16 gCurrentView;
uint16 gCurrentViewMonth;
uint16 gCurrentViewWeeks;
uint16 gCurrentViewWeek;
uint16 gCurrentViewDay;
uint16 gCurrentViewList;
uint16 gPreviousView;
#else
extern int cursor_focus, cursor_prev_focus;
extern uint16 gCurrentView;
extern uint16 gCurrentViewMonth;
extern uint16 gCurrentViewWeeks;
extern uint16 gCurrentViewWeek;
extern uint16 gCurrentViewDay;
extern uint16 gCurrentViewList;
extern uint16 gPreviousView;
#endif

/* -- prototype */
bool
View_Create(void);
bool
View_Destroy(void);
void
View_Redraw(void);
bool
View_KeyDown(WPARAM wParam, LPARAM lParam);
bool
View_Command(HWND hSelf, WPARAM wParam, LPARAM lParam);
bool
View_Timer(void);
bool
View_SetTimer(void);
void
View_UpdateTitle(void);
bool
View_HasTimeTable(void);

#endif
