/*
   2 weeks view
   Copyright (c) 1997,98 FURUKAWA Yo.
   $Id: view2w.c,v 1.1.1.1 1998/12/15 03:42:48 furukawa Exp $
   */

#include "arch.h"
#include "global.h"
#include "calendar.h"
#include "month.h"
#include "taskmg.h"
#include "taskid.h"
#include "view.h"
#include "view2w.h"
#include "viewitem.h"
#include "viewcal.h"
#include "additem.h"
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <u-k.h>

/* -- file local macros */
#define DAYCELL_ROWS		2
#define DAYCELL_COLS		7
#define DAYCELL_WIDTH		(16*5+11)
#define DAYCELL_HEIGHT		(16*5+11)
#define ITEM_PER_DAY		4

#define REGION_DAYWEEK_WIDTH	(DAYCELL_WIDTH*DAYCELL_COLS)
#define REGION_DAYWEEK_HEIGHT	(16*1+3)
#define REGION_WEEKS_WIDTH	(DAYCELL_WIDTH*DAYCELL_COLS)
#define REGION_WEEKS_HEIGHT	(DAYCELL_HEIGHT*DAYCELL_ROWS)

/* -- file local variables */

/* -- file local methods */

/* -- methods */

/* View2W */
bool
View2W_Create(void)
{
    D(mgDPrintf("View2W create\n"));

    /* ViewŗL̕ϐ */
    cursor_focus = FOCUS_CALENDAR;
    cursor_prev_focus = FOCUS_CALENDAR;
    ViewItem_InitCursor();
    ViewCal_Init(REGION_USER_LEFT, REGION_USER_TOP,
		 REGION_DAYWEEK_WIDTH, REGION_DAYWEEK_HEIGHT,
		 REGION_WEEKS_WIDTH, REGION_WEEKS_HEIGHT,
		 DAYCELL_WIDTH, DAYCELL_HEIGHT,
		 DAYCELL_COLS, DAYCELL_ROWS,
		 ITEM_PER_DAY,
		 F16_FNT, 10);
    ViewCal_InitCursor();

    return true;
}

/* View2WЕt */
bool
View2W_Destroy(void)
{
    D(mgDPrintf("View2W destroy\n"));
    return true;
}

/* View2Wĕ` */
void
View2W_Redraw(void)
{
    HDC hDC;
    PAINTSTRUCT ps;

    hDC = mgBeginPaint(ghMainWin, (LPPAINTSTRUCT)&ps);
    ViewCalDayWeek_Redraw(hDC);
    ViewCalWeeks_Redraw(hDC);
    ViewCal_InvertCursor(hDC);		      /* ON */
    mgEndPaint(ghMainWin, (LPPAINTSTRUCT)&ps);
}

/* View2Wxĕ` */
void
View2W_DelayedRedraw(void)
{
    /* NOTHING TO DO */
}

/* L[R[h */
bool
View2W_KeyDown(WPARAM wParam, LPARAM lParam)
{
    HDC hDC;
    PAINTSTRUCT ps;

    switch (wParam){
	case VK_LEFT:			      /*  */
	case UVK_LEFT:			      /*  */
	hDC = mgBeginPaint(ghMainWin, (LPPAINTSTRUCT)&ps);
	ViewCal_InvertCursor(hDC);	      /* OFF */
	ViewCal_Left(hDC);
	ViewCal_InvertCursor(hDC);	      /* ON */
	mgEndPaint(ghMainWin, (LPPAINTSTRUCT)&ps);
	/* xAbvf[g */
	View_SetTimer();
	break;

	case VK_RIGHT:			      /* E */
	case UVK_RIGHT:			      /* E */
	hDC = mgBeginPaint(ghMainWin, (LPPAINTSTRUCT)&ps);
	ViewCal_InvertCursor(hDC);	      /* OFF */
	ViewCal_Right(hDC);
	ViewCal_InvertCursor(hDC);	      /* ON */
	mgEndPaint(ghMainWin, (LPPAINTSTRUCT)&ps);
	/* xAbvf[g */
	View_SetTimer();
	break;

	case VK_UP:			      /*  */
	case UVK_UP:			      /*  */
	hDC = mgBeginPaint(ghMainWin, (LPPAINTSTRUCT)&ps);
	ViewCal_InvertCursor(hDC);	      /* OFF */
	ViewCal_Up(hDC);
	ViewCal_InvertCursor(hDC);	      /* ON */
	mgEndPaint(ghMainWin, (LPPAINTSTRUCT)&ps);
	/* xAbvf[g */
	View_SetTimer();
	break;

	case VK_DOWN:			      /*  */
	case UVK_DOWN:			      /*  */
	hDC = mgBeginPaint(ghMainWin, (LPPAINTSTRUCT)&ps);
	ViewCal_InvertCursor(hDC);	      /* OFF */
	ViewCal_Down(hDC);
	ViewCal_InvertCursor(hDC);	      /* ON */
	mgEndPaint(ghMainWin, (LPPAINTSTRUCT)&ps);
	/* xAbvf[g */
	View_SetTimer();
	break;

	case VK_PRIOR:			      /* O */
	hDC = mgBeginPaint(ghMainWin, (LPPAINTSTRUCT)&ps);
	ViewCal_WeekUp(hDC, 2);
	ViewCal_InvertCursor(hDC);	      /* ON */
	mgEndPaint(ghMainWin, (LPPAINTSTRUCT)&ps);
	/* xAbvf[g */
	View_SetTimer();
	break;

	case VK_NEXT:			      /*  */
	hDC = mgBeginPaint(ghMainWin, (LPPAINTSTRUCT)&ps);
	ViewCal_WeekDown(hDC, 2);
	ViewCal_InvertCursor(hDC);	      /* ON */
	mgEndPaint(ghMainWin, (LPPAINTSTRUCT)&ps);
	/* xAbvf[g */
	View_SetTimer();
	break;

	default:
	/* Ȃ */
	return false;
	break;
    }

    /*  */
    return true;
}

/* R}h */
bool
View2W_Command(WPARAM wParam, LPARAM lParam)
{
    switch (wParam){
	case ID_FUNC_NOW:
	if (HIWORD(lParam) == BN_CLICKED){
	    ViewCal_InitCursor();
	    View_Redraw();
	}else{
	    return false;
	}
	break;

	default:
	/* Ȃ */
	return false;
	break;
    }

    /*  */
    return true;
}
