/*
   3 weeks view
   Copyright (c) 1997,98 FURUKAWA Yo.
   $Id: view3w.c,v 1.1.1.1 1998/12/15 03:42:48 furukawa Exp $
   */

#include "arch.h"
#include "global.h"
#include "calendar.h"
#include "month.h"
#include "taskmg.h"
#include "taskid.h"
#include "view.h"
#include "view3w.h"
#include "viewitem.h"
#include "viewcal.h"
#include "additem.h"
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <u-k.h>

/* -- file local macros */
#define DAYCELL_ROWS		3
#define DAYCELL_COLS		7
#define DAYCELL_WIDTH		(12*5+2+2)
#define DAYCELL_HEIGHT		(12*5+2)
#define ITEM_PER_DAY		4

#define REGION_DAYWEEK_WIDTH	(DAYCELL_WIDTH*DAYCELL_COLS)
#define REGION_DAYWEEK_HEIGHT	(12*1+3)
#define REGION_WEEKS_WIDTH	(DAYCELL_WIDTH*DAYCELL_COLS)
#define REGION_WEEKS_HEIGHT	(DAYCELL_HEIGHT*DAYCELL_ROWS)

#define ITEMCELL_ROWS		12
#define ITEMCELL_COLS		1
#define ITEMCELL_WIDTH		(REGION_USER_WIDTH-REGION_WEEKS_WIDTH-1)
#define ITEMCELL_HEIGHT		(12+3)

#define REGION_DATE_WIDTH	(ITEMCELL_WIDTH)
#define REGION_DATE_HEIGHT	(16*1+5)
#define REGION_DATE_LEFT	(REGION_WEEKS_WIDTH+1)
#define REGION_DATE_TOP		(REGION_USER_TOP)
#define REGION_ITEMS_WIDTH	(ITEMCELL_WIDTH*ITEMCELL_COLS)
#define REGION_ITEMS_HEIGHT	(ITEMCELL_HEIGHT*ITEMCELL_ROWS)

/* -- file local variables */

/* -- file local methods */

/* -- methods */

/* View3W */
bool
View3W_Create(void)
{
    D(mgDPrintf("View3W create\n"));

    /* ViewŗL̕ϐ */
    cursor_focus = FOCUS_CALENDAR;
    cursor_prev_focus = FOCUS_CALENDAR;
    ViewItem_Init(REGION_DATE_LEFT, REGION_DATE_TOP,
		  REGION_DATE_WIDTH, REGION_DATE_HEIGHT,
		  REGION_ITEMS_WIDTH, REGION_ITEMS_HEIGHT,
		  ITEMCELL_WIDTH, ITEMCELL_HEIGHT,
		  ITEMCELL_COLS, ITEMCELL_ROWS,
		  F12_FNT, 7+24);
    ViewItem_InitCursor();
    ViewCal_Init(REGION_USER_LEFT, REGION_USER_TOP,
		 REGION_DAYWEEK_WIDTH, REGION_DAYWEEK_HEIGHT,
		 REGION_WEEKS_WIDTH, REGION_WEEKS_HEIGHT,
		 DAYCELL_WIDTH, DAYCELL_HEIGHT,
		 DAYCELL_COLS, DAYCELL_ROWS,
		 ITEM_PER_DAY,
		 F12_FNT, 10);
    ViewCal_InitCursor();

    return true;
}

/* View3WЕt */
bool
View3W_Destroy(void)
{
    D(mgDPrintf("View3W destroy\n"));
    return true;
}

/* View3Wĕ` */
void
View3W_Redraw(void)
{
    HDC hDC;
    PAINTSTRUCT ps;

    hDC = mgBeginPaint(ghMainWin, (LPPAINTSTRUCT)&ps);

    /*  */
    mgSelectStockObject(hDC, CL_BLACK|SOLID_PEN|SIZE1_PEN);
    mgMoveTo(hDC, REGION_USER_LEFT+REGION_DAYWEEK_WIDTH, REGION_USER_TOP);
    mgLineTo(hDC, REGION_USER_LEFT+REGION_DAYWEEK_WIDTH, REGION_USER_BOTTOM);

    ViewCalDayWeek_Redraw(hDC);
    ViewCalWeeks_Redraw(hDC);
    ViewItemDate_Redraw(hDC);
    ViewItem_Redraw(hDC);
    ViewCal_InvertCursor(hDC);		      /* ON */
    if (cursor_focus == FOCUS_ITEMLIST)
	ViewItem_InvertCursor(hDC);	      /* ON */
    mgEndPaint(ghMainWin, (LPPAINTSTRUCT)&ps);
}

/* View3Wxĕ` */
void
View3W_DelayedRedraw(void)
{
    HDC hDC;
    PAINTSTRUCT ps;

    hDC = mgBeginPaint(ghMainWin, (LPPAINTSTRUCT)&ps);
    ViewItemDate_Redraw(hDC);
    ViewItem_Redraw(hDC);
    if (cursor_focus == FOCUS_ITEMLIST)
	ViewItem_InvertCursor(hDC);
    mgEndPaint(ghMainWin, (LPPAINTSTRUCT)&ps);
}

/* L[R[h */
bool
View3W_KeyDown(WPARAM wParam, LPARAM lParam)
{
    HDC hDC;
    PAINTSTRUCT ps;

    switch (wParam){
	case VK_LEFT:			      /*  */
	case UVK_LEFT:			      /*  */
	hDC = mgBeginPaint(ghMainWin, (LPPAINTSTRUCT)&ps);
	ViewCal_InvertCursor(hDC);	      /* OFF */
	ViewCal_Left(hDC);
	ViewCal_InvertCursor(hDC);	      /* ON */
	/* tH[JXACeXgɈړ */
	if (cursor_focus == FOCUS_ITEMLIST){
	    ViewItem_InitCursor();
	    cursor_focus = FOCUS_CALENDAR;
	}
	mgEndPaint(ghMainWin, (LPPAINTSTRUCT)&ps);
	/* xAbvf[g */
	View_SetTimer();
	break;

	case VK_RIGHT:			      /* E */
	case UVK_RIGHT:			      /* E */
	hDC = mgBeginPaint(ghMainWin, (LPPAINTSTRUCT)&ps);
	ViewCal_InvertCursor(hDC);	      /* OFF */
	ViewCal_Right(hDC);
	ViewCal_InvertCursor(hDC);	      /* ON */
	/* tH[JXACeXgɈړ */
	if (cursor_focus == FOCUS_ITEMLIST){
	    ViewItem_InitCursor();
	    cursor_focus = FOCUS_CALENDAR;
	}
	mgEndPaint(ghMainWin, (LPPAINTSTRUCT)&ps);
	/* xAbvf[g */
	View_SetTimer();
	break;

	case VK_UP:			      /*  */
	case UVK_UP:			      /*  */
	hDC = mgBeginPaint(ghMainWin, (LPPAINTSTRUCT)&ps);
	ViewCal_InvertCursor(hDC);	      /* OFF */
	ViewCal_Up(hDC);
	ViewCal_InvertCursor(hDC);	      /* ON */
	mgEndPaint(ghMainWin, (LPPAINTSTRUCT)&ps);
	/* tH[JXACeXgɈړ */
	if (cursor_focus == FOCUS_ITEMLIST){
	    ViewItem_InitCursor();
	    cursor_focus = FOCUS_CALENDAR;
	}
	/* xAbvf[g */
	View_SetTimer();
	break;

	case VK_DOWN:			      /*  */
	case UVK_DOWN:			      /*  */
	hDC = mgBeginPaint(ghMainWin, (LPPAINTSTRUCT)&ps);
	ViewCal_InvertCursor(hDC);	      /* OFF */
	ViewCal_Down(hDC);
	ViewCal_InvertCursor(hDC);	      /* ON */
	mgEndPaint(ghMainWin, (LPPAINTSTRUCT)&ps);
	/* tH[JXACeXgɈړ */
	if (cursor_focus == FOCUS_ITEMLIST){
	    ViewItem_InitCursor();
	    cursor_focus = FOCUS_CALENDAR;
	}
	/* xAbvf[g */
	View_SetTimer();
	break;

	case VK_PRIOR:			      /* O */
	hDC = mgBeginPaint(ghMainWin, (LPPAINTSTRUCT)&ps);
	ViewCal_WeekUp(hDC, 3);
	ViewCal_InvertCursor(hDC);	      /* ON */
	mgEndPaint(ghMainWin, (LPPAINTSTRUCT)&ps);
	/* tH[JXACeXgɈړ */
	if (cursor_focus == FOCUS_ITEMLIST){
	    ViewItem_InitCursor();
	    cursor_focus = FOCUS_CALENDAR;
	}
	/* xAbvf[g */
	View_SetTimer();
	break;

	case VK_NEXT:			      /*  */
	hDC = mgBeginPaint(ghMainWin, (LPPAINTSTRUCT)&ps);
	ViewCal_WeekDown(hDC, 3);
	ViewCal_InvertCursor(hDC);	      /* ON */
	mgEndPaint(ghMainWin, (LPPAINTSTRUCT)&ps);
	/* tH[JXACeXgɈړ */
	if (cursor_focus == FOCUS_ITEMLIST){
	    ViewItem_InitCursor();
	    cursor_focus = FOCUS_CALENDAR;
	}
	/* xAbvf[g */
	View_SetTimer();
	break;

	case UVK_ITEMUP:		      /* ACe */
	hDC = mgBeginPaint(ghMainWin, (LPPAINTSTRUCT)&ps);
	if (cursor_focus == FOCUS_CALENDAR){
	    D(mgDPrintf("focus ITEMLIST"));
	    ViewItem_InvertCursor(hDC);     /* ON */
	    cursor_focus = FOCUS_ITEMLIST;
	}else{
	    ViewItem_InvertCursor(hDC);     /* OFF */
	    ViewItem_Up(hDC);
	    ViewItem_InvertCursor(hDC);     /* ON */
	}
	mgEndPaint(ghMainWin, (LPPAINTSTRUCT)&ps);
	break;

	case UVK_ITEMDOWN:		      /* ACe */
	hDC = mgBeginPaint(ghMainWin, (LPPAINTSTRUCT)&ps);
	if (cursor_focus == FOCUS_CALENDAR){
	    D(mgDPrintf("focus ITEMLIST"));
	    ViewItem_InvertCursor(hDC);     /* ON */
	    cursor_focus = FOCUS_ITEMLIST;
	}else{
	    ViewItem_InvertCursor(hDC);     /* OFF */
	    ViewItem_Down(hDC);
	    ViewItem_InvertCursor(hDC);     /* ON */
	}
	mgEndPaint(ghMainWin, (LPPAINTSTRUCT)&ps);
	break;

	default:
	/* Ȃ */
	return false;
	break;
    }

    /*  */
    return true;
}

/* R}h */
bool
View3W_Command(WPARAM wParam, LPARAM lParam)
{
    switch (wParam){
	case ID_FUNC_NOW:
	if (HIWORD(lParam) == BN_CLICKED){
	    ViewCal_InitCursor();
	    View_Redraw();
	}else{
	    return false;
	}
	break;

	default:
	/* Ȃ */
	return false;
	break;
    }

    /*  */
    return true;
}
