/*
   general dialog
   Copyright (c) 1997,98 FURUKAWA Yo.
   $Id: gendlg.h,v 1.2 1998/12/27 16:26:21 furukawa Exp $
   */

#ifndef _GENDLG_H_
#define _GENDLG_H_

#include "calendar.h"

/* -- global macro */
#ifdef GENDLG
#define gendlg_local
#else
#define gendlg_local extern
#endif

#define ADDITEM_TASK		1
#define ADDITEM_DEADLINE	2
#define ADDITEM_SCHEDULE	3
#define ADDITEM_CONTACT		4
#define ADDITEM_HOLIDAY		5
#define EDITITEM_TASK		6
#define EDITITEM_DEADLINE	7
#define EDITITEM_SCHEDULE	8
#define EDITITEM_CONTACT	9
#define EDITITEM_HOLIDAY	10
#define GENDLG_NONE		11
#define GENDLG_STRING		12
#define GENDLG_DATE		13

#define INC_TYPE_NONE	0
#define INC_TYPE_1	1
#define INC_TYPE_15	2

#define hasEndDate(x) ((x) == ADDITEM_SCHEDULE || (x) == EDITITEM_SCHEDULE || (x) == ADDITEM_HOLIDAY || (x) == EDITITEM_HOLIDAY)
#define hasTime(x) ((x) == ADDITEM_SCHEDULE || (x) == EDITITEM_SCHEDULE)
#define hasRank(x) ((x) == ADDITEM_TASK || (x) == EDITITEM_TASK)
#define hasRepeat(x) ((x) == ADDITEM_SCHEDULE || (x) == EDITITEM_SCHEDULE || (x) == ADDITEM_HOLIDAY || (x) == EDITITEM_HOLIDAY)
#define isAddMode(x) ((x) == ADDITEM_SCHEDULE || (x) == ADDITEM_TASK || (x) == ADDITEM_HOLIDAY)
#define isEditMode(x) ((x) == EDITITEM_SCHEDULE || (x) == EDITITEM_TASK || (x) == EDITITEM_HOLIDAY)

#define getStartDateByBuf() (Calendar_GetDayNo(atoi(bufStartYear), atoi(bufStartMonth), atoi(bufStartDay)))
#define getEndDateByBuf() (Calendar_GetDayNo(atoi(bufEndYear), atoi(bufEndMonth), atoi(bufEndDay)))

/* -- global variable */

gendlg_local mnwDialog gGenDialog;

/* ȥ */
gendlg_local mnwEdit gEditStartYear;
gendlg_local mnwEdit gEditStartMonth;
gendlg_local mnwEdit gEditStartDay;
gendlg_local mnwEdit gEditStartHour;
gendlg_local mnwEdit gEditStartMin;
gendlg_local mnwEdit gEditEndYear;
gendlg_local mnwEdit gEditEndMonth;
gendlg_local mnwEdit gEditEndDay;
gendlg_local mnwEdit gEditEndHour;
gendlg_local mnwEdit gEditEndMin;
gendlg_local mnwEdit gEditDescription;
gendlg_local mnwEdit gEditRank;
gendlg_local mnwLabel gLabelStartDayWeek;
gendlg_local mnwLabel gLabelEndDayWeek;
gendlg_local mnwList gListRepeat;
gendlg_local mnwEdit gEditRepeatInterval;
gendlg_local mnwLabel gLabelLabel;

/* Хåե */
#define BUF_GENERIC_LEN		(2048-1)
#define BUF_DESCRIPTION_LEN	(2048-1)
#define BUF_START_YEAR_LEN	4
#define BUF_START_MONTH_LEN	2
#define BUF_START_DAY_LEN	2
#define BUF_START_HOUR_LEN	2
#define BUF_START_MIN_LEN	2
#define BUF_START_DAYWEEK_LEN	2
#define BUF_END_YEAR_LEN	4
#define BUF_END_MONTH_LEN	2
#define BUF_END_DAY_LEN		2
#define BUF_END_HOUR_LEN	2
#define BUF_END_MIN_LEN		2
#define BUF_END_DAYWEEK_LEN	2
#define BUF_RANK_LEN		1
#define BUF_REPEAT_LEN		256
#define BUF_REPEAT_INTERVAL_LEN	2
#define BUF_LABEL_LEN		8
gendlg_local char bufGeneric[BUF_GENERIC_LEN+1];
gendlg_local char bufDescription[BUF_DESCRIPTION_LEN+1];
gendlg_local char bufStartYear[BUF_START_YEAR_LEN+1];
gendlg_local char bufStartMonth[BUF_START_MONTH_LEN+1];
gendlg_local char bufStartDay[BUF_START_DAY_LEN+1];
gendlg_local char bufStartHour[BUF_START_HOUR_LEN+1];
gendlg_local char bufStartMin[BUF_START_MIN_LEN+1];
gendlg_local char bufStartDayWeek[BUF_START_DAYWEEK_LEN+1];
gendlg_local char bufEndYear[BUF_END_YEAR_LEN+1];
gendlg_local char bufEndMonth[BUF_END_MONTH_LEN+1];
gendlg_local char bufEndDay[BUF_END_DAY_LEN+1];
gendlg_local char bufEndHour[BUF_END_HOUR_LEN+1];
gendlg_local char bufEndMin[BUF_END_MIN_LEN+1];
gendlg_local char bufEndDayWeek[BUF_END_DAYWEEK_LEN+1];
gendlg_local char bufRank[BUF_RANK_LEN+1];
gendlg_local char bufRepeat[BUF_REPEAT_LEN+1];
gendlg_local char bufRepeatInterval[BUF_REPEAT_INTERVAL_LEN+1];
gendlg_local char bufLabel[BUF_LABEL_LEN+1];

/* ѿ */
gendlg_local int16 dialog_mode;
gendlg_local bool value_invalid;
gendlg_local bool kanji_invalid, kanji_on;
gendlg_local uint16 focus_min_val, focus_max_val;
gendlg_local char *focus_buf;
gendlg_local uint16 focus_inc_type;
gendlg_local bool focus_not_move;
gendlg_local mnwWindow *focus, *next_focus, *should_focus;

/* -- prototype */
void
GenDlg_SetTitle(char *title);
void
GenDlg_SetMode(int mode);
void
GenDlg_SetString(char *str);
char *
GenDlg_GetString(void);
uint16
GenDlg_GetDate(void);
void
GenDlg_InitEditControl(mnwEdit *win, char *buf, uint16 size, char *init_str);
void
GenDlg_ResetControl(mnwEdit *win, char *buf);
bool
GenDlg_ChangeByArrow(bool inc);
bool
GenDlg_CheckValueRange(mnwEdit *win);
bool
GenDlg_GainFocus(mnwWindow *win);
void
GenDlg_MoveFocus(int id);
bool
GenDlg_ValueChanged(mnwWindow *win);
bool
GenDlg_Callback(mnwDialog *self, mnwEvent *event);

#endif
