/*
   2 weeks view
   Copyright (c) 1997,98 FURUKAWA Yo.
   $Id: view2w.c,v 1.2 1998/12/27 16:26:22 furukawa Exp $
   */

#include "global.h"
#include "taskmg.h"
#include "taskid.h"
#include "view.h"
#include "view2w.h"
#include "viewcal.h"
#include "viewitem.h"
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

/* -- file local macros */
#define DAYCELL_ROWS		2
#define DAYCELL_COLS		7
#define DAYCELL_WIDTH		(16*5+11)
#define DAYCELL_HEIGHT		(16*5+11)
#define ITEM_PER_DAY		4

#define REGION_DAYWEEK_WIDTH	(DAYCELL_WIDTH*DAYCELL_COLS)
#define REGION_DAYWEEK_HEIGHT	(16*1+3)
#define REGION_WEEKS_WIDTH	(DAYCELL_WIDTH*DAYCELL_COLS)
#define REGION_WEEKS_HEIGHT	(DAYCELL_HEIGHT*DAYCELL_ROWS)

/* -- file local variables */

/* -- file local methods */

/* -- methods */

/* View2W */
bool
View2W_Create(void)
{
    D(mnwDPrintf("View2W create\n"));

    /* Viewͭѿ */
    cursor_focus = FOCUS_CALENDAR;
    cursor_prev_focus = FOCUS_CALENDAR;
    ViewItem_InitCursor();
    ViewCal_Init(REGION_USER_LEFT, REGION_USER_TOP,
		 REGION_DAYWEEK_WIDTH, REGION_DAYWEEK_HEIGHT,
		 REGION_WEEKS_WIDTH, REGION_WEEKS_HEIGHT,
		 DAYCELL_WIDTH, DAYCELL_HEIGHT,
		 DAYCELL_COLS, DAYCELL_ROWS,
		 ITEM_PER_DAY,
		 kFont_16, 10);
    ViewCal_InitCursor();

    return true;
}

/* View2Wդ */
bool
View2W_Destroy(void)
{
    D(mnwDPrintf("View2W destroy\n"));
    return true;
}

/* View2W */
void
View2W_Redraw(void)
{
    ViewCalDayWeek_Redraw();
    ViewCalWeeks_Redraw();
    ViewCal_InvertCursor();		      /* ON */
}

/* View2Wٱ */
void
View2W_DelayedRedraw(void)
{
    /* NOTHING TO DO */
}

/* ɽ */
bool
View2W_KeyDown(mnwEvent *event)
{
    switch (event->param1){
	case kKey_LEFT:			      /*  */
	case kUKey_LEFT:		      /*  */
	ViewCal_InvertCursor();		      /* OFF */
	ViewCal_Left();
	ViewCal_InvertCursor();		      /* ON */
	/* ٱ䥢åץǡ */
	View_SetTimer();
	break;

	case kKey_RIGHT:		      /*  */
	case kUKey_RIGHT:		      /*  */
	ViewCal_InvertCursor();		      /* OFF */
	ViewCal_Right();
	ViewCal_InvertCursor();		      /* ON */
	/* ٱ䥢åץǡ */
	View_SetTimer();
	break;

	case kKey_UP:			      /*  */
	case kUKey_UP:			      /*  */
	ViewCal_InvertCursor();		      /* OFF */
	ViewCal_Up();
	ViewCal_InvertCursor();		      /* ON */
	/* ٱ䥢åץǡ */
	View_SetTimer();
	break;

	case kKey_DOWN:			      /*  */
	case kUKey_DOWN:		      /*  */
	ViewCal_InvertCursor();		      /* OFF */
	ViewCal_Down();
	ViewCal_InvertCursor();		      /* ON */
	/* ٱ䥢åץǡ */
	View_SetTimer();
	break;

	case kKey_PRIOR:		      /*  */
	ViewCal_WeekUp(2);
	ViewCal_InvertCursor();		      /* ON */
	/* ٱ䥢åץǡ */
	View_SetTimer();
	break;

	case kKey_NEXT:			      /*  */
	ViewCal_WeekDown(2);
	ViewCal_InvertCursor();		      /* ON */
	/* ٱ䥢åץǡ */
	View_SetTimer();
	break;

	default:
	/* ʤ */
	return false;
	break;
    }

    /*  */
    return true;
}

/* ޥɽ */
bool
View2W_Command(mnwEvent *event)
{
    switch (event->param1){
	case ID_FUNC_NOW:
	ViewCal_InitCursor();
	View_Redraw();
	break;

	default:
	/* ʤ */
	return false;
	break;
    }

    /*  */
    return true;
}
