/*
   week view (small size)
   Copyright (c) 1997,98 FURUKAWA Yo.
   $Id: viewws.c,v 1.2 1999/02/01 04:51:07 furukawa Exp $
   */

#include "global.h"
#include "calendar.h"
#include "month.h"
#include "taskmg.h"
#include "taskid.h"
#include "view.h"
#include "viewws.h"
#include "viewitem.h"
#include "viewtime.h"
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

/* -- file local macros */
#define HOURCELL_ROWS		10
#define HOURCELL_COLS		7
#define HOURCELL_WIDTH		(12*5+3)
#define HOURCELL_HEIGHT		(12*1+1)
#define ITEM_PER_DAY		4

#define REGION_HOUR_WIDTH	(6*5+2)
#define REGION_HOUR_HEIGHT	(HOURCELL_HEIGHT*HOURCELL_ROWS)
#define REGION_DAYWEEK_WIDTH	(HOURCELL_WIDTH*HOURCELL_COLS)
#define REGION_DAYWEEK_HEIGHT	(12*1+3)
#define REGION_TIMETABLE_WIDTH	(HOURCELL_WIDTH*HOURCELL_COLS)
#define REGION_TIMETABLE_HEIGHT	(HOURCELL_HEIGHT*HOURCELL_ROWS)
#define REGION_DAY_WIDTH	(HOURCELL_WIDTH*HOURCELL_COLS)
#define REGION_DAY_HEIGHT	(56)

#define ITEMCELL_ROWS		12
#define ITEMCELL_COLS		1
#define ITEMCELL_WIDTH		(REGION_USER_WIDTH-REGION_HOUR_WIDTH-REGION_DAYWEEK_WIDTH-1)
#define ITEMCELL_HEIGHT		(12+3)

#define REGION_DATE_WIDTH	(ITEMCELL_WIDTH)
#define REGION_DATE_HEIGHT	(16*1+5)
#define REGION_DATE_LEFT	(REGION_USER_LEFT+REGION_HOUR_WIDTH+REGION_DAYWEEK_WIDTH+1)
#define REGION_DATE_TOP		(REGION_USER_TOP)
#define REGION_ITEMS_WIDTH	(ITEMCELL_WIDTH)
#define REGION_ITEMS_HEIGHT	(ITEMCELL_HEIGHT*ITEMCELL_ROWS)

/* -- file local variables */

/* -- file local methods */

/* -- methods */

/* ViewWS */
bool
ViewWS_Create(void)
{
    D(mnwDPrintf("ViewWS create\n"));

    /* Viewͭѿ */
    cursor_focus = FOCUS_TIMETABLE;
    cursor_prev_focus = FOCUS_TIMETABLE;
    ViewItem_Init(REGION_DATE_LEFT, REGION_DATE_TOP,
		  REGION_DATE_WIDTH, REGION_DATE_HEIGHT,
		  REGION_ITEMS_WIDTH, REGION_ITEMS_HEIGHT,
		  ITEMCELL_WIDTH, ITEMCELL_HEIGHT,
		  ITEMCELL_COLS, ITEMCELL_ROWS,
		  kFont_12, 7+20, false);
    ViewItem_InitCursor();
    ViewTime_Init(REGION_USER_LEFT, REGION_USER_TOP,
		  REGION_HOUR_WIDTH, REGION_HOUR_HEIGHT,
		  REGION_DAYWEEK_WIDTH, REGION_DAYWEEK_HEIGHT,
		  REGION_TIMETABLE_WIDTH, REGION_TIMETABLE_HEIGHT,
		  REGION_DAY_WIDTH, REGION_DAY_HEIGHT,
		  HOURCELL_WIDTH, HOURCELL_HEIGHT,
		  HOURCELL_COLS, HOURCELL_ROWS,
		  ITEM_PER_DAY,
		  kFont_12, 10);
    ViewTime_InitCursor();

    return true;
}

/* ViewWSդ */
bool
ViewWS_Destroy(void)
{
    D(mnwDPrintf("ViewWS destroy\n"));
    return true;
}

/* ViewWS */
void
ViewWS_Redraw(void)
{
    /*  */
    mnwSetForeColor(kColor_Black);
    mnwDrawLine(REGION_USER_LEFT+REGION_HOUR_WIDTH+REGION_DAYWEEK_WIDTH,
		REGION_USER_TOP,
		REGION_USER_LEFT+REGION_HOUR_WIDTH+REGION_DAYWEEK_WIDTH,
		REGION_USER_BOTTOM);

    ViewTimeHour_Redraw();
    ViewTimeWeek_Redraw();
    ViewItemDate_Redraw();
    ViewItem_Redraw();
    ViewTime_InvertCursor();		      /* ON */
    if (cursor_focus == FOCUS_ITEMLIST)
	ViewItem_InvertCursor();	      /* ON */
}

/* ViewWSٱ */
void
ViewWS_DelayedRedraw(void)
{
    ViewItemDate_Redraw();
    ViewItem_Redraw();
    if (cursor_focus == FOCUS_ITEMLIST)
	ViewItem_InvertCursor();
}

/* ɽ */
bool
ViewWS_KeyDown(mnwEvent *event)
{
    switch (event->param1){
	case kKey_LEFT:			      /*  */
	case kUKey_LEFT:		      /*  */
	ViewTime_InvertCursor();	      /* OFF */
	gCursorDate--;
	/* 򥫡򸵤 */
	if (gCursorHourRange > 1){
	    gCursorHour = gCursorHour + gCursorHourRange - 1;
	    gCursorHourRange = 1;
	}
	ViewTime_Left();
	ViewTime_InvertCursor();	      /* ON */
	/* ե򥿥ơ֥˰ư */
	if (cursor_focus == FOCUS_ITEMLIST){
	    ViewItem_InitCursor();
	    cursor_focus = FOCUS_TIMETABLE;
	}
	/* ٱ䥢åץǡ */
	View_SetTimer();
	break;

	case kKey_RIGHT:		      /*  */
	case kUKey_RIGHT:		      /*  */
	ViewTime_InvertCursor();	      /* OFF */
	gCursorDate++;
	/* 򥫡򸵤 */
	if (gCursorHourRange > 1){
	    gCursorHour = gCursorHour + gCursorHourRange - 1;
	    gCursorHourRange = 1;
	}
	ViewTime_Right();
	ViewTime_InvertCursor();	      /* ON */
	/* ե򥿥ơ֥˰ư */
	if (cursor_focus == FOCUS_ITEMLIST){
	    ViewItem_InitCursor();
	    cursor_focus = FOCUS_TIMETABLE;
	}
	/* ٱ䥢åץǡ */
	View_SetTimer();
	break;

	case kKey_PRIOR:		      /*  */
	/* 򥫡򸵤 */
	if (gCursorHourRange > 1){
	    gCursorHour = gCursorHour + gCursorHourRange - 1;
	    gCursorHourRange = 1;
	}
	ViewTime_WeekUp();
	ViewTime_InvertCursor();	      /* ON */
	/* ٱ䥢åץǡ */
	View_SetTimer();
	break;

	case kKey_NEXT:			      /*  */
	/* 򥫡򸵤 */
	if (gCursorHourRange > 1){
	    gCursorHour = gCursorHour + gCursorHourRange - 1;
	    gCursorHourRange = 1;
	}
	ViewTime_WeekDown();
	ViewTime_InvertCursor();	      /* ON */
	/* ٱ䥢åץǡ */
	View_SetTimer();
	break;

	case kKey_UP:			      /*  */
	case kUKey_UP:			      /*  */
	ViewTime_InvertCursor();	      /* OFF */
	/* 򥫡򸵤 */
	if (gCursorHourRange > 1){
	    gCursorHour = gCursorHour + gCursorHourRange - 1;
	    gCursorHourRange = 1;
	}
	/* ư */
	if (gCursorHour > 0){
	    gCursorHour--;
	}
	ViewTime_Up();
	ViewTime_InvertCursor();	      /* ON */
	/* ե򥢥ƥꥹȤ˰ư */
	if (cursor_focus == FOCUS_ITEMLIST){
	    ViewItem_InvertCursor();
	    ViewItem_InitCursor();
	    cursor_focus = FOCUS_TIMETABLE;
	}
	break;

	case kKey_DOWN:			      /*  */
	case kUKey_DOWN:		      /*  */
	ViewTime_InvertCursor();	      /* OFF */
	/* 򥫡򸵤 */
	if (gCursorHourRange > 1){
	    gCursorHour = gCursorHour + gCursorHourRange - 1;
	    gCursorHourRange = 1;
	}
	/* ư */
	if (gCursorHour < 23){
	    gCursorHour++;
	}
	ViewTime_Down();
	ViewTime_InvertCursor();	      /* ON */
	/* ե򥢥ƥꥹȤ˰ư */
	if (cursor_focus == FOCUS_ITEMLIST){
	    ViewItem_InvertCursor();
	    ViewItem_InitCursor();
	    cursor_focus = FOCUS_TIMETABLE;
	}
	break;

	case kUKey_HOURUP:		      /* ־ */
	ViewTime_InvertCursor();	      /* OFF */
	/* 򥫡̾ */
	if (gCursorHourRange > 1){
	    gCursorHourRange--;
	}else{
	    if (gCursorHour > 0){
		gCursorHour--;
	    }
	}
	ViewTime_Up();
	ViewTime_InvertCursor();	      /* ON */
	/* ե򥢥ƥꥹȤ˰ư */
	if (cursor_focus == FOCUS_ITEMLIST){
	    ViewItem_InvertCursor();
	    ViewItem_InitCursor();
	    cursor_focus = FOCUS_TIMETABLE;
	}
	break;

	case kUKey_HOURDOWN:		      /* ֲ */
	ViewTime_InvertCursor();	      /* OFF */
	/* 򥫡 */
	if (gCursorHour + gCursorHourRange < 24){
	    gCursorHourRange++;
	}
	ViewTime_Down();
	ViewTime_InvertCursor();	      /* ON */
	/* ե򥢥ƥꥹȤ˰ư */
	if (cursor_focus == FOCUS_ITEMLIST){
	    ViewItem_InvertCursor();
	    ViewItem_InitCursor();
	    cursor_focus = FOCUS_TIMETABLE;
	}
	break;

	case kUKey_ITEMUP:		      /* ƥ */
	if (cursor_focus == FOCUS_TIMETABLE){
	    D(mnwDPrintf("focus ITEMLIST"));
	    ViewItem_InvertCursor();	      /* ON */
	    cursor_focus = FOCUS_ITEMLIST;
	}else{
	    ViewItem_InvertCursor();	      /* OFF */
	    ViewItem_Up();
	    ViewItem_InvertCursor();	      /* ON */
	}
	break;

	case kUKey_ITEMDOWN:		      /* ƥ಼ */
	if (cursor_focus == FOCUS_TIMETABLE){
	    D(mnwDPrintf("focus ITEMLIST"));
	    ViewItem_InvertCursor();	      /* ON */
	    cursor_focus = FOCUS_ITEMLIST;
	}else{
	    ViewItem_InvertCursor();	      /* OFF */
	    ViewItem_Down();
	    ViewItem_InvertCursor();	      /* ON */
	}
	break;

	default:
	/* ʤ */
	return false;
	break;
    }

    /*  */
    return true;
}

/* ޥɽ */
bool
ViewWS_Command(mnwEvent *event)
{
    switch (event->param1){
	case ID_FUNC_NOW:
	ViewTime_InitCursor();
	ViewItem_InitCursor();
	View_Redraw();
	break;

	default:
	/* ʤ */
	return false;
	break;
    }

    /*  */
    return true;
}
