/* sample program for MNW -- event viewer */

#define MNW_USE_SHORTCUT
#include "mnw.h"

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

void print_event(mnwEvent *event);

int main(void)
{
    mnwEvent *event, e;
    mnwWindow win;
    mnwRect rect;

    mnwSetup();

    mnwRect_SetXYWH(&rect, 400, 100, 50, 50);
    mnwWindow_Register(&win, mnwWindow_Callback, nil, &rect);

    mnwEvent_SetTimer(0, &win, 10*1000);

    mnwEvent_SetAll(&e, kEvent_SetFocus, nil, 0, 0);
    mnwEvent_SendTo(&e, &win);

    while ((event = mnwEvent_GetNext(true)) != nil){
	mnwDPrintf("key down");
	mnwDPrintf("1:%04X, 2:%04X", event->param1, event->param2);
	print_event(event);
	if (!mnwEvent_Translate(event)){
	    mnwDPrintf("1:%04X, 2:%04X", event->param1, event->param2);
	    print_event(event);
	    if (event->type == kEvent_KeyDown){
		if (event->param1 == 'Q'){
		    mnwEvent_SetAll(&e, kEvent_Quit, nil, 0, 0);
		    mnwEvent_Post(&e);
		}
	    }
	    mnwEvent_Dispatch(event);
	}
    }

    mnwTidy();
    return 0;
}

void print_event(mnwEvent *event)
{
    mnwRect rect;
    char str[256];

    /* scroll up */
    mnwRect_SetXYWH(&rect, 0, 16, 640, 240-16);
    mnwCopyRect(&rect, 0, -16);

    /* delete last line */
    mnwSetForeColor(kColor_LtGray);
    mnwRect_SetXYWH(&rect, 0, 240-1-16, 640, 16);
    mnwFillRect(&rect);

    /* write last line */
    mnwSetForeColor(kColor_Black);
    mnwSetFont(kFont_16);
    sprintf(str, "type:%d, param0=0x%X, param1=0x%X, param2=0x%X",
	    event->type, event->param0, event->param1, event->param2);
    mnwDrawText(0, 240-1-16, str, strlen(str));
}
