/*
   MNW message box
   Copyright (c) 1998 FURUKAWA Yo.
   $Id: mnwmsgbx.c,v 1.1.1.1 1999/02/28 06:47:48 furukawa Exp $
   */

#define MNW_USE_SHORTCUT
#include "mnw.h"

/* -- MsgBox */

/* 饹ǤϤʤʰ٤ˣ󥹥󥹤Ǥʤ */

#define HANDLE_SIZE	80
static char ok_buf[HANDLE_SIZE];
static char ng_buf[HANDLE_SIZE];
static char cancel_buf[HANDLE_SIZE];
static mnwButton button[3];
static char label_buf[3][HANDLE_SIZE];
static mnwLabel label[3];
static int msgbox_type;
static int msgbox_result;
static char *msgbox_msg;

static bool
mnwMsgBox_Callback(mnwDialog *self, mnwEvent *event);

int
mnwMsgBox(char *msg, int type)
{
    mnwDialog dialog;
    mnwRect r;
    mnwEvent e;

    msgbox_msg = msg;			      /* Ugh!: dirty */
    msgbox_type = type;
    msgbox_result = -1;

    /* MsgBox */
    mnwRect_SetXYWH(&r, 200, 70, 240, 120);
    mnwWindow_Register((mnwWindow *)&dialog,
		       (mnwWindowCallback)mnwMsgBox_Callback,
		       (mnwWindow *)gRootWindow, &r);

#if 0
    /* ե */
    mnwEvent_SetFocusWindow((mnwWindow *)&dialog);
#endif

    /* modal dialog */
    mnwEvent_SetAll(&e, kEvent_DoModal, nil, 0, 0);
    mnwEvent_SendToDirect(&e, (mnwWindow *)&dialog);

    /* MsgBoxξõ */
    mnwWindow_UnRegister((mnwWindow *)&dialog);

    return msgbox_result;
}

static bool
mnwMsgBox_Initialize(mnwDialog *self)
{
    mnwEvent e;
    mnwRect r;
    int button_num;
    int i, start, p;

    switch (msgbox_type & 0xf){
	case kMsgBox_Type_OK:
	button_num = 1;
	break;
	case kMsgBox_Type_OKNG:
	button_num = 2;
	break;
	case kMsgBox_Type_OKCANCEL:
	button_num = 2;
	break;
	case kMsgBox_Type_OKNGCANCEL:
	button_num = 3;
	/* TODO */
	break;
    }

#if 0
    mnwEvent_SetAll(&e, kEvent_GetRect, &box_r, 0, 0);
    mnwEvent_SendToDirect(&e, (mnwWindow *)self);
#endif

    /* å٥ */
    for (i = 0; i < 3; i++){
	mnwRect_SetXYWH(&r, 6, 10 + i * 24, 16*14+4, 22);
	mnwWindow_Register((mnwWindow *)&label[i],
			   (mnwWindowCallback)mnwLabel_Callback,
			   (mnwWindow *)self, &r);
	mnwEvent_SetAll(&e, kEvent_SetBuffer, label_buf[i], HANDLE_SIZE, 0);
	mnwEvent_SendTo(&e, (mnwWindow *)&label[i]);
	mnwEvent_SetAll(&e, kEvent_SetAlign, nil, kAlign_Center, 0);
	mnwEvent_SendTo(&e, (mnwWindow *)&label[i]);
    }

    /* å٥ */
    for (start = 0, p = 0, i = 0; p < strlen(msgbox_msg); p++){
	if (msgbox_msg[p] == '\n'){
	    mnwEvent_SetAll(&e, kEvent_SetText,
			    &msgbox_msg[start], p - start, 0);
	    mnwEvent_SendTo(&e, (mnwWindow *)&label[i++]);
	    start = p + 1;
	}
    }
    mnwEvent_SetAll(&e, kEvent_SetText,
		    &msgbox_msg[start], p - start, 0);
    mnwEvent_SendTo(&e, (mnwWindow *)&label[i++]);

    /* ܥ */
    switch (button_num){
	case 1:
	mnwRect_SetXYWH(&r, 90, 84, 60, 24);
	mnwWindow_Register((mnwWindow *)&button[0],
			   (mnwWindowCallback)mnwButton_Callback,
			   (mnwWindow *)self, &r);
	mnwEvent_SetAll(&e, kEvent_SetTabStop, &button[0], 0, 0);
	mnwEvent_SendTo(&e, (mnwWindow *)self);
	break;
	case 2:
	mnwRect_SetXYWH(&r, 50, 84, 60, 24);
	mnwWindow_Register((mnwWindow *)&button[0],
			   (mnwWindowCallback)mnwButton_Callback,
			   (mnwWindow *)self, &r);
	mnwEvent_SetAll(&e, kEvent_SetTabStop, &button[0], 0, 0);
	mnwEvent_SendTo(&e, (mnwWindow *)self);
	mnwRect_SetXYWH(&r, 130, 84, 60, 24);
	mnwWindow_Register((mnwWindow *)&button[1],
			   (mnwWindowCallback)mnwButton_Callback,
			   (mnwWindow *)self, &r);
	mnwEvent_SetAll(&e, kEvent_SetTabStop, &button[1], 0, 0);
	mnwEvent_SendTo(&e, (mnwWindow *)self);
	break;
	case 3:
	break;
    }

    /* ܥ */
    mnwEvent_SetAll(&e, kEvent_SetBuffer, ok_buf, HANDLE_SIZE, 0);
    mnwEvent_SendTo(&e, (mnwWindow *)&button[0]);
    mnwEvent_SetAll(&e, kEvent_SetText, "OK", 2, 0);
    mnwEvent_SendTo(&e, (mnwWindow *)&button[0]);
    mnwEvent_SetAll(&e, kEvent_SetCommand, nil, kMsgBox_OK, 0);
    mnwEvent_SendTo(&e, (mnwWindow *)&button[0]);
    switch (msgbox_type & 0xf){
	case kMsgBox_Type_OKNG:
	mnwEvent_SetAll(&e, kEvent_SetBuffer, ng_buf, HANDLE_SIZE, 0);
	mnwEvent_SendTo(&e, (mnwWindow *)&button[1]);
	mnwEvent_SetAll(&e, kEvent_SetText, "NG", 2, 0);
	mnwEvent_SendTo(&e, (mnwWindow *)&button[1]);
	mnwEvent_SetAll(&e, kEvent_SetCommand, nil, kMsgBox_NG, 0);
	mnwEvent_SendTo(&e, (mnwWindow *)&button[1]);
	break;
	case kMsgBox_Type_OKCANCEL:
	mnwEvent_SetAll(&e, kEvent_SetBuffer, cancel_buf, HANDLE_SIZE, 0);
	mnwEvent_SendTo(&e, (mnwWindow *)&button[1]);
	mnwEvent_SetAll(&e, kEvent_SetText, "CANCEL", 6, 0);
	mnwEvent_SendTo(&e, (mnwWindow *)&button[1]);
	mnwEvent_SetAll(&e, kEvent_SetCommand, nil, kMsgBox_CANCEL, 0);
	mnwEvent_SendTo(&e, (mnwWindow *)&button[1]);
	break;
    }

    /* ǽΥܥ˥ե */
    mnwEvent_SetAll(&e, kEvent_KeyDown, nil, kKey_TAB, 0);
    mnwEvent_SendTo(&e, (mnwWindow *)self);

    return true;
}

static bool
mnwMsgBox_Finalize(mnwDialog *self)
{
    int i;
    int button_num;

    switch (msgbox_type & 0xf){
	case kMsgBox_Type_OK:
	button_num = 1;
	break;
	case kMsgBox_Type_OKNG:
	button_num = 2;
	break;
	case kMsgBox_Type_OKCANCEL:
	button_num = 2;
	break;
	case kMsgBox_Type_OKNGCANCEL:
	button_num = 3;
	/* TODO */
	break;
    }

    /* å٥κ */
    for (i = 0; i < 3; i++){
	mnwWindow_UnRegister((mnwWindow *)&label[i]);
    }

    /* ܥκ */
    for (i = 0; i < button_num; i++){
	mnwWindow_UnRegister((mnwWindow *)&button[i]);
    }
    return true;
}

static bool
mnwMsgBox_Command(mnwDialog *self, mnwEvent *event)
{
    mnwEvent e;

    msgbox_result = event->param1;

    mnwEvent_SetFocusWindow((mnwWindow *)self);
    mnwEvent_SetAll(&e, kEvent_EndModal, nil, 0, 0);
    mnwEvent_SendTo(&e, (mnwWindow *)self);
    return true;
}

static bool
mnwMsgBox_Callback(mnwDialog *self, mnwEvent *event)
{
    switch (event->type){
	case kEvent_Create:
	mnwDialog_Callback((mnwDialog *)self, event); /* super */
	return mnwMsgBox_Initialize(self);
	break;
	case kEvent_Destroy:
	mnwMsgBox_Finalize(self);
	return mnwDialog_Callback((mnwDialog *)self, event); /* super */
	break;
	case kEvent_Command:
	return mnwMsgBox_Command(self, event);
	break;
	default:
	/* superdelegate */
	return mnwDialog_Callback((mnwDialog *)self, event);
	break;
    }

    /* ٥Ȥʤ */
    return false;
}
