/* sample program for MNW */

#define MNW_USE_SHORTCUT
#include "mnw.h"

static byte pixmap1[] = {
 0xFF,0x00,0x00,0x00,
 0xFF,0x00,0x00,0x00,
 0xFF,0x00,0x00,0x00,
 0xFF,0x00,0x00,0x00,
 0x00,0xFF,0x00,0x00,
 0x00,0xFF,0x00,0x00,
 0x00,0xFF,0x00,0x00,
 0x00,0xFF,0x00,0x00,
 0x00,0x00,0xFF,0x00,
 0x00,0x00,0xFF,0x00,
 0x00,0x00,0xFF,0x00,
 0x00,0x00,0xFF,0x00,
 0x00,0x00,0x00,0xFF,
 0x00,0x00,0x00,0xFF,
 0x00,0x00,0x00,0xFF,
 0x00,0x00,0x00,0xFF,
};

void
test1(void)
{
    mnwRect rect;
    byte buf[(16/4)*16];
    void *pixmap;

    mnwSetForeColor(kColor_White);
    mnwRect_SetXYWH(&rect, 10, 10, 100, 100);
    mnwFillRect(&rect);
    mnwSetForeColor(kColor_Black);
    mnwDrawRect(&rect);
    mnwSetForeColor(kColor_LtGray);
    mnwRect_SetXYWH(&rect, 20, 20, 100, 100);
    mnwFillRect(&rect);
    mnwSetForeColor(kColor_Black);
    mnwDrawRect(&rect);
    mnwSetForeColor(kColor_DkGray);
    mnwRect_SetXYWH(&rect, 30, 30, 100, 100);
    mnwFillRect(&rect);
    mnwSetForeColor(kColor_Black);
    mnwDrawRect(&rect);
    mnwSetForeColor(kColor_Black);
    mnwRect_SetXYWH(&rect, 40, 40, 100, 100);
    mnwFillRect(&rect);
    mnwSetForeColor(kColor_Black);
    mnwDrawRect(&rect);

    mnwSetForeColor(kColor_Black);
    mnwDrawLine(170, 10, 270, 10);
    mnwDrawLine(170, 10, 270, 20);
    mnwDrawLine(170, 10, 270, 30);
    mnwDrawLine(170, 10, 270, 40);
    mnwDrawLine(170, 10, 270, 50);
    mnwDrawLine(170, 10, 270, 60);
    mnwDrawLine(170, 10, 270, 70);
    mnwDrawLine(170, 10, 270, 80);
    mnwDrawLine(170, 10, 270, 90);

    mnwSetFont(kFont_12);
    mnwDrawText(300, 10, "ۤۤ", 8);
    mnwSetFont(kFont_16);
    mnwDrawText(300, 30, "ۤۤ", 4);
    mnwSetFont(kFont_24);
    mnwDrawText(300, 50, "ڤ", 11);
    mnwSetFont(kFont_10x8);
    mnwDrawText(500, 10, "ۤۤ", 8);

    mnwRect_SetXYWH(&rect, 0, 50, 640, 20);
    mnwCopyRect(&rect, 0, 100);

    mnwSetFont(kFont_16);
    mnwDrawText(320, 220, "եåƥ", 22);

    pixmap = mnwCreatePixmap(buf, 16, 16);
    memcpy(buf, pixmap1, sizeof(pixmap1));
    mnwDrawPixmap(320, 100, 0, 0, pixmap, 16, 16);
    mnwDestroyPixmap(pixmap);

#ifdef MNW_USE_TRUETYPE
    {
	int font_id, dir;
#ifndef MNW_USE_GGI
	mnwTT_Initialize("/home/furukawa/loft/font/dyna/DFGsk7.ttc");
#endif
	font_id = mnwTTFont_Create(30, 72, true);
	mnwTT_DrawText(font_id, 450, 30, "ܸ", 12);
	font_id = mnwTTFont_Create(20, 72, true);
	mnwTT_DrawText(font_id, 450, 60, "ܸ", 12);
	font_id = mnwTTFont_Create(10, 72, true);
	mnwTT_DrawText(font_id, 450, 90, "ܸ", 12);

	dir = kDIR_WEST;
	mnwSetFont(kFont_24);
	font_id = mnwTTFont_Create(24, 72, true);

	mnwTT_DrawFontRotated(font_id, 450, 120, 0xB4C1, dir);
	mnwTT_DrawFontRotated(font_id, 450, 150, 'a', dir);

	mnwTT_DrawTextRotated(font_id, 300, 120, "peaceܸ", 17, dir);
	mnwDrawTextRotated(300, 120, "peaceܸ", 17, dir);
    }
#endif

    mnwFlush();
    fgetc(stdin);
}

#define MULTITEXT ""

#define HANDLE_SIZE	80
static char label_handle[HANDLE_SIZE];
static char button_handle[HANDLE_SIZE];
static char text_handle[HANDLE_SIZE];
static char text_handle2[200];
static char list_handle[HANDLE_SIZE*10];

void
test2(void)
{
    mnwEvent *event, e;
    mnwDialog win1;
    mnwWindow win2;
    mnwLabel win3;
    mnwButton win4;
    mnwEdit win5, win7;
    mnwList win6;
    mnwRect rect;

    /* 롼ȥɥβĻ벽	*/
    mnwEvent_SetAll(&e, kEvent_Show, nil, 0, 0);
    mnwEvent_SendTo(&e, gRootWindow);

    /* 롼ȥɥΥȥ */
    mnwEvent_SetAll(&e, kEvent_SetText, "٥ƥ", 18, 0);
    mnwEvent_SendTo(&e, gRootWindow);
    mnwEvent_SetAll(&e, kEvent_Redraw, nil, 0, 0);
    mnwEvent_SendTo(&e, gRootWindow);

    /* ɥ */
    mnwRect_SetXYWH(&rect, 30, 60, 320, 160);
    mnwWindow_Register((mnwWindow *)&win1,
		       (mnwWindowCallback)mnwDialog_Callback,
		       (mnwWindow *)gRootWindow, &rect);
    mnwRect_SetXYWH(&rect, 20, 20, 80, 60);
    mnwWindow_Register((mnwWindow *)&win2, mnwWindow_Callback,
		       (mnwWindow *)&win1, &rect);
    mnwRect_SetXYWH(&rect, 110, 40, 50, 22);
    mnwWindow_Register((mnwWindow *)&win3,
		       (mnwWindowCallback)mnwLabel_Callback,
		       (mnwWindow *)&win1, &rect);
    mnwRect_SetXYWH(&rect, 110, 70, 50, 24);
    mnwWindow_Register((mnwWindow *)&win4,
		       (mnwWindowCallback)mnwButton_Callback,
		       (mnwWindow *)&win1, &rect);
    mnwRect_SetXYWH(&rect, 10, 100, 18*16-8+4, 16*3+4);
    mnwWindow_Register((mnwWindow *)&win5,
		       (mnwWindowCallback)mnwEdit_Callback,
		       (mnwWindow *)&win1, &rect);
    mnwRect_SetXYWH(&rect, 240, 20, 60, 16*3+4);
    mnwWindow_Register((mnwWindow *)&win6,
		       (mnwWindowCallback)mnwList_Callback,
		       (mnwWindow *)&win1, &rect);
    mnwRect_SetXYWH(&rect, 180, 76, 16*7+4, 16*1+4);
    mnwWindow_Register((mnwWindow *)&win7,
		       (mnwWindowCallback)mnwEdit_Callback,
		       (mnwWindow *)&win1, &rect);

    /* TAB stop */
    mnwEvent_SetAll(&e, kEvent_SetTabStop, &win4, 0, 0);
    mnwEvent_SendTo(&e, (mnwWindow *)&win1);
    mnwEvent_SetAll(&e, kEvent_SetTabStop, &win5, 0, 0);
    mnwEvent_SendTo(&e, (mnwWindow *)&win1);
    mnwEvent_SetAll(&e, kEvent_SetTabStop, &win6, 0, 0);
    mnwEvent_SendTo(&e, (mnwWindow *)&win1);
    mnwEvent_SetAll(&e, kEvent_SetTabStop, &win7, 0, 0);
    mnwEvent_SendTo(&e, (mnwWindow *)&win1);

    /* ե */
    mnwEvent_SetFocusWindow((mnwWindow *)&win1);

    /* ٥ */
    mnwEvent_SetAll(&e, kEvent_SetBuffer, label_handle, HANDLE_SIZE, 0);
    mnwEvent_SendTo(&e, (mnwWindow *)&win3);
    mnwEvent_SetAll(&e, kEvent_SetText, "hogehoge", 4, 0);
    mnwEvent_SendTo(&e, (mnwWindow *)&win3);
    mnwEvent_SetAll(&e, kEvent_SetStyle, nil, kStyle_Popup, 0);
    mnwEvent_SendTo(&e, (mnwWindow *)&win3);
    mnwEvent_SetAll(&e, kEvent_SetAlign, nil, kAlign_Center, 0);
    mnwEvent_SendTo(&e, (mnwWindow *)&win3);

    /* ܥ */
    mnwEvent_SetAll(&e, kEvent_SetBuffer, button_handle, HANDLE_SIZE, 0);
    mnwEvent_SendTo(&e, (mnwWindow *)&win4);
    mnwEvent_SetAll(&e, kEvent_SetText, "OK", 2, 0);
    mnwEvent_SendTo(&e, (mnwWindow *)&win4);
    mnwEvent_SetAll(&e, kEvent_SetCommand, nil, 0x999, 0);
    mnwEvent_SendTo(&e, (mnwWindow *)&win4);

    /* ǥåȥݤ */
    mnwEvent_SetAll(&e, kEvent_SetBuffer, text_handle, HANDLE_SIZE, 0);
    mnwEvent_SendTo(&e, (mnwWindow *)&win5);
    mnwEvent_SetAll(&e, kEvent_SetText, MULTITEXT, strlen(MULTITEXT), 0);
    mnwEvent_SendTo(&e, (mnwWindow *)&win5);
    mnwEvent_SetAll(&e, kEvent_SetMultiLine, nil, 0, 0);
    mnwEvent_SendTo(&e, (mnwWindow *)&win5);

    mnwEvent_SetAll(&e, kEvent_SetBuffer, text_handle2, 200, 0);
    mnwEvent_SendTo(&e, (mnwWindow *)&win7);
    mnwEvent_SetAll(&e, kEvent_SetText, "single line", 11, 0);
    mnwEvent_SendTo(&e, (mnwWindow *)&win7);

    /* ꥹȥݤ */
    mnwEvent_SetAll(&e, kEvent_SetBuffer, list_handle, HANDLE_SIZE, 10);
    mnwEvent_SendTo(&e, (mnwWindow *)&win6);
    mnwEvent_SetAll(&e, kEvent_SetText, "0", 0, 1);
    mnwEvent_SendTo(&e, (mnwWindow *)&win6);
    mnwEvent_SetAll(&e, kEvent_SetText, "1", 1, 1);
    mnwEvent_SendTo(&e, (mnwWindow *)&win6);
    mnwEvent_SetAll(&e, kEvent_SetText, "2", 2, 1);
    mnwEvent_SendTo(&e, (mnwWindow *)&win6);
    mnwEvent_SetAll(&e, kEvent_SetText, "3", 3, 1);
    mnwEvent_SendTo(&e, (mnwWindow *)&win6);
    mnwEvent_SetAll(&e, kEvent_SetText, "4", 4, 1);
    mnwEvent_SendTo(&e, (mnwWindow *)&win6);
    mnwEvent_SetAll(&e, kEvent_Redraw, nil, 0, 0);
    mnwEvent_SendTo(&e, (mnwWindow *)&win6);

    /* ɥβĻ벽 */
    mnwEvent_SetAll(&e, kEvent_Show, nil, 0, 0);
    mnwEvent_SendTo(&e, (mnwWindow *)&win1);

    while ((event = mnwEvent_GetNext(true)) != nil){
	if (!mnwEvent_Translate(event)){
	    mnwPrintEvent(event);
	    if (event->type == kEvent_Command){
		mnwMsgBox("a message box", kMsgBox_Type_OKCANCEL);
		continue;
	    }
	    if (event->type == kEvent_KeyDown){
		if (event->param1 == 'q'){
		    return;
		}
	    }
	    mnwEvent_Dispatch(event);
	}
    }
}

int main(void)
{
    mnwSetup();
    /*test1();*/
    test2();
    mnwTidy();
    return 0;
}
