/*
   architecture dependent definitions
   Copyright (c) 1997 FURUKAWA Yo.
   $Id: arch.h,v 1.1.1.1 1998/12/15 03:42:44 furukawa Exp $
   */

#ifndef _ARCH_H_
#define _ARCH_H_

#ifdef ARCH_POSIX
typedef unsigned int uint32;
typedef int int32;
typedef unsigned short uint16;
typedef short int16;
typedef unsigned char uint8;
typedef char int8;
#else
typedef unsigned long uint32;
typedef long int32;
typedef unsigned int uint16;
typedef int int16;
typedef unsigned char uint8;
typedef char int8;
#endif

typedef unsigned char byte;
#ifndef ARCH_BOOL_DEFINED
typedef unsigned char bool;
#endif

#ifndef false
#define false	(0!=0)
#define true	(!false)
#endif

#ifndef nil
#define nil	((void *)0)
#endif

#ifdef ARCH_POSIX
#ifndef max
#define max(x, y)	((x)>(y)?(x):(y))
#define min(x, y)	((x)<(y)?(x):(y))
#endif
#endif

#ifdef ARCH_DOS
#define OPENMODE_READ_BINARY	"rb"
#define OPENMODE_READ_TEXT	"rt"
#define OPENMODE_WRITE_BINARY	"wb"
#define OPENMODE_WRITE_TEXT	"wt"
#else
#define OPENMODE_READ_BINARY	"r"
#define OPENMODE_READ_TEXT	"r"
#define OPENMODE_WRITE_BINARY	"w"
#define OPENMODE_WRITE_TEXT	"w"
#endif

#define UINT8_MIN	((unit8)0)
#define UINT8_MAX	((uint8)255)
#define UINT16_MIN	((uint16)0)
#define UINT16_MAX	((uint16)65535)

#ifdef ARCH_DOS
#include <malloc.h>
#define ALLOC_BLOCK_SIZE_MAX	(uint16)(_HEAP_MAXREQ) /* < 64k for DOS */
#define ALLOC_BLOCK_SIZE	(uint16)(4*1024)
#else
#define ALLOC_BLOCK_SIZE_MAX	(uint16)(UINT16_MAX) /* for compatibility */
#define ALLOC_BLOCK_SIZE	(uint16)(16*1024)
#endif

#endif
