/*
   database interface
   Copyright (c) 1997 FURUKAWA Yo.
   $Id: db.c,v 1.1.1.1 1998/12/15 03:42:44 furukawa Exp $
   */

#include "arch.h"
#include "record.h"
#include "index.h"
#include "month.h"
#include "calendar.h"
#include "db.h"
#include <stdio.h>
#include <locale.h>
#include <time.h>

/* -- file local variables */
static uint16 dbMode;
static uint16 dbUser;
static byte dbFileName[256];

/* -- file local methods */

/* -- methods */

/* ǡ١ν */
bool
DB_Init(void)
{
    dbMode = DB_MODE_CLIENT;

    /* 쥳ɤν */
    Record_Init();

    /* ǥåν */
    Index_Init();

    /* åν */
    MonthRec_Init();

    return true;
}

/* ǡ١դ */
bool
DB_Tidy(void)
{
    /* åդ */
    MonthRec_Tidy();

    /* ǥåդ */
    Index_Tidy();

    /* 쥳ɤդ */
    Record_Tidy();

    return true;
}

/* ǡ١Υ⡼ */
uint16
DB_SetMode(uint16 mode)
{
    uint16 prev;

    prev = dbMode;
    dbMode = mode;
    return prev;
}

/* ǡ١Υ⡼ɼ */
uint16
DB_GetMode(void)
{
    return dbMode;
}


/* ǡ١Υ桼 */
uint16
DB_SetUser(uint16 user)
{
    uint16 prev;

    prev = dbUser;
    dbUser = user;
    return prev;
}

/* ǡ١Υ桼 */
uint16
DB_GetUser(void)
{
    return dbUser;
}

/* ǡ١Υե̾ */
void
DB_SetFileName(byte *name)
{
    sprintf((char *)dbFileName, "%s", (char *)name);
}

/* ǡ١Υե̾ */
byte *
DB_GetFileName(void)
{
   return dbFileName;
}

/* ǡ١ռ */
uint16
DB_GetDate(uint16 *out_year, uint16 *out_month, uint16 *out_day,
	   uint8 *out_hour, uint8 *out_min)
{
    struct tm *local_time;
    time_t now;

    setlocale(LC_TIME, "");
    time(&now);
    local_time = localtime(&now);
    *out_year = local_time->tm_year + 1900;
    *out_month = local_time->tm_mon + 1;
    *out_day = local_time->tm_mday;
    *out_hour = local_time->tm_hour;
    *out_min = local_time->tm_min;

    return Calendar_GetDayNo(*out_year, *out_month, *out_day);
}
