/*
   month cache
   Copyright (c) 1997 FURUKAWA Yo.
   $Id: month.h,v 1.1.1.1 1998/12/15 03:42:44 furukawa Exp $
   */

#ifndef _MONTH_H_
#define _MONTH_H_

#include "arch.h"
#include "record.h"

/* -- types */

typedef struct _MonthRec {
    uint8 isValid;
    uint16 monthNo;
    uint16 numOfDays;
    uint16 start_date;
    uint16 end_date;
    uint16 isHoliday[32];
    uint16 num[32];
    Record **rec[32];
    Record *pointers[3000];		      /* 3000 pointers per month */
} MonthRec;

/* -- prototypes */

void
MonthRec_Init(void);
void
MonthRec_Tidy(void);
void
MonthRec_Invalidate(void);
void
MonthRec_SelectLabel(uint16 label);
MonthRec *
MonthRec_GetByMonthNo(uint16 monthNo);
void
MonthRec_ConfigIsSaturdayHoliday(bool flag);
void
MonthRec_ConfigSetLabel(uint16 label, bool flag);

#endif
