/*
   token
   Copyright (c) 1998 FURUKAWA Yo.
   $Id: token.h,v 1.1.1.1 1998/12/15 03:42:45 furukawa Exp $
   */

#ifndef _TOKEN_H_
#define _TOKEN_H_

#include "arch.h"

/* -- macros */

/* token types */
#define TOK_EOL			0	/* End of Line */
#define TOK_WHITE		1	/* SPACE,TAB,CR,LF */

#define TOK_NUMBER		10	/* number */
#define TOK_ORDINAL		11	/* ordinal number (1st, first...) */

#define TOK_SEPARATE		20	/* ({[)}],./: */

#define TOK_MONTH		40	/* Jan,Jan.,January... */
#define TOK_DAYWEEK		41	/* Sun,Sun.,Sunday... */
#define TOK_AMPM		42	/* AM,PM,, */

#define TOK_NENGOU		50	/* ,ʿ */
#define TOK_NEN			51	/* ǯ */
#define TOK_GATU		52	/*  */
#define TOK_NITI		53	/*  */
#define TOK_JI			54	/*  */
#define TOK_FUN			55	/* ʬ */
#define TOK_HAN			56	/* Ⱦ */

#define TOK_UNKNOWN		255	/* ʤ */

/* token attribute */
#define TOKATTR_NONE		0

#define TOKATTR_DAYWEEK		10	/* Sun,Sunday... */
#define TOKATTR_DAYWEEK_J	11	/* ˡ... */

#define TOKATTR_AM		20	/* AM */
#define TOKATTR_PM		21	/* PM */
#define TOKATTR_AM_J		22	/*  */
#define TOKATTR_PM_J		23	/*  */

#define TOKATTR_SHOUWA		30	/*  */
#define TOKATTR_HEISEI		31	/* ʿ */

#define TOKATTR_BRACKET_OPEN	40	/* ({[ */
#define TOKATTR_BRACKET_CLOSE	41	/* )}] */
#define TOKATTR_COMMA		42	/* , */
#define TOKATTR_PERIOD		43	/* . */
#define TOKATTR_SLASH		44	/* / */
#define TOKATTR_COLON		45	/* : */
#define TOKATTR_HYPHEN		46	/* - */
#define TOKATTR_KARA		47	/* 顤 */

/* -- prototypes */
char *
Token_GetNext(char *str, uint8 *token, int16 *token_attr);

#endif
