/*
   add dialog
   Copyright (c) 1997,98 FURUKAWA Yo.
   $Id: additem.c,v 1.1.1.1 1998/12/15 03:42:46 furukawa Exp $
   */

/* ƂR[h */

#include "global.h"
#include "taskmg.h"
#include "taskid.h"
#include "arch.h"
#include "funckey.h"
#include "gendlg.h"
#include "additem.h"
#include "calendar.h"
#include "record.h"
#include "month.h"
#include "view.h"
#include "viewfile.h"
#include "context.h"
#include <string.h>
#include <stdlib.h>
#include <stdio.h>
#include <u-k.h>

/* -- file local macros */
#define EDIT_1stLINE_NORMAL	(34)
#define EDIT_2ndLINE_NORMAL	(EDIT_1stLINE_NORMAL+(18*3+2)+4)
#define EDIT_3rdLINE_NORMAL	(EDIT_2ndLINE_NORMAL+(18*1+2)+4)
#define EDIT_4thLINE_NORMAL	(EDIT_3rdLINE_NORMAL+(18*1+2)+4)
#define EDIT_5thLINE_NORMAL	(EDIT_4thLINE_NORMAL+(18*1+2)+4)

#define EDIT_1stLINE_LARGE	(34)
#define EDIT_2ndLINE_LARGE	(EDIT_1stLINE_LARGE+(18*5+2)+3)
#define EDIT_3rdLINE_LARGE	(EDIT_2ndLINE_LARGE+(18*1+2)+4)

#define EDIT_1stLINE_SMALL	(34)
#define EDIT_2ndLINE_SMALL	(EDIT_1stLINE_SMALL+(18*2+2)+3)
#define EDIT_3rdLINE_SMALL	(EDIT_2ndLINE_SMALL+(18*1+2)+3)
#define EDIT_4thLINE_SMALL	(EDIT_3rdLINE_SMALL+(18*1+2)+3)
#define EDIT_5thLINE_SMALL	(EDIT_4thLINE_SMALL+(18*1+2)+3)

#define F16_WIDTH	8
#define F16_HEIGHT	16
#define F12_WIDTH	6
#define F12_HEIGHT	12

#define DIALOG_NORMAL	0
#define DIALOG_LARGE	1
#define DIALOG_SMALL	2

/* -- file local variables */

/* AddEBhE */
static char *nameAddWin = "AddWin";

/* _CAO^Cg */
static char *dialogTitle[11] = {
    "",
    "^XNǉ", "", "XPW[ǉ", "", "xǉ",
    "^XNύX", "", "XPW[ύX", "", "xύX",
};

/* ԕϐ */
static uint8 local_repeat_type;
static uint16 local_label;
static uint16 prev_start_date, prev_end_date;

/* ʒuϐ */
static int region_dialog_left, region_dialog_top;
static int region_dialog_right, region_dialog_bottom;
static int region_dialog_width, region_dialog_height;
static int region_description_left, region_description_top;
static int region_title_left, region_title_top;
static int region_start_time_left, region_start_time_top;
static int region_end_time_left, region_end_time_top;
static int region_start_date_left, region_start_date_top;
static int region_end_date_left, region_end_date_top;
static int region_label_left, region_label_top;
static int region_repeat_left, region_repeat_top;
static int region_repeat_width, region_repeat_height;
static int region_repeat_label_left, region_repeat_label_top;
static int region_repeat_interval_left, region_repeat_interval_top;
static int region_rank_left, region_rank_top;
static int description_rows, description_cols;
static int dialog_size;

/*  */
static Record *editRecord;

/* -- file local methods */
static bool
Add_Create(int16 mode);
static void
Add_InitControls(void);
static bool
Add_Destroy(void);
static void
Add_InitRepeatControl(uint16 date);
static void
Add_ResetRepeatControl(uint16 date);
static void
Add_GetRepeatControl(void);
static void
Add_Redraw(void);
static bool
Add_FixDateRange(bool fix_end);
static bool
Add_FixTimeRange(bool fix_end);
static bool
Add_LostFocus(WPARAM id, WPARAM win);
static bool
Add_Register(void);
static void
Add_SetEditRecord(Record *rec);
static void
Add_SetLabel(uint16 label);
static bool
Add_InitRegion(void);
static char *
View_GetDialog(void);

/* -- methods */

/* Add */
static bool
Add_Create(int16 mode)
{
    D(mgDPrintf("Add create\n"));

    /* ԕϐ */
    gMode = MODE_ADD;
    dialog_mode  = mode;
    value_invalid = false;
    kanji_invalid = true;
    kanji_on = false;
    focus = next_focus = should_focus = 0;
    focus_min_val = focus_max_val = 0;
    focus_inc_type = INC_TYPE_NONE;
    focus_not_move = false;

    /* _CAOTCY */
    if (gCurrentView == VIEW_BROWSER){
	dialog_size = DIALOG_SMALL;
    }else if (gOpt_LargeDialog){
	dialog_size = DIALOG_LARGE;
    }else{
	dialog_size = DIALOG_NORMAL;
    }

    /* ʒuϐ */
    Add_InitRegion();

    /* t@NVL[̐ݒ */
    FuncKey_SetAddMode();

    /* LqRg[̍쐬 */
    hEditDescription =
	mgCreateWindow(EDIT, (LPSTR)NULL, 
		       WS_CHILD|WS_VISIBLE|WS_BORDER|WS_TABSTOP|ES_LEFT|ES_MULTILINE,
		       region_description_left, region_description_top,
		       description_cols*F16_WIDTH+4, description_rows*(F16_HEIGHT+2)+2,
		       ghAddWin, (HMENU)ID_EDIT_DESCRIPTION,
		       ghTaskInstance);
    if (hEditDescription == NULL){
	return false;
    }

    /* tRg[̍쐬 */
    hEditStartYear =
	mgCreateWindow(EDIT, (LPSTR)NULL, 
		       WS_CHILD|WS_VISIBLE|WS_BORDER|WS_TABSTOP|ES_RIGHT,
		       region_start_date_left, region_start_date_top,
		       BUF_START_YEAR_LEN*F16_WIDTH+4, F16_HEIGHT+4,
		       ghAddWin, (HMENU)ID_EDIT_START_YEAR,
		       ghTaskInstance);
    if (hEditStartYear == NULL){
	return false;
    }
    region_start_date_left += (BUF_START_YEAR_LEN+2)*F16_WIDTH+8;
    hEditStartMonth =
	mgCreateWindow(EDIT, (LPSTR)NULL, 
		       WS_CHILD|WS_VISIBLE|WS_BORDER|WS_TABSTOP|ES_RIGHT,
		       region_start_date_left, region_start_date_top,
		       BUF_START_MONTH_LEN*F16_WIDTH+4, F16_HEIGHT+4,
		       ghAddWin, (HMENU)ID_EDIT_START_MONTH,
		       ghTaskInstance);
    if (hEditStartMonth == NULL){
	return false;
    }
    region_start_date_left += (BUF_START_MONTH_LEN+2)*F16_WIDTH+8;
    hEditStartDay =
	mgCreateWindow(EDIT, (LPSTR)NULL, 
		       WS_CHILD|WS_VISIBLE|WS_BORDER|WS_TABSTOP|ES_RIGHT,
		       region_start_date_left, region_start_date_top,
		       BUF_START_DAY_LEN*F16_WIDTH+4, F16_HEIGHT+4,
		       ghAddWin, (HMENU)ID_EDIT_START_DAY,
		       ghTaskInstance);
    if (hEditStartDay == NULL){
	return false;
    }
    region_start_date_left += (BUF_START_DAY_LEN+2)*F16_WIDTH+8;
    hStaticStartDayWeek =
	mgCreateWindow(STATIC, (LPSTR)NULL, 
		       WS_CHILD|WS_VISIBLE|SS_RIGHT,
		       region_start_date_left+8, region_start_date_top+2,
		       BUF_START_DAYWEEK_LEN*F16_WIDTH, F16_HEIGHT,
		       ghAddWin, (HMENU)ID_STATIC_START_DAYWEEK,
		       ghTaskInstance);
    if (hStaticStartDayWeek == NULL){
	return false;
    }

    if (hasEndDate(dialog_mode)){
	hEditEndYear =
	    mgCreateWindow(EDIT, (LPSTR)NULL, 
			   WS_CHILD|WS_VISIBLE|WS_BORDER|WS_TABSTOP|ES_RIGHT,
			   region_end_date_left, region_end_date_top,
			   BUF_END_YEAR_LEN*F16_WIDTH+4, F16_HEIGHT+4,
			   ghAddWin, (HMENU)ID_EDIT_END_YEAR,
			   ghTaskInstance);
	if (hEditEndYear == NULL){
	    return false;
	}
	region_end_date_left += (BUF_END_YEAR_LEN+2)*F16_WIDTH+8;
	hEditEndMonth =
	    mgCreateWindow(EDIT, (LPSTR)NULL, 
			   WS_CHILD|WS_VISIBLE|WS_BORDER|WS_TABSTOP|ES_RIGHT,
			   region_end_date_left, region_end_date_top,
			   BUF_END_MONTH_LEN*F16_WIDTH+4, F16_HEIGHT+4,
			   ghAddWin, (HMENU)ID_EDIT_END_MONTH,
			   ghTaskInstance);
	if (hEditEndMonth == NULL){
	    return false;
	}
	region_end_date_left += (BUF_END_MONTH_LEN+2)*F16_WIDTH+8;
	hEditEndDay =
	    mgCreateWindow(EDIT, (LPSTR)NULL, 
			   WS_CHILD|WS_VISIBLE|WS_BORDER|WS_TABSTOP|ES_RIGHT,
			   region_end_date_left, region_end_date_top,
			   BUF_END_DAY_LEN*F16_WIDTH+4, F16_HEIGHT+4,
			   ghAddWin, (HMENU)ID_EDIT_END_DAY,
			   ghTaskInstance);
	if (hEditEndDay == NULL){
	    return false;
	}
	region_end_date_left += (BUF_END_DAY_LEN+2)*F16_WIDTH+8;
	if (hasEndDate(dialog_mode)){
	    hStaticEndDayWeek =
		mgCreateWindow(STATIC, (LPSTR)NULL, 
			       WS_CHILD|WS_VISIBLE|WS_BORDER|WS_TABSTOP|SS_RIGHT,
			       region_end_date_left+8, region_end_date_top+2,
			       BUF_END_DAYWEEK_LEN*F16_WIDTH, F16_HEIGHT,
			       ghAddWin, (HMENU)ID_STATIC_END_DAYWEEK,
			       ghTaskInstance);
	    if (hStaticEndDayWeek == NULL){
		return false;
	    }
	}
    }

    /* Rg[쐬 */
    if (hasTime(dialog_mode)){
	hEditStartHour =
	    mgCreateWindow(EDIT, (LPSTR)NULL, 
			   WS_CHILD|WS_VISIBLE|WS_BORDER|WS_TABSTOP|ES_RIGHT,
			   region_start_time_left, region_start_time_top,
			   BUF_START_HOUR_LEN*F16_WIDTH+4, F16_HEIGHT+4,
			   ghAddWin, (HMENU)ID_EDIT_START_HOUR,
			   ghTaskInstance);
	if (hEditStartHour == NULL){
	    return false;
	}
	region_start_time_left += (BUF_START_HOUR_LEN+2)*F16_WIDTH+8;
	hEditStartMin =
	    mgCreateWindow(EDIT, (LPSTR)NULL, 
			   WS_CHILD|WS_VISIBLE|WS_BORDER|WS_TABSTOP|ES_RIGHT,
			   region_start_time_left, region_start_time_top,
			   BUF_START_MIN_LEN*F16_WIDTH+4, F16_HEIGHT+4,
			   ghAddWin, (HMENU)ID_EDIT_START_MIN,
			   ghTaskInstance);
	if (hEditStartMin == NULL){
	    return false;
	}

	hEditEndHour =
	    mgCreateWindow(EDIT, (LPSTR)NULL, 
			   WS_CHILD|WS_VISIBLE|WS_BORDER|WS_TABSTOP|ES_RIGHT,
			   region_end_time_left, region_end_time_top,
			   BUF_END_HOUR_LEN*F16_WIDTH+4, F16_HEIGHT+4,
			   ghAddWin, (HMENU)ID_EDIT_END_HOUR,
			   ghTaskInstance);
	if (hEditEndHour == NULL){
	    return false;
	}
	region_end_time_left += (BUF_END_HOUR_LEN+2)*F16_WIDTH+8;
	hEditEndMin =
	    mgCreateWindow(EDIT, (LPSTR)NULL, 
			   WS_CHILD|WS_VISIBLE|WS_BORDER|WS_TABSTOP|ES_RIGHT,
			   region_end_time_left, region_end_time_top,
			   BUF_END_MIN_LEN*F16_WIDTH+4, F16_HEIGHT+4,
			   ghAddWin, (HMENU)ID_EDIT_END_MIN,
			   ghTaskInstance);
	if (hEditEndMin == NULL){
	    return false;
	}
    }

    /* NRg[쐬 */
    if (hasRank(dialog_mode)){
	hEditRank =
	    mgCreateWindow(EDIT, (LPSTR)NULL, 
			   WS_CHILD|WS_VISIBLE|WS_BORDER|WS_TABSTOP|ES_RIGHT,
			   region_rank_left+F16_WIDTH*6+4, region_rank_top,
			   BUF_RANK_LEN*F16_WIDTH+4, F16_HEIGHT+4,
			   ghAddWin, (HMENU)ID_EDIT_RANK,
			   ghTaskInstance);
	if (hEditRank == NULL){
	    return false;
	}
    }

    /* JԂRg[쐬 */
    if (hasRepeat(dialog_mode)){
	hListRepeat =
	    mgCreateWindow(LISTBOX, (LPSTR)NULL, 
			   WS_CHILD|WS_VISIBLE|WS_BORDER|WS_TABSTOP|ES_RIGHT,
			   region_repeat_left, region_repeat_top,
			   region_repeat_width, region_repeat_height,
			   ghAddWin, (HMENU)ID_LIST_REPEAT,
			   ghTaskInstance);
	if (hListRepeat == NULL){
	    return false;
	}

	hEditRepeatInterval =
	    mgCreateWindow(EDIT, (LPSTR)NULL, 
			   WS_CHILD|WS_VISIBLE|WS_BORDER|WS_TABSTOP|ES_RIGHT,
			   region_repeat_interval_left, region_repeat_interval_top,
			   BUF_REPEAT_INTERVAL_LEN*F16_WIDTH+4, F16_HEIGHT+4,
			   ghAddWin, (HMENU)ID_EDIT_REPEAT_INTERVAL,
			   ghTaskInstance);
	if (hEditRepeatInterval == NULL){
	    return false;
	}
    }

    /* xRg[쐬 */
    hStaticLabel =
	mgCreateWindow(STATIC, (LPSTR)NULL, 
		       WS_CHILD|WS_VISIBLE|WS_BORDER|SS_CENTER|SS_PUSH,
		       region_label_left, region_label_top,
		       BUF_LABEL_LEN*F16_WIDTH+4, F16_HEIGHT+4,
		       ghAddWin, (HMENU)ID_STATIC_LABEL,
		       ghTaskInstance);
    if (hStaticLabel == NULL){
	return false;
    }

mgDPrintf("create fin");

    /* ʒuϐiāj */
    Add_InitRegion();

    /* Rg[̏ݒ */
    Add_InitControls();

    /* tH[JẌړ */
    mgSetFocus(hEditDescription);

    /* t̕ۑ */
    prev_start_date = getStartDateByBuf();
    if (hasEndDate(dialog_mode)){
	prev_end_date = getEndDateByBuf();
    }

    return true;
}

/* ʒuϐ */
static bool
Add_InitRegion(void)
{
    switch (dialog_size){
	case DIALOG_NORMAL:
	description_cols = 53;
	description_rows = 3;
	region_dialog_width = 483;
	region_dialog_height = 193;
	region_title_left = (region_dialog_width-(F16_WIDTH*strlen(dialogTitle[dialog_mode])))/2;
	region_title_top = 6;
	region_description_left = 22;
	region_description_top = EDIT_1stLINE_NORMAL;
	region_start_date_left = 22;
	region_start_date_top = EDIT_2ndLINE_NORMAL;
	region_end_date_left = 22+186;
	region_end_date_top = EDIT_2ndLINE_NORMAL;
	region_start_time_left = 22;
	region_start_time_top = EDIT_3rdLINE_NORMAL;
	region_end_time_left = 22+94;
	region_end_time_top = EDIT_3rdLINE_NORMAL;
	region_rank_left = 22+186;
	region_rank_top = EDIT_2ndLINE_NORMAL;
	region_repeat_left = 22+186;
	region_repeat_top = EDIT_3rdLINE_NORMAL;
	region_repeat_width = 14*F16_WIDTH+24;
	region_repeat_height = 3*(F16_HEIGHT+4)+4;
	region_repeat_label_left = region_repeat_left-8*F16_WIDTH-4;
	region_repeat_label_top = region_repeat_top+2*(F16_HEIGHT+4)+4;
	region_repeat_interval_left = region_repeat_left+150;
	region_repeat_interval_top = region_repeat_top+2*(F16_HEIGHT+4)+2;
	region_label_left = 22;
	region_label_top = EDIT_5thLINE_NORMAL;
	break;

	case DIALOG_LARGE:
	description_cols = 74;
	description_rows = 5;
	region_dialog_width = 640;
	region_dialog_height = 201;
	region_title_left = (region_dialog_width-(F16_WIDTH*strlen(dialogTitle[dialog_mode])))/2;
	region_title_top = 6;
	region_description_left = 22;
	region_description_top = EDIT_1stLINE_LARGE;
	region_start_date_left = 22;
	region_start_date_top = EDIT_2ndLINE_LARGE;
	region_end_date_left = 22+186;
	region_end_date_top = EDIT_2ndLINE_LARGE;
	region_start_time_left = 22;
	region_start_time_top = EDIT_3rdLINE_LARGE;
	region_end_time_left = 22+94;
	region_end_time_top = EDIT_3rdLINE_LARGE;
	region_rank_left = 22+186;
	region_rank_top = EDIT_2ndLINE_LARGE;
	region_repeat_left = 22+186+16*11;
	region_repeat_top = EDIT_2ndLINE_LARGE;
	region_repeat_width = 14*F16_WIDTH+24;
	region_repeat_height = 3*(F16_HEIGHT+4)+4;
	region_repeat_label_left = region_repeat_left-8*F16_WIDTH-4;
	region_repeat_label_top = region_repeat_top+2*(F16_HEIGHT+4)+4;
	region_repeat_interval_left = region_repeat_left+150;
	region_repeat_interval_top = region_repeat_top+2*(F16_HEIGHT+4)+2;
	region_label_left = 22+526;
	region_label_top = EDIT_2ndLINE_LARGE;
	break;

	case DIALOG_SMALL:
	description_cols = 23;
	description_rows = 2;
	region_dialog_width = 212;
	region_dialog_height = 201;
	region_title_left = (region_dialog_width-(F16_WIDTH*strlen(dialogTitle[dialog_mode])))/2;
	region_title_top = 6;
	region_description_left = 10;
	region_description_top = EDIT_1stLINE_SMALL;
	region_start_date_left = 10;
	region_start_date_top = EDIT_2ndLINE_SMALL;
	region_end_date_left = 10+16;
	region_end_date_top = EDIT_3rdLINE_SMALL;
	region_start_time_left = 10;
	region_start_time_top = EDIT_4thLINE_SMALL;
	region_end_time_left = 10+94;
	region_end_time_top = EDIT_4thLINE_SMALL;
	region_rank_left = 10;
	region_rank_top = EDIT_3rdLINE_SMALL;
	region_repeat_left = 10;
	region_repeat_top = EDIT_5thLINE_SMALL;
	region_repeat_width = 14*F12_WIDTH+27;
	region_repeat_height = 3*(F12_HEIGHT+3)+6;
	region_repeat_label_left = region_repeat_left-8*F12_WIDTH-4;
	region_repeat_label_top = region_repeat_top+2*(F12_HEIGHT+3)+4;
	region_repeat_interval_left = region_repeat_left+115;;
	region_repeat_interval_top = region_repeat_top+2*(F12_HEIGHT+3)+2-2;
	region_label_left = 125;
	region_label_top = EDIT_5thLINE_SMALL;
	break;
    }

    region_dialog_left = 0;
    region_dialog_top = 0;
    region_dialog_right = region_dialog_width - 1;
    region_dialog_bottom = region_dialog_height - 1;

    return true;
}

/* Rg[̏ݒ */
static void
Add_InitControls(void)
{
    uint16 year, month, day, dayWeek;
    char *buf = bufGeneric;

mgDPrintf("hoge");

    /* LqRg[̏ݒ */
    memset(bufDescription, 0, BUF_DESCRIPTION_LEN);
    if (isAddMode(dialog_mode)){
	buf[0] = '\0';
	GenDlg_InitEditControl(hEditDescription, bufDescription, BUF_DESCRIPTION_LEN, buf);
    }else{
	memcpy(buf, editRecord->descript, editRecord->descript_len);
	buf[editRecord->descript_len] = '\0';
	GenDlg_InitEditControl(hEditDescription, bufDescription, BUF_DESCRIPTION_LEN, buf);
    }
    /* sʒu̎w */
    mgSendMessage(hEditDescription, EM_SETWIDTH,
		  (WORD)description_cols, (LPARAM)0);

mgDPrintf("hoge");

    /* tRg[̏ݒ */
    if (isAddMode(dialog_mode)){
	Calendar_GetDateByNo(gCursorDate, &year, &month, &day);
	sprintf(buf, "%d", year);
	GenDlg_InitEditControl(hEditStartYear, bufStartYear, BUF_START_YEAR_LEN, buf);
	sprintf(buf, "%d", month);
	GenDlg_InitEditControl(hEditStartMonth, bufStartMonth, BUF_START_MONTH_LEN, buf);
	sprintf(buf, "%d", day);
	GenDlg_InitEditControl(hEditStartDay, bufStartDay, BUF_START_DAY_LEN, buf);
	if (hasEndDate(dialog_mode)){
	    sprintf(buf, "%d", year);
	    GenDlg_InitEditControl(hEditEndYear, bufEndYear, BUF_END_YEAR_LEN, buf);
	    sprintf(buf, "%d", month);
	    GenDlg_InitEditControl(hEditEndMonth, bufEndMonth, BUF_END_MONTH_LEN, buf);
	    sprintf(buf, "%d", day);
	    GenDlg_InitEditControl(hEditEndDay, bufEndDay, BUF_END_DAY_LEN, buf);
	}
    }else{
	Calendar_GetDateByNo(editRecord->start_date, &year, &month, &day);
	sprintf(buf, "%d", year);
	GenDlg_InitEditControl(hEditStartYear, bufStartYear, BUF_START_YEAR_LEN, buf);
	sprintf(buf, "%d", month);
	GenDlg_InitEditControl(hEditStartMonth, bufStartMonth, BUF_START_MONTH_LEN, buf);
	sprintf(buf, "%d", day);
	GenDlg_InitEditControl(hEditStartDay, bufStartDay, BUF_START_DAY_LEN, buf);
	if (hasEndDate(dialog_mode)){
	    Calendar_GetDateByNo(editRecord->end_date, &year, &month, &day);
	    sprintf(buf, "%d", year);
	    GenDlg_InitEditControl(hEditEndYear, bufEndYear, BUF_END_YEAR_LEN, buf);
	    sprintf(buf, "%d", month);
	    GenDlg_InitEditControl(hEditEndMonth, bufEndMonth, BUF_END_MONTH_LEN, buf);
	    sprintf(buf, "%d", day);
	    GenDlg_InitEditControl(hEditEndDay, bufEndDay, BUF_END_DAY_LEN, buf);
	}
    }
    
mgDPrintf("hoge");
    /* j̃Rg[ݒ */
    if (isAddMode(dialog_mode)){
	dayWeek = Calendar_GetDayOfWeekByNo(gCursorDate);
	mgSendMessage(hStaticStartDayWeek, WM_SETTEXT,
		      (WORD)0, (LPARAM)nameDayWeek[dayWeek]);
	if (hasEndDate(dialog_mode)){
	    mgSendMessage(hStaticEndDayWeek, WM_SETTEXT,
			  (WORD)0, (LPARAM)nameDayWeek[dayWeek]);
	}
    }else{
	dayWeek = Calendar_GetDayOfWeekByNo(editRecord->start_date);
	mgSendMessage(hStaticStartDayWeek, WM_SETTEXT,
		      (WORD)0, (LPARAM)nameDayWeek[dayWeek]);
	if (hasEndDate(dialog_mode)){
	    dayWeek = Calendar_GetDayOfWeekByNo(editRecord->end_date);
	    mgSendMessage(hStaticEndDayWeek, WM_SETTEXT,
			  (WORD)0, (LPARAM)nameDayWeek[dayWeek]);
	}
    }

mgDPrintf("hoge");
    /* Rg[̏lݒ */
    if (hasTime(dialog_mode) && isAddMode(dialog_mode)){
	if (View_HasTimeTable()){
	    if (gCursorHour+gCursorHourRange < 24){
		sprintf(buf, "%d", gCursorHour);
		GenDlg_InitEditControl(hEditStartHour, bufStartHour, BUF_START_HOUR_LEN, buf);
		sprintf(buf, "%d", gCursorHour+gCursorHourRange);
		GenDlg_InitEditControl(hEditEndHour, bufEndHour, BUF_END_HOUR_LEN, buf);
		sprintf(buf, "0");
		GenDlg_InitEditControl(hEditStartMin, bufStartMin, BUF_START_MIN_LEN, buf);
		GenDlg_InitEditControl(hEditEndMin, bufEndMin, BUF_END_MIN_LEN, buf);
	    }else{
		sprintf(buf, "%d", gCursorHour);
		GenDlg_InitEditControl(hEditStartHour, bufStartHour, BUF_START_HOUR_LEN, buf);
		sprintf(buf, "24");
		GenDlg_InitEditControl(hEditEndHour, bufEndHour, BUF_END_HOUR_LEN, buf);
		sprintf(buf, "0");
		GenDlg_InitEditControl(hEditStartMin, bufStartMin, BUF_START_MIN_LEN, buf);
		sprintf(buf, "0");
		GenDlg_InitEditControl(hEditEndMin, bufEndMin, BUF_END_MIN_LEN, buf);
	    }
	}else{
	    sprintf(buf, "--");
	    GenDlg_InitEditControl(hEditStartHour, bufStartHour, BUF_START_HOUR_LEN, buf);
	    GenDlg_InitEditControl(hEditEndHour, bufEndHour, BUF_END_HOUR_LEN, buf);
	    GenDlg_InitEditControl(hEditStartMin, bufStartMin, BUF_START_MIN_LEN, buf);
	    GenDlg_InitEditControl(hEditEndMin, bufEndMin, BUF_END_MIN_LEN, buf);
	}
    }else if (hasTime(dialog_mode) && isEditMode(dialog_mode)){
	if (editRecord->u.sche.end_time_h == 0 && editRecord->u.sche.end_time_h == 0){
	    sprintf(buf, "--");
	    GenDlg_InitEditControl(hEditStartHour, bufStartHour, BUF_START_HOUR_LEN, buf);
	    GenDlg_InitEditControl(hEditEndHour, bufEndHour, BUF_END_HOUR_LEN, buf);
	    GenDlg_InitEditControl(hEditStartMin, bufStartMin, BUF_START_MIN_LEN, buf);
	    GenDlg_InitEditControl(hEditEndMin, bufEndMin, BUF_END_MIN_LEN, buf);
	}else{
	    sprintf(buf, "%d", editRecord->u.sche.start_time_h);
	    GenDlg_InitEditControl(hEditStartHour, bufStartHour, BUF_START_HOUR_LEN, buf);
	    sprintf(buf, "%d", editRecord->u.sche.start_time_m);
	    GenDlg_InitEditControl(hEditStartMin, bufStartMin, BUF_START_MIN_LEN, buf);
	    sprintf(buf, "%d", editRecord->u.sche.end_time_h);
	    GenDlg_InitEditControl(hEditEndHour, bufEndHour, BUF_END_HOUR_LEN, buf);
	    sprintf(buf, "%d", editRecord->u.sche.end_time_m);
	    GenDlg_InitEditControl(hEditEndMin, bufEndMin, BUF_END_MIN_LEN, buf);
	}
    }

mgDPrintf("hoge");
    /* NRg[̏ݒ */
    if (hasRank(dialog_mode) && isAddMode(dialog_mode)){
	sprintf(buf, "%d", 3);
	GenDlg_InitEditControl(hEditRank, bufRank, BUF_RANK_LEN, buf);
    }else if (hasRank(dialog_mode) && isEditMode(dialog_mode)){
	sprintf(buf, "%d", editRecord->u.task.rank);
	GenDlg_InitEditControl(hEditRank, bufRank, BUF_RANK_LEN, buf);
    }    

    /* JԂRg[ݒ */
    if (hasRepeat(dialog_mode)){
	if (dialog_size == DIALOG_SMALL){
	    mgSendMessage(hListRepeat, WM_SETFONT,
			  (WORD)F12_FNT, (LPARAM)MAKELONG((WORD)FALSE,0));
	}
    }
    if (hasRepeat(dialog_mode) && isAddMode(dialog_mode)){
	local_repeat_type = REPEAT_TYPE_NONE;
	Add_InitRepeatControl(gCursorDate);
	sprintf(buf, "%d", 1);
	GenDlg_InitEditControl(hEditRepeatInterval, bufRepeatInterval,
			    BUF_REPEAT_INTERVAL_LEN, buf);
    }else if (hasRepeat(dialog_mode) && isEditMode(dialog_mode)){
	local_repeat_type = editRecord->repeat_type;
	Add_InitRepeatControl(editRecord->start_date);
	if (editRecord->repeat_every < 1)
	    editRecord->repeat_every = 1;
	sprintf(buf, "%d", editRecord->repeat_every);
	GenDlg_InitEditControl(hEditRepeatInterval, bufRepeatInterval,
			    BUF_REPEAT_INTERVAL_LEN, buf);
    }    

mgDPrintf("hoge");
    /* x̏ݒ */
    if (isAddMode(dialog_mode)){
	if (gOpt_Label1Default){
	    Add_SetLabel(1);
	}else{
	    if (gLabel < 5){
		Add_SetLabel(gLabel);
	    }else{
		Add_SetLabel(0);
	    }
	}
    }else{
	Add_SetLabel(editRecord->label);
    }
}

/* AddЕt */
static bool
Add_Destroy(void)
{
    D(mgDPrintf("Add destroy\n"));

    if (kanji_on){
	IMESTRUCT imeStruct;
	/* IMEOFF */
	imeStruct.fnc = IME_SETOPEN;
	imeStruct.wParam = 0;
	mgSendIMEMessage(ghAddWin, (LPARAM)&imeStruct);
    }
 
    mgDestroyWindow(hEditDescription);

    mgDestroyWindow(hEditStartYear);
    mgDestroyWindow(hEditStartMonth);
    mgDestroyWindow(hEditStartDay);
    if (hasEndDate(dialog_mode)){
	mgDestroyWindow(hEditEndYear);
	mgDestroyWindow(hEditEndMonth);
	mgDestroyWindow(hEditEndDay);
    }

    mgDestroyWindow(hStaticStartDayWeek);
    if (hasEndDate(dialog_mode)){
	mgDestroyWindow(hStaticEndDayWeek);
    }

    if (hasTime(dialog_mode)){
	mgDestroyWindow(hEditStartHour);
	mgDestroyWindow(hEditStartMin);
	mgDestroyWindow(hEditEndHour);
	mgDestroyWindow(hEditEndMin);
    }

    if (hasRank(dialog_mode)){
	mgDestroyWindow(hEditRank);
    }    

    if (hasRepeat(dialog_mode)){
	mgDestroyWindow(hListRepeat);
	mgDestroyWindow(hEditRepeatInterval);
    }    

    mgDestroyWindow(hStaticLabel);

    /* t@NVL[L */
    FuncKey_SetMainMode();

    gMode = MODE_VIEW;

    return true;
}

/* JԂRg[̏ݒ */
static void
Add_InitRepeatControl(uint16 date)
{
    memset(bufRepeat, 0, BUF_REPEAT_LEN+1);
    mgSendMessage(hListRepeat, LB_SETFHANDLE,
		  (WORD)(BUF_REPEAT_LEN+1), (LPARAM)(LPSTR)bufRepeat);

    /* ȅݒ */
    Add_ResetRepeatControl(date);
}

/* JԂRg[̍Đݒ */
static void
Add_ResetRepeatControl(uint16 date)
{
    uint16 year, month, day, dayWeek, nthWeek, numOfDays;
    int no;
    char buf[16];
    char *kanjiNum[] = {
	"", "", "", "O", "l", "",
    };

    /* 3/13/1998̏ꍇ		\
       REPEAT_TYPE_NONE		Ȃ
       REPEAT_TYPE_DAILY	
       REPEAT_TYPE_WEEKLY	j
       REPEAT_TYPE_MONTHLYDAY	13
       REPEAT_TYPE_MONTHLYWEEK	2j
       REPEAT_TYPE_YEARLYDAY	313
       REPEAT_TYPE_YEARLYWEEK	32j
       */

    Calendar_GetDateByNo(date, &year, &month, &day);
    dayWeek = Calendar_GetDayOfWeekByNo(date);
    nthWeek = (day / 7)+((day%7)?1:0);
    numOfDays = Calendar_GetNumOfDays(year, month);

    /* NA */
    mgSendMessage(hListRepeat, LB_RESETCONTENT, 0, 0);
    no = 0;

    /* REPEAT_TYPE_NONE */
    mgSendMessage(hListRepeat, LB_INSERTSTRING, no++, (LPARAM)(LPSTR)"Ȃ");
    
    /* REPEAT_TYPE_DAILY */
    mgSendMessage(hListRepeat, LB_INSERTSTRING, no++, (LPARAM)(LPSTR)"");
    
    /* REPEAT_TYPE_WEEKLY */
    sprintf(buf, "%sj", nameDayWeek[dayWeek]);
    mgSendMessage(hListRepeat, LB_INSERTSTRING, no++, (LPARAM)(LPSTR)buf);

    /* REPEAT_TYPE_MONTHLYDAY */
    sprintf(buf, "%d", day);
    mgSendMessage(hListRepeat, LB_INSERTSTRING, no++, (LPARAM)(LPSTR)buf);

    /* REPEAT_TYPE_MONTHLYWEEK */
    if (numOfDays-day >= 7){
	sprintf(buf, "%s%sj", kanjiNum[nthWeek], nameDayWeek[dayWeek]);
	mgSendMessage(hListRepeat, LB_INSERTSTRING, no++, (LPARAM)(LPSTR)buf);
    }else{
	sprintf(buf, "ŏI%sj", nameDayWeek[dayWeek]);
	mgSendMessage(hListRepeat, LB_INSERTSTRING, no++, (LPARAM)(LPSTR)buf);
    }

    /* REPEAT_TYPE_YEARLYDAY */
    sprintf(buf, "%d%d", month, day);
    mgSendMessage(hListRepeat, LB_INSERTSTRING, no++, (LPARAM)(LPSTR)buf);

    /* REPEAT_TYPE_YEARLYWEEK */
    if (numOfDays-day >= 7){
	sprintf(buf, "%d%s%sj", month, kanjiNum[nthWeek], nameDayWeek[dayWeek]);
	mgSendMessage(hListRepeat, LB_INSERTSTRING, no++, (LPARAM)(LPSTR)buf);
    }else{
	sprintf(buf, "%dŏI%sj", month, nameDayWeek[dayWeek]);
	mgSendMessage(hListRepeat, LB_INSERTSTRING, no++, (LPARAM)(LPSTR)buf);
    }

    /* ݂̑IlɃZbg */
    mgSendMessage(hListRepeat, LB_SETCURSEL, (WPARAM)local_repeat_type, 0);
}

/* JԂRg[̒l擾 */
static void
Add_GetRepeatControl(void)
{
    LRESULT r;

    r = mgSendDlgItemMessage(ghAddWin, ID_LIST_REPEAT, LB_GETCURSEL, 0, 0);
    local_repeat_type = LOBYTE(LOWORD(r));
}

/* x̐ݒ */
static void
Add_SetLabel(uint16 label)
{
    local_label = label;
    mgSendMessage(hStaticLabel, WM_SETTEXT,
		  (WORD)0, (LPARAM)Context_GetLabelName(local_label));
}

/* AddEBhEĕ` */
static void
Add_Redraw(void)
{
    HDC hDC;
    PAINTSTRUCT ps;

    hDC = mgBeginPaint(ghAddWin, (LPPAINTSTRUCT)&ps);

    /* g */
    mgSelectStockObject(hDC, CL_WHITE|SOLID_PEN|SIZE1_PEN);
    mgMoveTo(hDC, region_dialog_left, region_dialog_top);
    mgLineTo(hDC, region_dialog_right, region_dialog_top);
    mgMoveTo(hDC, region_dialog_left, region_dialog_top);
    mgLineTo(hDC, region_dialog_left, region_dialog_bottom);
    mgMoveTo(hDC, region_dialog_left, region_dialog_top+1);
    mgLineTo(hDC, region_dialog_right, region_dialog_top+1);
    mgMoveTo(hDC, region_dialog_left+1, region_dialog_top);
    mgLineTo(hDC, region_dialog_left+1, region_dialog_bottom);
    mgSelectStockObject(hDC, CL_DKGRAY|SOLID_PEN|SIZE1_PEN);
    mgMoveTo(hDC, region_dialog_left, region_dialog_bottom-1);
    mgLineTo(hDC, region_dialog_right, region_dialog_bottom-1);
    mgMoveTo(hDC, region_dialog_right-1, region_dialog_top);
    mgLineTo(hDC, region_dialog_right-1, region_dialog_bottom);
    mgMoveTo(hDC, region_dialog_left+1, region_dialog_bottom-2);
    mgLineTo(hDC, region_dialog_right, region_dialog_bottom-2);
    mgMoveTo(hDC, region_dialog_right-2, region_dialog_top+1);
    mgLineTo(hDC, region_dialog_right-2, region_dialog_bottom);

    mgSetBkMode(hDC, TRANSPARENT);
    mgSetTextColor(hDC, CL_BLACK);

    /* ^Cg */
    mgSelectStockObject(hDC, CL_BLACK|SOLID_PEN|SIZE1_PEN|F16_FNT);
    mgTextOut(hDC, region_title_left, region_title_top,
	      dialogTitle[dialog_mode], strlen(dialogTitle[dialog_mode]));

    /* E */
    mgSelectStockObject(hDC, CL_BLACK|SOLID_PEN|SIZE1_PEN);
    mgMoveTo(hDC, region_dialog_left+20, region_dialog_top+F16_HEIGHT+10);
    mgLineTo(hDC, region_dialog_right-20, region_dialog_top+F16_HEIGHT+10);

    /* t̊ */
    mgSelectStockObject(hDC, CL_BLACK|SOLID_PEN|SIZE1_PEN|F16_FNT);
    mgTextOut(hDC, region_start_date_left+4*F16_WIDTH+1*8-2, region_start_date_top+2, "N", 2);
    mgTextOut(hDC, region_start_date_left+8*F16_WIDTH+2*8-2, region_start_date_top+2, "", 2);
    mgTextOut(hDC, region_start_date_left+12*F16_WIDTH+3*8-2, region_start_date_top+2, "", 2);
    mgTextOut(hDC, region_start_date_left+14*F16_WIDTH+3*8-2, region_start_date_top+2, "(", 1);
    mgTextOut(hDC, region_start_date_left+17*F16_WIDTH+3*8, region_start_date_top+2, ")", 1);
    if (hasEndDate(dialog_mode)){
	mgTextOut(hDC, region_start_date_left+17*F16_WIDTH+4*8, region_start_date_top+2, "`", 2);
	mgTextOut(hDC, region_end_date_left+4*F16_WIDTH+1*8-2, region_end_date_top+2, "N", 2);
	mgTextOut(hDC, region_end_date_left+8*F16_WIDTH+2*8-2, region_end_date_top+2, "", 2);
	mgTextOut(hDC, region_end_date_left+12*F16_WIDTH+3*8-2, region_end_date_top+2, "", 2);
	mgTextOut(hDC, region_end_date_left+14*F16_WIDTH+3*8-2, region_end_date_top+2, "(", 1);
	mgTextOut(hDC, region_end_date_left+17*F16_WIDTH+3*8, region_end_date_top+2, ")", 1);
    }

    /* ̊ */
    if (hasTime(dialog_mode)){
	mgSelectStockObject(hDC, CL_BLACK|SOLID_PEN|SIZE1_PEN|F16_FNT);
	mgTextOut(hDC, region_start_time_left+2*F16_WIDTH+1*8-2, region_start_time_top+2, "", 2);
	mgTextOut(hDC, region_start_time_left+6*F16_WIDTH+2*8-2, region_start_time_top+2, "`", 4);
	mgTextOut(hDC, region_end_time_left+2*F16_WIDTH+1*8-2, region_end_time_top+2, "", 2);
	mgTextOut(hDC, region_end_time_left+6*F16_WIDTH+2*8-2, region_end_time_top+2, "", 4);
    }

    /* N */
    if (hasRank(dialog_mode)){
	mgSelectStockObject(hDC, CL_BLACK|SOLID_PEN|SIZE1_PEN|F16_FNT);
	mgTextOut(hDC, region_rank_left, region_rank_top+2, "N", 6);
    }

    /* JԂ */
    if (hasRepeat(dialog_mode)){
	mgSelectStockObject(hDC, CL_BLACK|SOLID_PEN|SIZE1_PEN|F16_FNT);
	if (dialog_size != DIALOG_SMALL){
	    mgTextOut(hDC, region_repeat_label_left, region_repeat_label_top, "JԂ", 8);
	}
	mgTextOut(hDC, region_repeat_interval_left+F16_WIDTH*2+6, region_repeat_interval_top+2, "", 6);
    }

    mgEndPaint(ghAddWin, (LPPAINTSTRUCT)&ps);
}

/* t̒l͈̔͂ */
static bool
Add_FixDateRange(bool fix_end)
{
    uint16 start_date, end_date;

    D(mgDPrintf("fixing value range"));

    /* `FbN */
    start_date = getStartDateByBuf();
    if (hasEndDate(dialog_mode)){
	end_date = getEndDateByBuf();
    }

    /*  */
    if (hasEndDate(dialog_mode)){
	if (start_date > end_date){
	    if (!fix_end){
		GenDlg_ResetControl(hEditStartYear, bufEndYear);
		GenDlg_ResetControl(hEditStartMonth, bufEndMonth);
		GenDlg_ResetControl(hEditStartDay, bufEndDay);
		start_date = end_date;
	    }else{
		GenDlg_ResetControl(hEditEndYear, bufStartYear);
		GenDlg_ResetControl(hEditEndMonth, bufStartMonth);
		GenDlg_ResetControl(hEditEndDay, bufStartDay);
		end_date = start_date;
	    }
	}
    }
    
    /* j̐ݒ */
    mgSendMessage(hStaticStartDayWeek, WM_SETTEXT,
		  (WORD)0, (LPARAM)nameDayWeek[Calendar_GetDayOfWeekByNo(start_date)]);
    if (hasEndDate(dialog_mode)){
	mgSendMessage(hStaticEndDayWeek, WM_SETTEXT,
		      (WORD)0, (LPARAM)nameDayWeek[Calendar_GetDayOfWeekByNo(end_date)]);
    }

    return false;
}

/* l͈̔͂ */
static bool
Add_FixTimeRange(bool fix_end)
{
    uint16 start_hour, end_hour;
    uint16 start_min, end_min;

    start_hour = atoi(bufStartHour);
    start_min = atoi(bufStartMin);
    end_hour = atoi(bufEndHour);
    end_min = atoi(bufEndMin);

    /* QS`FbN */
    if (start_hour == 24 && start_min > 0){
	GenDlg_ResetControl(hEditStartMin, "0");
	start_min = 0;
    }
    if (end_hour == 24 && end_min > 0){
	GenDlg_ResetControl(hEditEndMin, "0");
	end_min = 0;
    }

    /* O֌W`FbN */
    if (start_hour * 60+start_min <= end_hour * 60+end_min){
	return true;
    }

    /*  */
    if (!fix_end){
	if (end_hour == 0){
	    GenDlg_ResetControl(hEditEndHour, "0");
	}
	if (end_min == 0){
	    GenDlg_ResetControl(hEditEndMin, "0");
	}
	GenDlg_ResetControl(hEditStartHour, bufEndHour);
	GenDlg_ResetControl(hEditStartMin, bufEndMin);
    }else{
	if (start_hour == 0){
	    GenDlg_ResetControl(hEditStartHour, "0");
	}
	if (start_min ==0){
	    GenDlg_ResetControl(hEditStartMin, "0");
	}
	GenDlg_ResetControl(hEditEndHour, bufStartHour);
	GenDlg_ResetControl(hEditEndMin, bufStartMin);
    }

    return false;
}

/* tH[JXȂȂƂ̏ */
static bool
Add_LostFocus(WPARAM id, WPARAM win)
{
    bool r;
    static bool checking = false;
    uint16 start_date, end_date;

    if (checking){
	/* Qd`FbNh~ */
	return true;
    }

    /* l`FbN */
    switch (id){
	case ID_LIST_REPEAT:
	Add_GetRepeatControl();
	if (local_repeat_type != REPEAT_TYPE_NONE
	    && getStartDateByBuf() == getEndDateByBuf()){
	    /* JԂw肳Ă̂ɊԂO */
	    /* I̔NP₷ */
	    char buf[10];
	    sprintf(buf, "%d", atoi(bufEndYear)+1);
	    GenDlg_ResetControl(hEditEndYear, buf);
	}
	checking = false;
	return true;
	break;
	case ID_EDIT_DESCRIPTION:
	checking = false;
	return true;
	break;
    }
    checking = true;
    r = GenDlg_CheckValueRange(win);
    checking = false;
    if (r == false){
	char buf[5];
	sprintf(buf, "%d", focus_min_val);
	GenDlg_ResetControl(win, buf);
	mgSendMessage(win, EM_SETSEL, 0, MAKELPARAM(0, -1));
	return false;
    }

    start_date = getStartDateByBuf();
    end_date = getEndDateByBuf();
    if (start_date == prev_start_date && end_date == prev_end_date){
	/* t̕ύXȂ */

	/* l͈̔͂ */
	switch (id){
	    case ID_EDIT_START_HOUR:
	    case ID_EDIT_START_MIN:
	    Add_FixTimeRange(true);
	    break;
	    case ID_EDIT_END_HOUR:
	    case ID_EDIT_END_MIN:
	    Add_FixTimeRange(false);
	    break;
	}
    }else{
	/* t̕ύX */

	/* l͈̔͂ */
	switch (id){
	    case ID_EDIT_START_YEAR:
	    case ID_EDIT_START_MONTH:
	    case ID_EDIT_START_DAY:
	    Add_FixDateRange(true);
	    break;
	    case ID_EDIT_END_YEAR:
	    case ID_EDIT_END_MONTH:
	    case ID_EDIT_END_DAY:
	    Add_FixDateRange(false);
	    break;
	}

	start_date = getStartDateByBuf();

	/* JԂXg̍XV */
	if (hasRepeat(dialog_mode)){
	    if (start_date != prev_start_date){
		Add_ResetRepeatControl(start_date);
	    }
	}

	/* t̕ۑ */
	prev_start_date = start_date;
	prev_end_date = end_date;
    }

    return true;
}

/* o^ */
static bool
Add_Register(void)
{
    Record *rec;
    bool r;

    D(mgDPrintf("try register"));

    /* l̐`FbN */
    if (value_invalid){
	D(mgDPrintf("value invalid"));
	return false;
    }
    if (strlen(bufDescription) <= 0){
	D(mgDPrintf("value invalid"));
	return false;
    }

    D(mgDPrintf("allocate record"));

    /* R[h蓖 */
    rec = Record_AllocateRecord(1);
    if (rec == nil){
	return false;
    }

    /* R[h̏ */
    if (isAddMode(dialog_mode)){
	memset(rec, 0, sizeof(Record));
    }else{
	memcpy(rec, editRecord, sizeof(Record));
    }

    rec->len = sizeof(Record);		      /* NOTE: This may be error. */

    /* Lq */
    rec->descript_len = strlen(bufDescription);
    rec->descript = Record_AllocateByte(rec->descript_len);
    if (rec->descript == nil){
	return false;
    }
    memcpy(rec->descript, bufDescription, rec->descript_len);

    /* tEEN */
    switch (dialog_mode){
	case ADDITEM_SCHEDULE:
	case EDITITEM_SCHEDULE:
	rec->type = RECORD_TYPE_SCHEDULE;
	rec->start_date = getStartDateByBuf();
	rec->end_date = getEndDateByBuf();
	rec->u.sche.start_time_h = (uint8)atoi(bufStartHour);
	rec->u.sche.start_time_m = (uint8)atoi(bufStartMin);
	rec->u.sche.end_time_h = (uint8)atoi(bufEndHour);
	rec->u.sche.end_time_m = (uint8)atoi(bufEndMin);
	break;

	case ADDITEM_TASK:
	case EDITITEM_TASK:
	rec->type = RECORD_TYPE_TASK;
	rec->start_date = getStartDateByBuf();
	rec->end_date = DATE_THE_END;
	rec->u.task.rank = (uint8)atoi(bufRank);
	break;

	case ADDITEM_HOLIDAY:
	case EDITITEM_HOLIDAY:
	rec->type = RECORD_TYPE_HOLIDAY;
	rec->start_date = getStartDateByBuf();
	rec->end_date = getEndDateByBuf();
	break;

	default:
	break;
    }

    /* JԂ */
    if (hasRepeat(dialog_mode)){
	uint16 year, month, day, dayWeek, nthWeek, numOfDays;

	Calendar_GetDateByNo(rec->start_date, &year, &month, &day);
	dayWeek = Calendar_GetDayOfWeekByNo(rec->start_date);
	nthWeek = (day / 7)+((day%7)?1:0);
	numOfDays = Calendar_GetNumOfDays(year, month);

	Add_GetRepeatControl();
	if (numOfDays-day < 7){
	    nthWeek = 5;
	}
	rec->repeat_type = local_repeat_type;
	rec->repeat_every = (uint8)atoi(bufRepeatInterval);
	switch (rec->repeat_type){
	    case REPEAT_TYPE_WEEKLY:
	    rec->repeat_arg1 = gDayOfWeekBit[dayWeek];
	    break;
	    case REPEAT_TYPE_MONTHLYWEEK:
	    case REPEAT_TYPE_YEARLYWEEK:
	    rec->repeat_arg1 = gNthWeekBit[nthWeek];
	    rec->repeat_arg2 = gDayOfWeekBit[dayWeek];
	    break;
	}
    }else{
	rec->repeat_type = REPEAT_TYPE_NONE;
    }

    /* x */
    rec->label = local_label;

    /* N̎ */
    if (gCurrentView == VIEW_BROWSER && ViewFile_CheckFile()){
	D(mgDPrintf("made a link automatically"));
	rec->link_len = strlen(gSelectedFile);
	rec->link = Record_AllocateByte(rec->link_len);
	memcpy(rec->link, gSelectedFile, rec->link_len);
    }

    /* R[h̓o^ */
    r = Record_Register(rec);
    if (!r){
	D(mgDPrintf("Record_Register failed"));
	return false;
    }
    gDBDirty = true;

    D(mgDPrintf("Record_Register success"));

    /* LbV̖ */
    MonthRec_Invalidate();

    return true;
}

/* ҏWׂR[hݒ */
static void
Add_SetEditRecord(Record *rec)
{
    editRecord = rec;
}

/* _CAOTCY̎擾 */
static char *
View_GetDialog(void)
{
    if (gCurrentView == VIEW_BROWSER){
	D(mgDPrintf("use SMALL DIALOG"));
	return "AddItemS";
    }else if (gOpt_LargeDialog){
	D(mgDPrintf("use LARGE DIALOG"));
	return "AddItemL";
    }else{
	D(mgDPrintf("use NORMAL DIALOG"));
	return "AddItem";
    }
}

/* ACe̕ҏW */
bool
Add_EditItem(uint16 date, int no)
{
    uint16 year, month, day;
    MonthRec *monthRec;
    Record *rec;
    int r;

    /* R[ho */
    Calendar_GetDateByNo(date, &year, &month, &day);
    monthRec = MonthRec_GetByMonthNo(Calendar_GetMonthNo(year, month));
    rec = monthRec->rec[day][no];

    /* ҏWׂR[hݒ */
    Add_SetEditRecord(rec);

    /* ҏW_CAO|bvAbv */
    switch (rec->type){
	case RECORD_TYPE_SCHEDULE:
	r = mgDialogBoxParam(ghTaskInstance,
			     (LPCSTR)View_GetDialog(),
			     ghMainWin,
			     (DLGPROC)AddWinProc,
			     (LPARAM)EDITITEM_SCHEDULE);
	break;
	case RECORD_TYPE_TASK:
	r = mgDialogBoxParam(ghTaskInstance,
			     (LPCSTR)View_GetDialog(),
			     ghMainWin,
			     (DLGPROC)AddWinProc,
			     (LPARAM)EDITITEM_TASK);
	break;
	case RECORD_TYPE_HOLIDAY:
	r = mgDialogBoxParam(ghTaskInstance,
			     (LPCSTR)View_GetDialog(),
			     ghMainWin,
			     (DLGPROC)AddWinProc,
			     (LPARAM)EDITITEM_HOLIDAY);
	break;
	default:
	r = true;
	break;
    }

    if (r){
	D(mgDPrintf("Dialog says add/mod succeeded"));
    }else{
	D(mgDPrintf("Dialog says add/mod failed"));
    }

    /* ύX̂̂o^ꂽ */

    if (r == true){
	/* 폜 */
	Record_Delete(rec);
	/* TODO: Ԃl̃`FbN */
	gDBDirty = true;

	/* LbV̖ */
	MonthRec_Invalidate();
    }

    return true;
}

/* ACe̍폜 */
bool
Add_DeleteItem(uint16 date, int no)
{
    uint16 year, month, day;
    MonthRec *monthRec;
    Record *rec;

    /* R[ho */
    Calendar_GetDateByNo(date, &year, &month, &day);
    monthRec = MonthRec_GetByMonthNo(Calendar_GetMonthNo(year, month));
    rec = monthRec->rec[day][no];

    /* 폜 */
    Record_Delete(rec);
    /* TODO: Ԃl̃`FbN */
    gDBDirty = true;

    /* LbV̖ */
    MonthRec_Invalidate();

    return true;
}

/* ACeDONEgO */
bool
Add_ToggleDoneItem(uint16 date, int no)
{
    uint16 year, month, day;
    MonthRec *monthRec;
    Record *rec;

    /* R[ho */
    Calendar_GetDateByNo(date, &year, &month, &day);
    monthRec = MonthRec_GetByMonthNo(Calendar_GetMonthNo(year, month));
    rec = monthRec->rec[day][no];

    if (rec->type != RECORD_TYPE_TASK){
	/* ^XNȊO͊֌WȂ */
	return false;
    }

    if (rec->done_len > 0){
	/* ɂ */
	rec->done_len = 0;
	rec->done = nil;
    }else{
	/* ɂ */
	rec->done_len = sizeof(uint16);
	rec->done = (uint16 *)Record_AllocateByte(sizeof(uint16));
	rec->done[0] = date;
    }
    /* NOTE: DONEɂ͖Ή */

    gDBDirty = true;

    /* LbV̖ */
    MonthRec_Invalidate();

    return true;
}

/* AddEBhEvV[W */
LRESULT CALLBACK
AddWinProc(HWND hSelf, UINT msg,
	   WPARAM wParam, LPARAM lParam,
	   POINT LPoint, POINT DPoint)
{
    bool r;

    switch (msg){
	case WM_INITDIALOG:		      /* _CAO */
	ghAddWin = hSelf;
	r = Add_Create(LOWORD(lParam));
	if (r){
	    return 0;			      /*  */
	}else{
	    return -1;			      /* ُ */
	}
	break;

	case WM_PAINT:			      /* ĕ` */
	Add_Redraw();
	return 1;
	break;

	case WM_KEYDOWN:		      /* L[R[h */
	switch (wParam){
	    case VK_KANJI:
	    if (!kanji_invalid){
		IMESTRUCT imeStruct;
		if (kanji_on){
		    kanji_on = false;
		    D(mgDPrintf("kanji off"));
		    /* IMEOFF */
		    imeStruct.fnc = IME_SETOPEN;
		    imeStruct.wParam = 0;
		    mgSendIMEMessage(ghAddWin, (LPARAM)&imeStruct);
		}else{
		    kanji_on = true;
		    D(mgDPrintf("kanji on"));
		    /* IMEON */
		    imeStruct.fnc = IME_SETOPEN;
		    imeStruct.wParam = 1;
		    mgSendIMEMessage(ghAddWin, (LPARAM)&imeStruct);
		}
		return 1;
	    }
	    break;

	    case VK_RETURN:
	    D(mgDPrintf("register by RETURN key"));
	    mgSetFocus(hEditDescription);
	    r = Add_Register();
	    if (r){
		mgEndDialog(hSelf, true);
		return 1;
	    }else{
		return 1;
	    }
	    break;

	    case VK_ESCAPE:
	    D(mgDPrintf("got ESCAPE key, which is not out of operation"));
	    break;

	    case 'D':
	    if (mgGetKeyState(VK_CONTROL)){   /* CTRL+D */
		mgSetFocus(hEditDescription);
	    }
	    break;
	    case 'S':
	    if (mgGetKeyState(VK_CONTROL)){   /* CTRL+S */
		mgSetFocus(hEditStartYear);
	    }
	    break;
	    case 'E':
	    if (mgGetKeyState(VK_CONTROL)){   /* CTRL+E */
		if (hasEndDate(dialog_mode)){
		    mgSetFocus(hEditEndYear);
		}
	    }
	    break;
	    case 'T':
	    if (mgGetKeyState(VK_CONTROL)){   /* CTRL+T */
		if (hasEndDate(dialog_mode)){
		    mgSetFocus(hEditStartHour);
		}
	    }
	    break;
	    case 'R':
	    if (mgGetKeyState(VK_CONTROL)){   /* CTRL+R */
		if (hasRepeat(dialog_mode)){
		    mgSetFocus(hListRepeat);
		} else if (hasRank(dialog_mode)){
		    mgSetFocus(hEditRank);
		}
	    }
	    break;
	}

	case UWM_KEYALLOW:		      /*  */
	if (LOBYTE(lParam) == 2 && focus_inc_type != INC_TYPE_NONE){
	    /* ω */
	    GenDlg_ChangeByAllow(true);
	    return 1;
	}else if (LOBYTE(lParam) == 4 && focus_inc_type != INC_TYPE_NONE){
	    /* ω */
	    GenDlg_ChangeByAllow(false);
	}
	break;

	case WM_COMMAND:		      /* R}h */
	switch (wParam){
	    case ID_FUNC_OK:
	    mgSetFocus(hEditDescription);
	    r = Add_Register();
	    if (r){
		mgEndDialog(hSelf, true);
		return 1;
	    }else{
		return 1;
	    }
	    break;

	    case ID_FUNC_CANCEL:
	    mgEndDialog(hSelf, false);
	    return 1;
	    break;

	    case ID_FUNC_LABEL0:
	    Add_SetLabel(0);
	    return 1;
	    break;
	    case ID_FUNC_LABEL1:
	    Add_SetLabel(1);
	    return 1;
	    break;
	    case ID_FUNC_LABEL2:
	    Add_SetLabel(2);
	    return 1;
	    break;
	    case ID_FUNC_LABEL3:
	    Add_SetLabel(3);
	    return 1;
	    break;
	    case ID_FUNC_LABEL4:
	    Add_SetLabel(4);
	    return 1;
	    break;

	    case ID_KEY_ESCAPE:
	    D(mgDPrintf("got ESCAPE key"));
	    mgEndDialog(hSelf, false);
	    return 1;
	    break;

	    case ID_KEY_RETURN:
	    D(mgDPrintf("got RETURN key"));
	    mgSetFocus(next_focus);
	    return 1;
	    break;
	}
	if (HIWORD(lParam) == EN_SETFOCUS
	    || HIWORD(lParam) == LBN_SETFOCUS){
	    D(mgDPrintf("gain focus"));
	    GenDlg_GainFocus(wParam, LOWORD(lParam));
	    return 1;
	}else if (HIWORD(lParam) == EN_KILLFOCUS
		  || HIWORD(lParam) == LBN_KILLFOCUS){
	    D(mgDPrintf("lost focus"));
	    Add_LostFocus(wParam, LOWORD(lParam));
	    return 1;
	}else if (HIWORD(lParam) == EN_CHANGE){	/* EN_UPDATE? */
	    D(mgDPrintf("value changed"));
	    GenDlg_ValueChanged(wParam, LOWORD(lParam));
	    return 1;
	}else if (HIWORD(lParam) == EN_OVERAREA
		  && LOWORD(lParam) == hEditDescription){ /* s */
	    DWORD dwScroll, dwCurScroll;
	    int vscroll, hscroll;
	    D(mgDPrintf("got EN_OVERAREA"));
	    dwScroll = (DWORD)mgSendMessage(hEditDescription,
					    EM_GETOVERAREAVOL,
					    0, 0L);
	    D(mgDPrintf("swScroll: %d", dwScroll));
	    if (dwScroll){
		dwCurScroll = (DWORD)mgSendMessage(hEditDescription,
						   EM_GETSCROLLVOL,
						   0, 0L);
		D(mgDPrintf("swCurScroll: %d", dwScroll));
		vscroll = (int)LOWORD(dwCurScroll)+(int)LOWORD(dwScroll);
		if ((int)HIWORD(dwScroll) > 0){
		    hscroll = (int)HIWORD(dwCurScroll)+(int)LOWORD(dwScroll)+5;
		}else if ((int)HIWORD(dwScroll) < 0){
		    hscroll = (int)HIWORD(dwCurScroll)+(int)LOWORD(dwScroll)-5;
		}else{
		    hscroll = (int)HIWORD(dwCurScroll);
		}
		mgSendMessage(hEditDescription, EM_LINESCROLL,
			      0, MAKELPARAM(vscroll, hscroll));
	    }
	    return 1;
	}
	break;

	case WM_CLOSE:			      /* _CAȌ */
	D(mgDPrintf("got WM_CLOSE"));
	mgEndDialog(hSelf, true);
	return 0;
	break;

	case WM_DESTROY:		      /* _CAO폜 */
	r = Add_Destroy();
	if (r){
	    return 0;			      /*  */
	}else{
	    return -1;			      /* ُ */
	}
	break;
    }

    /* Ȃ */
    return 0;
}
