/*
   context
   Copyright (c) 1997,98 FURUKAWA Yo.
   $Id: context.c,v 1.1.1.1 1998/12/15 03:42:46 furukawa Exp $
   */

#include "arch.h"
#include "global.h"
#include "taskmg.h"
#include "context.h"
#include "view.h"
#include "viewfile.h"
#include "db.h"
#include "month.h"
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

/* -- file local macros */
#define CONTEXT_VERSION	3

/* -- file local variables */
static char labelName[6][16];
static bool labelCustom[5];

/* -- file local methods */

/* -- methods */

/* ReLXgt@C
   1	o[W
   2	t@C
   3	݂̃r[
   4	Monthr[
   5	Weeksr[
   6	Weekr[
   7	Dayr[
   8	Listr[
   9	J[\
   10	J[\

   11	x
   12	JX^x
   13	gOpt_PowerOnToday
   14	gOpt_WeeksStartsFromMonday
   15	gOpt_TimeTableStartsNine
   16	gOpt_SaturdayIsHoliday
   17	gOpt_Label1Default
   18	gOpt_SelectItemByPageUpDown
   19	ItH_
   20	It@C

   21	gOpt_LargeDialog
   22	
   23	
   24	
   25	
   26	
   27	
   28	
   29	
   30	
   */

static void chop(char *buf)
{
    buf[strlen(buf)-1] = '\0';
}

/* ReLXg̕ۑ */
bool
Context_Save(void)
{
    FILE *fp;

    /* open file */
    fp = fopen(TASK_CONTEXT_FILE, OPENMODE_WRITE_TEXT);
    if (NULL == fp)
	return false;

    fprintf(fp, "%d\n", CONTEXT_VERSION);
    /* version 1 */
    fprintf(fp, "%s\n", DB_GetFileName());
    fprintf(fp, "%d\n", gCurrentView);
    fprintf(fp, "%d\n", gCurrentViewMonth);
    fprintf(fp, "%d\n", gCurrentViewWeeks);
    fprintf(fp, "%d\n", gCurrentViewWeek);
    fprintf(fp, "%d\n", gCurrentViewDay);
    fprintf(fp, "%d\n", gCurrentViewList);
    fprintf(fp, "%d\n", gCursorDate);
    fprintf(fp, "%d\n", gCursorHour);
    /* version 2 */
    fprintf(fp, "%d\n", gLabel);
    fprintf(fp, "%d %d %d %d %d\n",
	    labelCustom[0],
	    labelCustom[1],
	    labelCustom[2],
	    labelCustom[3],
	    labelCustom[4]);
    fprintf(fp, "%d\n", gOpt_PowerOnToday);
    fprintf(fp, "%d\n", gOpt_WeeksStartsFromMonday);
    fprintf(fp, "%d\n", gOpt_TimeTableStartsNine);
    fprintf(fp, "%d\n", gOpt_SaturdayIsHoliday);
    fprintf(fp, "%d\n", gOpt_Label1Default);
    fprintf(fp, "%d\n", gOpt_SelectItemByPageUpDown);
    fprintf(fp, "%s\n", gSelectedFolder);
    if (gCurrentView == VIEW_BROWSER){
	fprintf(fp, "%s\n", gSelectedFile);
    }else{
	fprintf(fp, "\n");
    }
    /* version 3 */
    fprintf(fp, "%d\n", gOpt_LargeDialog);
    fprintf(fp, "\n");
    fprintf(fp, "\n");
    fprintf(fp, "\n");
    fprintf(fp, "\n");
    fprintf(fp, "\n");
    fprintf(fp, "\n");
    fprintf(fp, "\n");
    fprintf(fp, "\n");
    fprintf(fp, "\n");

    D(mgDPrintf("...context file saved"));

    /* close file */
    fclose(fp);
    return true;
}

/* ReLXg̓ǂݍ */
bool
Context_Load(void)
{
    FILE *fp;
    char buf[80];
    int version;

    D(mgDPrintf("context file loading..."));

    /* open file */
    fp = fopen(TASK_CONTEXT_FILE, OPENMODE_READ_TEXT);
    if (NULL == fp)
	return false;

    if (NULL == fgets(buf, sizeof(buf), fp))
	return false;
    version = atoi(buf);

    /* version 1 */
    D(mgDPrintf("... version 1"));
    if (NULL == fgets(buf, sizeof(buf), fp))
	return false;
    chop(buf);
    D(mgDPrintf("DBfile: %s", buf));
    DB_SetFileName((byte *)buf);
    if (NULL == fgets(buf, sizeof(buf), fp))
	return false;
    gCurrentView = atoi(buf);
    if (NULL == fgets(buf, sizeof(buf), fp))
	return false;
    gCurrentViewMonth = atoi(buf);
    if (NULL == fgets(buf, sizeof(buf), fp))
	return false;
    gCurrentViewWeeks = atoi(buf);
    if (NULL == fgets(buf, sizeof(buf), fp))
	return false;
    gCurrentViewWeek = atoi(buf);
    if (NULL == fgets(buf, sizeof(buf), fp))
	return false;
    gCurrentViewDay = atoi(buf);
    if (NULL == fgets(buf, sizeof(buf), fp))
	return false;
    gCurrentViewList = atoi(buf);
    if (NULL == fgets(buf, sizeof(buf), fp))
	return false;
    gCursorDate = atoi(buf);
    if (NULL == fgets(buf, sizeof(buf), fp))
	return false;
    gCursorHour = atoi(buf);
    gCursorHourRange = 1;

    /* version 2 */
    if (version >= 2){
	D(mgDPrintf("... version 2"));
	if (NULL == fgets(buf, sizeof(buf), fp))
	    return false;
	gLabel = atoi(buf);
	if (NULL == fgets(buf, sizeof(buf), fp))
	    return false;
	if (strlen(buf) > 3){
	    buf[1] = '\0';
	    buf[3] = '\0';
	    buf[5] = '\0';
	    buf[7] = '\0';
	    buf[9] = '\0';
	    labelCustom[0] = atoi(&(buf[0]));
	    labelCustom[1] = atoi(&(buf[2]));
	    labelCustom[2] = atoi(&(buf[4]));
	    labelCustom[3] = atoi(&(buf[6]));
	    labelCustom[4] = atoi(&(buf[8]));
	}else{
	    labelCustom[0] = 1;
	    labelCustom[1] = 1;
	    labelCustom[2] = 1;
	    labelCustom[3] = 1;
	    labelCustom[4] = 1;
	}
	D(mgDPrintf("Custom Label: %d %d %d %d %d",
		    labelCustom[0],
		    labelCustom[1],
		    labelCustom[2],
		    labelCustom[3],
		    labelCustom[4]));
	if (NULL == fgets(buf, sizeof(buf), fp))
	    return false;
	gOpt_PowerOnToday = atoi(buf);
	if (NULL == fgets(buf, sizeof(buf), fp))
	    return false;
	gOpt_WeeksStartsFromMonday = atoi(buf);
	if (NULL == fgets(buf, sizeof(buf), fp))
	    return false;
	gOpt_TimeTableStartsNine = atoi(buf);
	if (NULL == fgets(buf, sizeof(buf), fp))
	    return false;
	gOpt_SaturdayIsHoliday = atoi(buf);
	if (NULL == fgets(buf, sizeof(buf), fp))
	    return false;
	gOpt_Label1Default = atoi(buf);
	if (NULL == fgets(buf, sizeof(buf), fp))
	    return false;
	gOpt_SelectItemByPageUpDown = atoi(buf);
	if (NULL == fgets(buf, sizeof(buf), fp))
	    return false;
	chop(buf);
	sprintf(gSelectedFolder, buf);
	if (NULL == fgets(buf, sizeof(buf), fp))
	    return false;
	chop(buf);
	ViewFile_SetFile(buf);
    }

    /* version 3 */
    if (version >= 3){
	D(mgDPrintf("... version 3"));
	if (NULL == fgets(buf, sizeof(buf), fp))
	    return false;
	gOpt_LargeDialog = atoi(buf);
	if (NULL == fgets(buf, sizeof(buf), fp))
	    return false;
	if (NULL == fgets(buf, sizeof(buf), fp))
	    return false;
	if (NULL == fgets(buf, sizeof(buf), fp))
	    return false;
	if (NULL == fgets(buf, sizeof(buf), fp))
	    return false;
	if (NULL == fgets(buf, sizeof(buf), fp))
	    return false;
	if (NULL == fgets(buf, sizeof(buf), fp))
	    return false;
	if (NULL == fgets(buf, sizeof(buf), fp))
	    return false;
	if (NULL == fgets(buf, sizeof(buf), fp))
	    return false;
	if (NULL == fgets(buf, sizeof(buf), fp))
	    return false;
    }

    gPreviousView = VIEW_DAY_L;

    /* close file */
    fclose(fp);
    D(mgDPrintf("... done"));
    return true;
}

/* ReLXg̃ftHg */
bool
Context_Defaults(void)
{
    uint8 hour, min;

    D(mgDPrintf("default mode"));

    /* version 1 */
    DB_SetFileName((byte *)TASK_RECORD_FILE);
    gCurrentView = VIEW_3WEEK;
    gCurrentViewMonth = VIEW_3MONTH;
    gCurrentViewWeeks = VIEW_2WEEK;
    gCurrentViewWeek = VIEW_WEEK_S;
    gCurrentViewDay = VIEW_DAY_L;
    gCurrentViewList = VIEW_LIST_S;
    gPreviousView = VIEW_3WEEK;
    gTodayDate = DB_GetDate(&gTodayYear, &gTodayMonth, &gTodayDay,
			    &hour, &min);
    gCursorDate = gTodayDate;
    gCursorHour = hour;
    gCursorHourRange = 1;

    /* version 2 */
    gLabel = 0;
    labelCustom[0] = 1;
    labelCustom[1] = 1;
    labelCustom[2] = 1;
    labelCustom[3] = 1;
    labelCustom[4] = 1;
    gOpt_PowerOnToday = false;
    gOpt_WeeksStartsFromMonday = false;
    gOpt_TimeTableStartsNine = false;
    gOpt_SaturdayIsHoliday = false;
    gOpt_Label1Default = false;
    gOpt_SelectItemByPageUpDown = false;

    /* version 3 */
    gOpt_LargeDialog = false;

    sprintf(gSelectedFolder, "");
    /* sprintf(gSelectedFile, ""); */

    return true;
}

/* x̏ */
bool
Context_InitLabelName(void)
{
    sprintf(labelName[0], "    ");
    sprintf(labelName[1], " ނP ");
    sprintf(labelName[2], " ނQ ");
    sprintf(labelName[3], " ނR ");
    sprintf(labelName[4], " ނS ");
    sprintf(labelName[5], "JX^");
    return true;
}

/* x̓ǂݍ */
bool
Context_LoadLabelName(void)
{
    int i;
    FILE *fp;
    char buf[80];

    D(mgDPrintf("label file loading..."));

    /* open file */
    fp = fopen(TASK_LABEL_FILE, OPENMODE_READ_TEXT);
    if (NULL == fp){
	D(mgDPrintf("label file not found."));
	return false;
    }

    for (i = 1; i <= 4; i++){
	if (NULL == fgets(buf, sizeof(buf), fp)){
	    return false;
	}
	chop(buf);
	if (strlen(buf) > 0){
	    buf[8] = '\0';
	    Context_SetLabelName(i, buf);
	}
    }

    /* close file */
    fclose(fp);
    return true;
}

/* x̐ݒ */
bool
Context_SetLabelName(int i, char *name)
{
    if (i > 0 && i <= 4){
	switch(strlen(name)){
	    case 0:
	    case 1:
	    case 2:
	    sprintf(labelName[i], "   %-5s", name);
	    break;
	    case 3:
	    case 4:
	    sprintf(labelName[i], "  %-6s", name);
	    break;
	    case 5:
	    case 6:
	    sprintf(labelName[i], " %-7s", name);
	    break;
	    case 7:
	    case 8:
	    default:
	    sprintf(labelName[i], "%-8s", name);
	    break;
	}
	labelName[i][8] = '\0';
	return true;
    }else{
	return false;
    }
}

/* x̎擾 */
char *
Context_GetLabelName(int i)
{
    if (i >= 0 && i <= 5){
	return labelName[i];
    }else{
	return "";
    }
}

/* JX^x̃Zbg */
void
Context_SetCustomLabel(int label, bool flag)
{
    labelCustom[label] = flag;
}

/* JX^x̎擾 */
bool
Context_GetCustomLabel(int label)
{
    return labelCustom[label];
}

/* JX^x̑I */
void
Context_SelectCustomLabel(void)
{
    D(mgDPrintf("Context_SelectCustomLabel()"));
    MonthRec_ConfigSetLabel(0, labelCustom[0]);
    MonthRec_ConfigSetLabel(1, labelCustom[1]);
    MonthRec_ConfigSetLabel(2, labelCustom[2]);
    MonthRec_ConfigSetLabel(3, labelCustom[3]);
    MonthRec_ConfigSetLabel(4, labelCustom[4]);
}

/* ̐ݒ */
void
Context_ReflectEnvironment(void)
{
    D(mgDPrintf("Reflecting Environment..."));

    if (gLabel < 5){
	MonthRec_SelectLabel(gLabel);
    }else{
	Context_SelectCustomLabel();
    }

    MonthRec_ConfigIsSaturdayHoliday(gOpt_SaturdayIsHoliday);
}
