/*
   cooperate
   Copyright (c) 1997,98 FURUKAWA Yo.
   $Id: coop.c,v 1.1.1.1 1998/12/15 03:42:46 furukawa Exp $
   */

#include "arch.h"
#include "global.h"
#include "taskmg.h"
#include "taskid.h"
#include "funckey.h"
#include "view.h"
#include "viewfile.h"
#include "util.h"
#include <string.h>
#include <stdlib.h>
#include <stdio.h>
#include <u-k.h>
#include <afc_mk/cfcglapi.h>
#include <afc_mk/afcmedef.h>
#include <afc_mk/afcsyapi.h>

/* -- file local macros */
#define MODE_TOOL_REGFILE	1

/* -- file local variables */
static char drive_letter[3];		      /* NhCu */

/* -- file local methods */

/* -- methods */

/* ̃vO̘AgN */
bool
Coop_StartFromOther(int argc, char *argv[])
{
    char buf[80];

    /* NhCũhCu^[擾 */
    D(mgDPrintf("argv[0] = %s", argv[0]));
    strncpy(drive_letter, argv[0], 2);
    drive_letter[2] = '\0';

    if (argc < 2){
	/* AgNiʏNj */
	D(mgDPrintf("START with NORMAL MODE"));
	gCoopMode = COOP_NONE;
	return true;
    }else{
	/* AgN */
	D(mgDPrintf("argv[1] = %s", argv[1]));

	/* Agt@Cǂݍ */
	if (!CfcReadFile(argv[1], &m_sCFCFileInfo, NULL)){
	    return false;
	}

	D(mgDPrintf("read CFC file... ID=0x%lx, Ver=0x%lx",
		    m_sCFCFileInfo.dwID,
		    m_sCFCFileInfo.dwVersion));
	D(mgDPrintf("  Mode=%d, Result=%d, Count=%d",
		    m_sCFCFileInfo.bActMode,
		    m_sCFCFileInfo.bResult,
		    m_sCFCFileInfo.wSelCount));
	D(mgDPrintf("  EXENameBy=%s DIRName=%s",
		    m_sCFCFileInfo.szEXENameBy,
		    m_sCFCFileInfo.szDIRName));

	/* tH_ۑ */
	sprintf(gSelectedFolder, m_sCFCFileInfo.szDIRName);

	switch (m_sCFCFileInfo.bResult){
	    case DCFC_RET_OK:
	    /* t@C[Ag */
	    D(mgDPrintf("START from FILER with BROWSER MODE"));
	    gCoopMode = COOP_FILER;
	    /* uEU̗グ */
	    gCurrentView = VIEW_BROWSER;
	    /* t@Cݒ肷 */
	    sprintf(buf, "%s\\%s", 
		    m_sCFCFileInfo.szDIRName,
		    m_sCFCFileInfo.szInvertFile);
	    D(mgDPrintf("select %s", buf));
	    ViewFile_SetFile(buf);
	    break;

	    case DCFC_RET_TOOL:
	    /* [c[Ag */
	    if (m_sCFCFileInfo.wSelCount > 0){
		D(mgDPrintf("START from MAILER with BROWSER MODE"));
		gCoopMode = COOP_MAILER;
		/* uEU̗グ */
		gCurrentView = VIEW_BROWSER;
		/* t@Cݒ肷 */
		sprintf(buf, "%s\\%s", 
			m_sCFCFileInfo.szDIRName,
			m_sCFCFileInfo.lpsFileName[0].szFileName);
		D(mgDPrintf("select %s", buf));
		ViewFile_SetFile(buf);
	    }else{
		D(mgDPrintf("START from MAILER with NORMAL MODE"));
		gCoopMode = COOP_MAILER;
	    }
	    break;

	    case DCFC_RET_CANCEL:
	    case DCFC_RET_ERROR:
	    case DCFC_RET_NEWFILE:
	    case DCFC_RET_EDITFILE:
	    case DCFC_RET_APCHANGE:
	    case DCFC_RET_RELATION:
	    /* ȂiʏNj */
	    D(mgDPrintf("START with NORMAL MODE"));
	    gCoopMode = COOP_NONE;
	    return false;
	    break;
	}

	if (m_sCFCFileInfo.lpsFileName != NULL){
	    _ffree(m_sCFCFileInfo.lpsFileName);
	}

	return true;
    }
}

/* t@C[N */
bool
Coop_ExecFiler(void)
{
    static bool first;
    char buf[80];

    /* Agt@C */
    D(mgDPrintf("write CFC file..."));
    m_sCFCFileInfo.dwID = 0x44434643;
    m_sCFCFileInfo.dwVersion = 0x00010000;
    m_sCFCFileInfo.bActMode = DCFC_ACT_LIST;
    m_sCFCFileInfo.bResult = 0;
    m_sCFCFileInfo.bSortType = DCFC_SORT_DOCNAME;
    m_sCFCFileInfo.bSortMode = DCFC_SORT_DEC;
    m_sCFCFileInfo.bFontMode = DCFC_FONT_12;
    m_sCFCFileInfo.bDispMode = DCFC_DISP_COMMID;
    /* m_sCFCFileInfo.StLineFlag = should not assign; */
    m_sCFCFileInfo.unHelpID = 0;
    m_sCFCFileInfo.wSelCount = 0;
    m_sCFCFileInfo.wRecentMenuID = 0;
    m_sCFCFileInfo.wAPParam = 0;
    /* m_sCFCFileInfo.wAPPath = should not assign; */
    sprintf(buf, "%s%s", drive_letter, EXEName_Task);
    sprintf(m_sCFCFileInfo.szEXENameBy, buf);
    sprintf(m_sCFCFileInfo.szDIRName, gSelectedFolder);
    sprintf(buf, "%s%s", drive_letter, HELPName_Task);
    sprintf(m_sCFCFileInfo.szHelpFile, buf);
    sprintf(m_sCFCFileInfo.szTitleText, "^XN it@CIj");
    sprintf(m_sCFCFileInfo.szFileExt, "");
    sprintf(m_sCFCFileInfo.szDocMask, "");
    sprintf(m_sCFCFileInfo.szIconBmpID, "TASKMG_KB");
    sprintf(m_sCFCFileInfo.szListFirst, "");
    sprintf(m_sCFCFileInfo.szInvertFile, ""); /* this should not be set */
    m_sCFCFileInfo.lpsFileName = NULL;
    if (!CfcWriteFile(CFCName_Filer, &m_sCFCFileInfo, NULL)){
	return false;
    }

    /* exec */
    D(mgDPrintf("exec filer..."));
    sprintf(buf, "%s %s", EXEName_Filer, CFCName_Filer);
    mgWinExec(buf);
    return true;
}

/* u[vvN */
bool
Coop_ExecEditor(void)
{
    static bool first;
    char buf[80];

    /* Agt@C */
    D(mgDPrintf("write CFC file..."));
    m_sCFCFileInfo.dwID = 0x44434643;
    m_sCFCFileInfo.dwVersion = 0x00010000;
    m_sCFCFileInfo.bActMode = 0;
    m_sCFCFileInfo.bResult = DCFC_RET_RELATION;
    m_sCFCFileInfo.bSortType = DCFC_SORT_DOCNAME;
    m_sCFCFileInfo.bSortMode = DCFC_SORT_DEC;
    m_sCFCFileInfo.bFontMode = DCFC_FONT_12;
    m_sCFCFileInfo.bDispMode = DCFC_DISP_COMMID;
    /* m_sCFCFileInfo.StLineFlag = should not assign; */
    m_sCFCFileInfo.unHelpID = 0;
    m_sCFCFileInfo.wSelCount = 0;
    m_sCFCFileInfo.wRecentMenuID = 0;
    m_sCFCFileInfo.wAPParam = DCFC_VERB_EDIT;
    /* m_sCFCFileInfo.wAPPath = should not assign; */
    sprintf(buf, "%s%s", drive_letter, EXEName_Task);
    sprintf(m_sCFCFileInfo.szEXENameBy, buf);
    sprintf(m_sCFCFileInfo.szDIRName, gSelectedFolder);
    sprintf(buf, "%s%s", drive_letter, HELPName_Task);
    sprintf(m_sCFCFileInfo.szHelpFile, buf);
    sprintf(m_sCFCFileInfo.szTitleText, "ҏW");
    sprintf(m_sCFCFileInfo.szFileExt, "");
    sprintf(m_sCFCFileInfo.szDocMask, "");
    sprintf(m_sCFCFileInfo.szIconBmpID, "WPBMP1");
    sprintf(m_sCFCFileInfo.szListFirst, "");
    sprintf(m_sCFCFileInfo.szInvertFile, "");
    m_sCFCFileInfo.lpsFileName = NULL;
    if (!CfcWriteFile(CFCName_Editor, &m_sCFCFileInfo, NULL)){
	return false;
    }

    /* exec */
    D(mgDPrintf("exec editor..."));
    sprintf(buf, "%s %s", EXEName_Editor, CFCName_Editor);
    mgWinExec(buf);
    return true;
}

/* udq[vɓo^Ă邩`FbN */
static bool
Coop_IsRegisteredAsTool(void)
{
    WORD r;
    char buf[80];

    sprintf(buf, "%s%s", drive_letter, EXEName_Task);
    r = AfcFindToolRec(buf, MODE_TOOL_REGFILE);
    if (r == DAFC_ERR_NONE){
	return true;
    }else{
	return false;
    }
}

/* udq[vɓo^ */
static bool
Coop_RegisterAsTool(void)
{
    WORD r;
    AFC_TOOL_REC tool_rec;
    char buf[80];

    tool_rec.wActMode = MODE_TOOL_REGFILE;
    sprintf(tool_rec.szFuncName, "^XN");
    sprintf(tool_rec.szToolName, "^XN");
    sprintf(buf, "%s%s", drive_letter, EXEName_Task);
    sprintf(tool_rec.szPath, buf);
    sprintf(tool_rec.szFuncGuide, " ^XN ");
    r = AfcUpdateToolRec((LPAFC_TOOL_REC)&tool_rec);
    if (r == DAFC_ERR_NONE){
	return true;
    }else{
	return false;
    }
}

/* udq[vN */
bool
Coop_ExecMailer(void)
{
    char buf[80];

    if (Coop_IsRegisteredAsTool()){
	D(mgDPrintf("task is already registered as tool."));
    }else{
	D(mgDPrintf("task is not registered as tool."));
	if (Coop_RegisterAsTool()){
	    D(mgDPrintf("registering ... success"));
	}else{
	    D(mgDPrintf("registering ... failure"));
	}
    }

    /* exec */
    D(mgDPrintf("exec mailer..."));
    sprintf(buf, "%s %s%s", EXEName_Mailer, drive_letter, EXEName_Task);
    mgWinExec(buf);
    return true;
    
}

#define ACE_KEY_MIN	21
#define ACE_KEY_MAX	28
#define ACE_KEY_NUM	(ACE_KEY_MAX-ACE_KEY_MIN+1)

static char ace_exec_path[ACE_KEY_NUM][64];
static bool gACEEnable;

/* ACEt@C̓ǂݍ */
bool
Coop_ReadACEFile(void)
{
    FILE *fp;
    int i, no;
    char buf[80], *p, *path;

    D(mgDPrintf("Coop_ReadACEFile()"));

    gACEEnable = false;
    for (i = 0; i < ACE_KEY_NUM; i++){
	ace_exec_path[i][0] = '\0';
    }

    fp = fopen(TASK_ACE_FILE, OPENMODE_READ_TEXT);
    if (fp == NULL){
	return false;
    }

    while (NULL != fgets(buf, sizeof(buf), fp)){
	if (buf[0] == ';'){
	    continue;
	}
	p = buf;
	for (; *p != ',' && *p != '\0'; p++);
	*p = '\0';
	no = atoi(buf);
	if (no < ACE_KEY_MIN || no > ACE_KEY_MAX){
	    continue;
	}
	p++;
	path = p;
	for (; *p != ',' && *p != '\0'; p++);
	*p = '\0';
	sprintf(ace_exec_path[no - ACE_KEY_MIN], "%s", path);
    }

    fclose(fp);
    gACEEnable = true;
    return true;
}

/* ACEŕʂ̃vON */
bool
Coop_ExecACE(int no)
{
    char buf[80];
    if (!gACEEnable || no < 0 || no >= ACE_KEY_NUM){
	return false;
    }
    if (ace_exec_path[no][0] == '\0'){
	return false;
    }

    /* exec */
    D(mgDPrintf("exec %s...", ace_exec_path[no]));
    sprintf(buf, "%s %s%s", ace_exec_path[no], drive_letter, EXEName_Task);
    mgWinExec(buf);
    return true;
}
