/*
   week view (small size)
   Copyright (c) 1997,98 FURUKAWA Yo.
   $Id: viewws.c,v 1.1.1.1 1998/12/15 03:42:49 furukawa Exp $
   */

#include "arch.h"
#include "global.h"
#include "calendar.h"
#include "month.h"
#include "taskmg.h"
#include "taskid.h"
#include "view.h"
#include "viewws.h"
#include "viewitem.h"
#include "viewtime.h"
#include "additem.h"
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <u-k.h>

/* -- file local macros */
#define HOURCELL_ROWS		10
#define HOURCELL_COLS		7
#define HOURCELL_WIDTH		(12*5+3)
#define HOURCELL_HEIGHT		(12*1+1)
#define ITEM_PER_DAY		4

#define REGION_HOUR_WIDTH	(6*5+2)
#define REGION_HOUR_HEIGHT	(HOURCELL_HEIGHT*HOURCELL_ROWS)
#define REGION_DAYWEEK_WIDTH	(HOURCELL_WIDTH*HOURCELL_COLS)
#define REGION_DAYWEEK_HEIGHT	(12*1+3)
#define REGION_TIMETABLE_WIDTH	(HOURCELL_WIDTH*HOURCELL_COLS)
#define REGION_TIMETABLE_HEIGHT	(HOURCELL_HEIGHT*HOURCELL_ROWS)
#define REGION_DAY_WIDTH	(HOURCELL_WIDTH*HOURCELL_COLS)
#define REGION_DAY_HEIGHT	(56)

#define ITEMCELL_ROWS		12
#define ITEMCELL_COLS		1
#define ITEMCELL_WIDTH		(REGION_USER_WIDTH-REGION_HOUR_WIDTH-REGION_DAYWEEK_WIDTH-1)
#define ITEMCELL_HEIGHT		(12+3)

#define REGION_DATE_WIDTH	(ITEMCELL_WIDTH)
#define REGION_DATE_HEIGHT	(16*1+5)
#define REGION_DATE_LEFT	(REGION_USER_LEFT+REGION_HOUR_WIDTH+REGION_DAYWEEK_WIDTH+2)
#define REGION_DATE_TOP		(REGION_USER_TOP)
#define REGION_ITEMS_WIDTH	(ITEMCELL_WIDTH)
#define REGION_ITEMS_HEIGHT	(ITEMCELL_HEIGHT*ITEMCELL_ROWS)

/* -- file local variables */

/* -- file local methods */

/* -- methods */

/* ViewWS */
bool
ViewWS_Create(void)
{
    D(mgDPrintf("ViewWS create\n"));

    /* ViewŗL̕ϐ */
    cursor_focus = FOCUS_TIMETABLE;
    cursor_prev_focus = FOCUS_TIMETABLE;
    ViewItem_Init(REGION_DATE_LEFT, REGION_DATE_TOP,
		  REGION_DATE_WIDTH, REGION_DATE_HEIGHT,
		  REGION_ITEMS_WIDTH, REGION_ITEMS_HEIGHT,
		  ITEMCELL_WIDTH, ITEMCELL_HEIGHT,
		  ITEMCELL_COLS, ITEMCELL_ROWS,
		  F12_FNT, 7+20);
    ViewItem_InitCursor();
    ViewTime_Init(REGION_USER_LEFT, REGION_USER_TOP,
		  REGION_HOUR_WIDTH, REGION_HOUR_HEIGHT,
		  REGION_DAYWEEK_WIDTH, REGION_DAYWEEK_HEIGHT,
		  REGION_TIMETABLE_WIDTH, REGION_TIMETABLE_HEIGHT,
		  REGION_DAY_WIDTH, REGION_DAY_HEIGHT,
		  HOURCELL_WIDTH, HOURCELL_HEIGHT,
		  HOURCELL_COLS, HOURCELL_ROWS,
		  ITEM_PER_DAY,
		  F12_FNT, 10);
    ViewTime_InitCursor();

    return true;
}

/* ViewWSЕt */
bool
ViewWS_Destroy(void)
{
    D(mgDPrintf("ViewWS destroy\n"));
    return true;
}

/* ViewWSĕ` */
void
ViewWS_Redraw(void)
{
    HDC hDC;
    PAINTSTRUCT ps;

    hDC = mgBeginPaint(ghMainWin, (LPPAINTSTRUCT)&ps);

    /*  */
    mgSelectStockObject(hDC, CL_BLACK|SOLID_PEN|SIZE1_PEN);
    mgMoveTo(hDC, REGION_USER_LEFT+REGION_HOUR_WIDTH+REGION_DAYWEEK_WIDTH, REGION_USER_TOP);
    mgLineTo(hDC, REGION_USER_LEFT+REGION_HOUR_WIDTH+REGION_DAYWEEK_WIDTH, REGION_USER_BOTTOM);

    ViewTimeHour_Redraw(hDC);
    ViewTimeWeek_Redraw(hDC);
    ViewItemDate_Redraw(hDC);
    ViewItem_Redraw(hDC);
    ViewTime_InvertCursor(hDC);		      /* ON */
    if (cursor_focus == FOCUS_ITEMLIST)
	ViewItem_InvertCursor(hDC);	      /* ON */
    mgEndPaint(ghMainWin, (LPPAINTSTRUCT)&ps);
}

/* ViewWSxĕ` */
void
ViewWS_DelayedRedraw(void)
{
    HDC hDC;
    PAINTSTRUCT ps;

    hDC = mgBeginPaint(ghMainWin, (LPPAINTSTRUCT)&ps);
    ViewItemDate_Redraw(hDC);
    ViewItem_Redraw(hDC);
    if (cursor_focus == FOCUS_ITEMLIST)
	ViewItem_InvertCursor(hDC);
    mgEndPaint(ghMainWin, (LPPAINTSTRUCT)&ps);
}

/* L[R[h */
bool
ViewWS_KeyDown(WPARAM wParam, LPARAM lParam)
{
    HDC hDC;
    PAINTSTRUCT ps;

    switch (wParam){
	case VK_LEFT:			      /*  */
	case UVK_LEFT:			      /*  */
	hDC = mgBeginPaint(ghMainWin, (LPPAINTSTRUCT)&ps);
	ViewTime_InvertCursor(hDC);	      /* OFF */
	gCursorDate--;
	/* IJ[\ */
	if (gCursorHourRange > 1){
	    gCursorHour = gCursorHour + gCursorHourRange - 1;
	    gCursorHourRange = 1;
	}
	ViewTime_Left(hDC);
	ViewTime_InvertCursor(hDC);	      /* ON */
	/* tH[JX^Ce[uɈړ */
	if (cursor_focus == FOCUS_ITEMLIST){
	    ViewItem_InitCursor();
	    cursor_focus = FOCUS_TIMETABLE;
	}
	mgEndPaint(ghMainWin, (LPPAINTSTRUCT)&ps);
	/* xAbvf[g */
	View_SetTimer();
	break;

	case VK_RIGHT:			      /* E */
	case UVK_RIGHT:			      /* E */
	hDC = mgBeginPaint(ghMainWin, (LPPAINTSTRUCT)&ps);
	ViewTime_InvertCursor(hDC);	      /* OFF */
	gCursorDate++;
	/* IJ[\ */
	if (gCursorHourRange > 1){
	    gCursorHour = gCursorHour + gCursorHourRange - 1;
	    gCursorHourRange = 1;
	}
	ViewTime_Right(hDC);
	ViewTime_InvertCursor(hDC);	      /* ON */
	/* tH[JX^Ce[uɈړ */
	if (cursor_focus == FOCUS_ITEMLIST){
	    ViewItem_InitCursor();
	    cursor_focus = FOCUS_TIMETABLE;
	}
	mgEndPaint(ghMainWin, (LPPAINTSTRUCT)&ps);
	/* xAbvf[g */
	View_SetTimer();
	break;

	case VK_PRIOR:			      /* O */
	hDC = mgBeginPaint(ghMainWin, (LPPAINTSTRUCT)&ps);
	/* IJ[\ */
	if (gCursorHourRange > 1){
	    gCursorHour = gCursorHour + gCursorHourRange - 1;
	    gCursorHourRange = 1;
	}
	ViewTime_WeekUp(hDC);
	ViewTime_InvertCursor(hDC);	      /* ON */
	mgEndPaint(ghMainWin, (LPPAINTSTRUCT)&ps);
	/* xAbvf[g */
	View_SetTimer();
	break;

	case VK_NEXT:			      /*  */
	hDC = mgBeginPaint(ghMainWin, (LPPAINTSTRUCT)&ps);
	/* IJ[\ */
	if (gCursorHourRange > 1){
	    gCursorHour = gCursorHour + gCursorHourRange - 1;
	    gCursorHourRange = 1;
	}
	ViewTime_WeekDown(hDC);
	ViewTime_InvertCursor(hDC);	      /* ON */
	mgEndPaint(ghMainWin, (LPPAINTSTRUCT)&ps);
	/* xAbvf[g */
	View_SetTimer();
	break;

	case VK_UP:			      /*  */
	case UVK_UP:			      /*  */
	hDC = mgBeginPaint(ghMainWin, (LPPAINTSTRUCT)&ps);
	ViewTime_InvertCursor(hDC);	      /* OFF */
	/* IJ[\ */
	if (gCursorHourRange > 1){
	    gCursorHour = gCursorHour + gCursorHourRange - 1;
	    gCursorHourRange = 1;
	}
	/* J[\ړ */
	if (gCursorHour > 0){
	    gCursorHour--;
	}
	ViewTime_Up(hDC);
	ViewTime_InvertCursor(hDC);	      /* ON */
	/* tH[JXACeXgɈړ */
	if (cursor_focus == FOCUS_ITEMLIST){
	    ViewItem_InvertCursor(hDC);
	    ViewItem_InitCursor();
	    cursor_focus = FOCUS_TIMETABLE;
	}
	mgEndPaint(ghMainWin, (LPPAINTSTRUCT)&ps);
	break;

	case VK_DOWN:			      /*  */
	case UVK_DOWN:			      /*  */
	hDC = mgBeginPaint(ghMainWin, (LPPAINTSTRUCT)&ps);
	ViewTime_InvertCursor(hDC);	      /* OFF */
	/* IJ[\ */
	if (gCursorHourRange > 1){
	    gCursorHour = gCursorHour + gCursorHourRange - 1;
	    gCursorHourRange = 1;
	}
	/* J[\ړ */
	if (gCursorHour < 23){
	    gCursorHour++;
	}
	ViewTime_Down(hDC);
	ViewTime_InvertCursor(hDC);	      /* ON */
	/* tH[JXACeXgɈړ */
	if (cursor_focus == FOCUS_ITEMLIST){
	    ViewItem_InvertCursor(hDC);
	    ViewItem_InitCursor();
	    cursor_focus = FOCUS_TIMETABLE;
	}
	mgEndPaint(ghMainWin, (LPPAINTSTRUCT)&ps);
	break;

	case UVK_HOURUP:		      /* ԏ */
	hDC = mgBeginPaint(ghMainWin, (LPPAINTSTRUCT)&ps);
	ViewTime_InvertCursor(hDC);	      /* OFF */
	/* IJ[\k */
	if (gCursorHourRange > 1){
	    gCursorHourRange--;
	}else{
	    if (gCursorHour > 0){
		gCursorHour--;
	    }
	}
	ViewTime_Up(hDC);
	ViewTime_InvertCursor(hDC);	      /* ON */
	/* tH[JXACeXgɈړ */
	if (cursor_focus == FOCUS_ITEMLIST){
	    ViewItem_InvertCursor(hDC);
	    ViewItem_InitCursor();
	    cursor_focus = FOCUS_TIMETABLE;
	}
	mgEndPaint(ghMainWin, (LPPAINTSTRUCT)&ps);
	break;

	case UVK_HOURDOWN:		      /* ԉ */
	hDC = mgBeginPaint(ghMainWin, (LPPAINTSTRUCT)&ps);
	ViewTime_InvertCursor(hDC);	      /* OFF */
	/* IJ[\g */
	if (gCursorHour + gCursorHourRange < 24){
	    gCursorHourRange++;
	}
	ViewTime_Down(hDC);
	ViewTime_InvertCursor(hDC);	      /* ON */
	/* tH[JXACeXgɈړ */
	if (cursor_focus == FOCUS_ITEMLIST){
	    ViewItem_InvertCursor(hDC);
	    ViewItem_InitCursor();
	    cursor_focus = FOCUS_TIMETABLE;
	}
	mgEndPaint(ghMainWin, (LPPAINTSTRUCT)&ps);
	break;

	case UVK_ITEMUP:		      /* ACe */
	hDC = mgBeginPaint(ghMainWin, (LPPAINTSTRUCT)&ps);
	if (cursor_focus == FOCUS_TIMETABLE){
	    D(mgDPrintf("focus ITEMLIST"));
	    ViewItem_InvertCursor(hDC);     /* ON */
	    cursor_focus = FOCUS_ITEMLIST;
	}else{
	    ViewItem_InvertCursor(hDC);     /* OFF */
	    ViewItem_Up(hDC);
	    ViewItem_InvertCursor(hDC);     /* ON */
	}
	mgEndPaint(ghMainWin, (LPPAINTSTRUCT)&ps);
	break;

	case UVK_ITEMDOWN:		      /* ACe */
	hDC = mgBeginPaint(ghMainWin, (LPPAINTSTRUCT)&ps);
	if (cursor_focus == FOCUS_TIMETABLE){
	    D(mgDPrintf("focus ITEMLIST"));
	    ViewItem_InvertCursor(hDC);     /* ON */
	    cursor_focus = FOCUS_ITEMLIST;
	}else{
	    ViewItem_InvertCursor(hDC);     /* OFF */
	    ViewItem_Down(hDC);
	    ViewItem_InvertCursor(hDC);     /* ON */
	}
	mgEndPaint(ghMainWin, (LPPAINTSTRUCT)&ps);
	break;

	default:
	/* Ȃ */
	return false;
	break;
    }

    /*  */
    return true;
}

/* R}h */
bool
ViewWS_Command(WPARAM wParam, LPARAM lParam)
{
    switch (wParam){
	case ID_FUNC_NOW:
	if (HIWORD(lParam) == BN_CLICKED){
	    ViewTime_InitCursor();
	    ViewItem_InitCursor();
	    View_Redraw();
	}else{
	    return false;
	}
	break;

	default:
	/* Ȃ */
	return false;
	break;
    }

    /*  */
    return true;
}
