/*
   add dialog
   Copyright (c) 1997,98 FURUKAWA Yo.
   $Id: additem.c,v 1.2 1998/12/27 16:26:19 furukawa Exp $
   */

/* ǽˤ뤬äȤ */

#include "global.h"
#include "taskmg.h"
#include "taskid.h"
#include "arch.h"
#include "gendlg.h"
#include "additem.h"
#include "calendar.h"
#include "record.h"
#include "month.h"
#include "view.h"
#include "context.h"
#include "funckey.h"
#include "file.h"
#include <string.h>
#include <stdlib.h>
#include <stdio.h>
#include "mnw.h"

/* -- file local macros */

#define EDIT_1stLINE_NORMAL	(34)
#define EDIT_2ndLINE_NORMAL	(EDIT_1stLINE_NORMAL+(18*3+2)+4)
#define EDIT_3rdLINE_NORMAL	(EDIT_2ndLINE_NORMAL+(18*1+2)+4)
#define EDIT_4thLINE_NORMAL	(EDIT_3rdLINE_NORMAL+(18*1+2)+4)
#define EDIT_5thLINE_NORMAL	(EDIT_4thLINE_NORMAL+(18*1+2)+4)

#define EDIT_1stLINE_LARGE	(34)
#define EDIT_2ndLINE_LARGE	(EDIT_1stLINE_LARGE+(18*5+2)+3)
#define EDIT_3rdLINE_LARGE	(EDIT_2ndLINE_LARGE+(18*1+2)+4)

#define EDIT_1stLINE_SMALL	(34)
#define EDIT_2ndLINE_SMALL	(EDIT_1stLINE_SMALL+(18*2+2)+3)
#define EDIT_3rdLINE_SMALL	(EDIT_2ndLINE_SMALL+(18*1+2)+3)
#define EDIT_4thLINE_SMALL	(EDIT_3rdLINE_SMALL+(18*1+2)+3)
#define EDIT_5thLINE_SMALL	(EDIT_4thLINE_SMALL+(18*1+2)+3)

#define F16_WIDTH	8
#define F16_HEIGHT	16
#define F12_WIDTH	6
#define F12_HEIGHT	12

#define DIALOG_NORMAL	0
#define DIALOG_LARGE	1
#define DIALOG_SMALL	2

/* -- file local variables */

/* ɥ */
static mnwDialog gAddDialog;

/* ȥ */
static char *dialogTitle[11] = {
    "",
    "ɲ", "", "塼ɲ", "", "ɲ",
    "ѹ", "", "塼ѹ", "", "ѹ",
};

/* ѿ */
static int local_repeat_type;
static uint16 prev_start_date, prev_end_date;
static uint16 local_label;

/* ѿ */
static int region_dialog_left, region_dialog_top;
static int region_dialog_right, region_dialog_bottom;
static int region_dialog_width, region_dialog_height;
static int region_description_left, region_description_top;
static int region_title_left, region_title_top;
static int region_start_time_left, region_start_time_top;
static int region_end_time_left, region_end_time_top;
static int region_start_date_left, region_start_date_top;
static int region_end_date_left, region_end_date_top;
static int region_label_left, region_label_top;
static int region_repeat_left, region_repeat_top;
static int region_repeat_width, region_repeat_height;
static int region_repeat_label_left, region_repeat_label_top;
static int region_repeat_interval_left, region_repeat_interval_top;
static int region_rank_left, region_rank_top;
static int description_rows, description_cols;
static int dialog_size;
static bool dialog_visible, dialog_result;

/* ƨ */
static Record *editRecord;

/* -- file local methods */

static bool
AddDlg_Create(mnwDialog *self);
static void
AddDlg_InitControls(void);
static bool
AddDlg_Destroy(mnwDialog *self);
static void
AddDlg_InitRepeatControl(uint16 date);
static void
AddDlg_ResetRepeatControl(uint16 date);
static void
AddDlg_GetRepeatControl(void);
static bool
AddDlg_Redraw(mnwDialog *self);
static bool
AddDlg_FixDateRange(bool fix_end);
static bool
AddDlg_FixTimeRange(bool fix_end);
static bool
AddDlg_GainFocusNotify(mnwDialog *self, mnwEvent *event);
static bool
AddDlg_LostFocusNotify(mnwDialog *self, mnwEvent *event);
static bool
AddDlg_ChangedNotify(mnwDialog *self, mnwEvent *event);
static bool
AddDlg_Register(void);
static void
AddDlg_SetLabel(uint16 label);
static bool
AddDlg_InitRegion(void);
static bool
AddDlg_Callback(mnwDialog *self, mnwEvent *event);

/* -- methods */

/* Add */
static bool
AddDlg_Create(mnwDialog *self)
{
    mnwRect r;
    mnwEvent e;

    D(mnwDPrintf("Add create\n"));

    /* ѿ */
    gMode = MODE_ADD;
    value_invalid = false;
    focus = next_focus = should_focus = nil;
    focus_min_val = focus_max_val = 0;
    focus_inc_type = INC_TYPE_NONE;
    focus_not_move = false;
    dialog_visible = true;

    /* ե󥯥󥭡 */
    FuncKey_SetAddMode();

    /* ҥȥκ */
    mnwRect_SetXYWH(&r,
		    region_description_left, region_description_top,
		    description_cols*F16_WIDTH+4,
		    description_rows*F16_HEIGHT+2);
    mnwWindow_Register((mnwWindow *)&gEditDescription,
		       (mnwWindowCallback)mnwEdit_Callback,
		       (mnwWindow *)&gAddDialog, &r);
    mnwEvent_SetAll(&e, kEvent_SetTabStop, &gEditDescription, 0, 0);
    mnwEvent_SendTo(&e, (mnwWindow *)&gAddDialog);
    mnwEvent_SetAll(&e, kEvent_SetID, nil, ID_EDIT_DESCRIPTION, 0);
    mnwEvent_SendTo(&e, (mnwWindow *)&gEditDescription);
    mnwEvent_SetAll(&e, kEvent_SetMultiLine, nil, 0, 0);
    mnwEvent_SendTo(&e, (mnwWindow *)&gEditDescription);

    /* եȥκ */
    mnwRect_SetXYWH(&r,
		    region_start_date_left, region_start_date_top,
		    BUF_START_YEAR_LEN*F16_WIDTH+4, F16_HEIGHT+4);
    mnwWindow_Register((mnwWindow *)&gEditStartYear,
		       (mnwWindowCallback)mnwEdit_Callback,
		       (mnwWindow *)&gAddDialog, &r);
    mnwEvent_SetAll(&e, kEvent_SetTabStop, &gEditStartYear, 0, 0);
    mnwEvent_SendTo(&e, (mnwWindow *)(mnwWindow *)&gAddDialog);
    mnwEvent_SetAll(&e, kEvent_SetID, nil, ID_EDIT_START_YEAR, 0);
    mnwEvent_SendTo(&e, (mnwWindow *)&gEditStartYear);
    region_start_date_left += (BUF_START_YEAR_LEN+2)*F16_WIDTH+8;
    mnwRect_SetXYWH(&r,
		    region_start_date_left, region_start_date_top,
		    BUF_START_MONTH_LEN*F16_WIDTH+4, F16_HEIGHT+4);
    mnwWindow_Register((mnwWindow *)&gEditStartMonth,
		       (mnwWindowCallback)mnwEdit_Callback,
		       (mnwWindow *)&gAddDialog, &r);
    mnwEvent_SetAll(&e, kEvent_SetTabStop, &gEditStartMonth, 0, 0);
    mnwEvent_SendTo(&e, (mnwWindow *)(mnwWindow *)&gAddDialog);
    mnwEvent_SetAll(&e, kEvent_SetID, nil, ID_EDIT_START_MONTH, 0);
    mnwEvent_SendTo(&e, (mnwWindow *)&gEditStartMonth);
    region_start_date_left += (BUF_START_MONTH_LEN+2)*F16_WIDTH+8;
    mnwRect_SetXYWH(&r,
		    region_start_date_left, region_start_date_top,
		    BUF_START_DAY_LEN*F16_WIDTH+4, F16_HEIGHT+4);
    mnwWindow_Register((mnwWindow *)&gEditStartDay,
		       (mnwWindowCallback)mnwEdit_Callback,
		       (mnwWindow *)&gAddDialog, &r);
    mnwEvent_SetAll(&e, kEvent_SetTabStop, &gEditStartDay, 0, 0);
    mnwEvent_SendTo(&e, (mnwWindow *)(mnwWindow *)&gAddDialog);
    mnwEvent_SetAll(&e, kEvent_SetID, nil, ID_EDIT_START_DAY, 0);
    mnwEvent_SendTo(&e, (mnwWindow *)&gEditStartDay);
    region_start_date_left += (BUF_START_DAY_LEN+2)*F16_WIDTH+8;
    mnwRect_SetXYWH(&r,
		    region_start_date_left+8, region_start_date_top+2,
		    BUF_START_DAYWEEK_LEN*F16_WIDTH, F16_HEIGHT+4);
    mnwWindow_Register((mnwWindow *)&gLabelStartDayWeek,
		       (mnwWindowCallback)mnwLabel_Callback,
		       (mnwWindow *)&gAddDialog, &r);
    mnwEvent_SetAll(&e, kEvent_SetID, nil, ID_STATIC_START_DAYWEEK, 0);
    mnwEvent_SendTo(&e, (mnwWindow *)&gLabelStartDayWeek);

    if (hasEndDate(dialog_mode)){
	mnwRect_SetXYWH(&r,
			region_end_date_left, region_end_date_top,
			BUF_END_YEAR_LEN*F16_WIDTH+4, F16_HEIGHT+4);
	mnwWindow_Register((mnwWindow *)&gEditEndYear,
			   (mnwWindowCallback)mnwEdit_Callback,
			   (mnwWindow *)&gAddDialog, &r);
	mnwEvent_SetAll(&e, kEvent_SetTabStop, &gEditEndYear, 0, 0);
	mnwEvent_SendTo(&e, (mnwWindow *)(mnwWindow *)&gAddDialog);
	mnwEvent_SetAll(&e, kEvent_SetID, nil, ID_EDIT_END_YEAR, 0);
	mnwEvent_SendTo(&e, (mnwWindow *)&gEditEndYear);
	region_end_date_left += (BUF_END_YEAR_LEN+2)*F16_WIDTH+8;
	mnwRect_SetXYWH(&r,
			region_end_date_left, region_end_date_top,
			BUF_END_MONTH_LEN*F16_WIDTH+4, F16_HEIGHT+4);
	mnwWindow_Register((mnwWindow *)&gEditEndMonth,
			   (mnwWindowCallback)mnwEdit_Callback,
			   (mnwWindow *)&gAddDialog, &r);
	mnwEvent_SetAll(&e, kEvent_SetTabStop, &gEditEndMonth, 0, 0);
	mnwEvent_SendTo(&e, (mnwWindow *)(mnwWindow *)&gAddDialog);
	mnwEvent_SetAll(&e, kEvent_SetID, nil, ID_EDIT_END_MONTH, 0);
	mnwEvent_SendTo(&e, (mnwWindow *)&gEditEndMonth);
	region_end_date_left += (BUF_END_MONTH_LEN+2)*F16_WIDTH+8;
	mnwRect_SetXYWH(&r,
			region_end_date_left, region_end_date_top,
			BUF_END_DAY_LEN*F16_WIDTH+4, F16_HEIGHT+4);
	mnwWindow_Register((mnwWindow *)&gEditEndDay,
			   (mnwWindowCallback)mnwEdit_Callback,
			   (mnwWindow *)&gAddDialog, &r);
	mnwEvent_SetAll(&e, kEvent_SetTabStop, &gEditEndDay, 0, 0);
	mnwEvent_SendTo(&e, (mnwWindow *)(mnwWindow *)&gAddDialog);
	mnwEvent_SetAll(&e, kEvent_SetID, nil, ID_EDIT_END_DAY, 0);
	mnwEvent_SendTo(&e, (mnwWindow *)&gEditEndDay);
	region_end_date_left += (BUF_END_DAY_LEN+2)*F16_WIDTH+8;
	mnwRect_SetXYWH(&r,
			region_end_date_left+8, region_end_date_top+2,
			BUF_END_DAYWEEK_LEN*F16_WIDTH, F16_HEIGHT+4);
	mnwWindow_Register((mnwWindow *)&gLabelEndDayWeek,
			   (mnwWindowCallback)mnwLabel_Callback,
			   (mnwWindow *)&gAddDialog, &r);
	mnwEvent_SetAll(&e, kEvent_SetID, nil, ID_STATIC_END_DAYWEEK, 0);
	mnwEvent_SendTo(&e, (mnwWindow *)&gLabelEndDayWeek);
    }

    /* 拾ȥ */
    if (hasTime(dialog_mode)){
	mnwRect_SetXYWH(&r,
			region_start_time_left, region_start_time_top,
			BUF_START_HOUR_LEN*F16_WIDTH+4, F16_HEIGHT+4);
	mnwWindow_Register((mnwWindow *)&gEditStartHour,
			   (mnwWindowCallback)mnwEdit_Callback,
			   (mnwWindow *)&gAddDialog, &r);
	mnwEvent_SetAll(&e, kEvent_SetTabStop, &gEditStartHour, 0, 0);
	mnwEvent_SendTo(&e, (mnwWindow *)(mnwWindow *)&gAddDialog);
	mnwEvent_SetAll(&e, kEvent_SetID, nil, ID_EDIT_START_HOUR, 0);
	mnwEvent_SendTo(&e, (mnwWindow *)&gEditStartHour);
	region_start_time_left += (BUF_START_HOUR_LEN+2)*F16_WIDTH+8;
	mnwRect_SetXYWH(&r,
			region_start_time_left, region_start_time_top,
			BUF_START_MIN_LEN*F16_WIDTH+4, F16_HEIGHT+4);
	mnwWindow_Register((mnwWindow *)&gEditStartMin,
			   (mnwWindowCallback)mnwEdit_Callback,
			   (mnwWindow *)&gAddDialog, &r);
	mnwEvent_SetAll(&e, kEvent_SetTabStop, &gEditStartMin, 0, 0);
	mnwEvent_SendTo(&e, (mnwWindow *)(mnwWindow *)&gAddDialog);
	mnwEvent_SetAll(&e, kEvent_SetID, nil, ID_EDIT_START_MIN, 0);
	mnwEvent_SendTo(&e, (mnwWindow *)&gEditStartMin);

	mnwRect_SetXYWH(&r,
			region_end_time_left, region_end_time_top,
			BUF_END_HOUR_LEN*F16_WIDTH+4, F16_HEIGHT+4);
	mnwWindow_Register((mnwWindow *)&gEditEndHour,
			   (mnwWindowCallback)mnwEdit_Callback,
			   (mnwWindow *)&gAddDialog, &r);
	mnwEvent_SetAll(&e, kEvent_SetTabStop, &gEditEndHour, 0, 0);
	mnwEvent_SendTo(&e, (mnwWindow *)(mnwWindow *)&gAddDialog);
	mnwEvent_SetAll(&e, kEvent_SetID, nil, ID_EDIT_END_HOUR, 0);
	mnwEvent_SendTo(&e, (mnwWindow *)&gEditEndHour);
	region_end_time_left += (BUF_END_HOUR_LEN+2)*F16_WIDTH+8;
	mnwRect_SetXYWH(&r,
			region_end_time_left, region_end_time_top,
			BUF_END_MIN_LEN*F16_WIDTH+4, F16_HEIGHT+4);
	mnwWindow_Register((mnwWindow *)&gEditEndMin,
			   (mnwWindowCallback)mnwEdit_Callback,
			   (mnwWindow *)&gAddDialog, &r);
	mnwEvent_SetAll(&e, kEvent_SetTabStop, &gEditEndMin, 0, 0);
	mnwEvent_SendTo(&e, (mnwWindow *)(mnwWindow *)&gAddDialog);
	mnwEvent_SetAll(&e, kEvent_SetID, nil, ID_EDIT_END_MIN, 0);
	mnwEvent_SendTo(&e, (mnwWindow *)&gEditEndMin);
    }

    /* 󥯥ȥ */
    if (hasRank(dialog_mode)){
	mnwRect_SetXYWH(&r,
			region_rank_left+F16_WIDTH*6+4, region_rank_top,
			BUF_RANK_LEN*F16_WIDTH+4, F16_HEIGHT+4);
	mnwWindow_Register((mnwWindow *)&gEditRank,
			   (mnwWindowCallback)mnwEdit_Callback,
			   (mnwWindow *)&gAddDialog, &r);
	mnwEvent_SetAll(&e, kEvent_SetTabStop, &gEditRank, 0, 0);
	mnwEvent_SendTo(&e, (mnwWindow *)(mnwWindow *)&gAddDialog);
	mnwEvent_SetAll(&e, kEvent_SetID, nil, ID_EDIT_RANK, 0);
	mnwEvent_SendTo(&e, (mnwWindow *)&gEditRank);
    }

    /* ֤ȥ */
    if (hasRepeat(dialog_mode)){
	mnwRect_SetXYWH(&r,
			region_repeat_left, region_repeat_top,
			region_repeat_width, region_repeat_height);
	mnwWindow_Register((mnwWindow *)&gListRepeat,
			   (mnwWindowCallback)mnwList_Callback,
			   (mnwWindow *)&gAddDialog, &r);
	mnwEvent_SetAll(&e, kEvent_SetTabStop, &gListRepeat, 0, 0);
	mnwEvent_SendTo(&e, (mnwWindow *)(mnwWindow *)&gAddDialog);
	mnwEvent_SetAll(&e, kEvent_SetID, nil, ID_LIST_REPEAT, 0);
	mnwEvent_SendTo(&e, (mnwWindow *)&gListRepeat);
	mnwRect_SetXYWH(&r,
			region_repeat_interval_left, region_repeat_interval_top,
			BUF_REPEAT_INTERVAL_LEN*F16_WIDTH+4, F16_HEIGHT+4);
	mnwWindow_Register((mnwWindow *)&gEditRepeatInterval,
			   (mnwWindowCallback)mnwEdit_Callback,
			   (mnwWindow *)&gAddDialog, &r);
	mnwEvent_SetAll(&e, kEvent_SetTabStop, &gEditRepeatInterval, 0, 0);
	mnwEvent_SendTo(&e, (mnwWindow *)(mnwWindow *)&gAddDialog);
	mnwEvent_SetAll(&e, kEvent_SetID, nil, ID_EDIT_REPEAT_INTERVAL, 0);
	mnwEvent_SendTo(&e, (mnwWindow *)&gEditRepeatInterval);
    }

    /* ٥륳ȥ */
    mnwRect_SetXYWH(&r,
		    region_label_left, region_label_top,
		    BUF_LABEL_LEN*F16_WIDTH+4, F16_HEIGHT+4);
    mnwWindow_Register((mnwWindow *)&gLabelLabel,
		       (mnwWindowCallback)mnwLabel_Callback,
		       (mnwWindow *)&gAddDialog, &r);
    mnwEvent_SetAll(&e, kEvent_SetID, nil, ID_STATIC_LABEL, 0);
    mnwEvent_SendTo(&e, (mnwWindow *)&gLabelLabel);
    mnwEvent_SetAll(&e, kEvent_SetStyle, nil, kStyle_Border, 0);
    mnwEvent_SendTo(&e, (mnwWindow *)&gLabelLabel);

    /* ѿʺơ */
    AddDlg_InitRegion();

    /* ȥν */
    AddDlg_InitControls();

    /* դ¸ */
    prev_start_date = getStartDateByBuf();
    if (hasEndDate(dialog_mode)){
	prev_end_date = getEndDateByBuf();
    }

    /* ǽΥȥ˥ե */
    mnwEvent_SetAll(&e, kEvent_KeyDown, nil, kKey_TAB, 0);
    mnwEvent_SendTo(&e, (mnwWindow *)self);

    /* ̾ѴON/OFF */
    if (!mnwIsIMEOn()){
	mnwToggleIME();		      /* ON */
    }

    return true;
}

/* ѿ */
static bool
AddDlg_InitRegion(void)
{
    switch (dialog_size){
	case DIALOG_NORMAL:
	description_cols = 53;
	description_rows = 3;
	region_dialog_width = 483;
	region_dialog_height = 193;
	region_title_left = (region_dialog_width-(F16_WIDTH*strlen(dialogTitle[dialog_mode])))/2;
	region_title_top = 6;
	region_description_left = 22;
	region_description_top = EDIT_1stLINE_NORMAL;
	region_start_date_left = 22;
	region_start_date_top = EDIT_2ndLINE_NORMAL;
	region_end_date_left = 22+186;
	region_end_date_top = EDIT_2ndLINE_NORMAL;
	region_start_time_left = 22;
	region_start_time_top = EDIT_3rdLINE_NORMAL;
	region_end_time_left = 22+94;
	region_end_time_top = EDIT_3rdLINE_NORMAL;
	region_rank_left = 22+186;
	region_rank_top = EDIT_2ndLINE_NORMAL;
	region_repeat_left = 22+186;
	region_repeat_top = EDIT_3rdLINE_NORMAL;
	region_repeat_width = 14*F16_WIDTH+24;
	region_repeat_height = 3*F16_HEIGHT+4;
	region_repeat_label_left = region_repeat_left-8*F16_WIDTH-4;
	region_repeat_label_top = region_repeat_top+2*F16_HEIGHT+4;
	region_repeat_interval_left = region_repeat_left+150;
	region_repeat_interval_top = region_repeat_top+2*F16_HEIGHT;
	region_label_left = 22;
	region_label_top = EDIT_5thLINE_NORMAL;
	break;

	case DIALOG_LARGE:
	description_cols = 74;
	description_rows = 5;
	region_dialog_width = 640;
	region_dialog_height = 202;
	region_title_left = (region_dialog_width-(F16_WIDTH*strlen(dialogTitle[dialog_mode])))/2;
	region_title_top = 6;
	region_description_left = 22;
	region_description_top = EDIT_1stLINE_LARGE;
	region_start_date_left = 22;
	region_start_date_top = EDIT_2ndLINE_LARGE;
	region_end_date_left = 22+186;
	region_end_date_top = EDIT_2ndLINE_LARGE;
	region_start_time_left = 22;
	region_start_time_top = EDIT_3rdLINE_LARGE;
	region_end_time_left = 22+94;
	region_end_time_top = EDIT_3rdLINE_LARGE;
	region_rank_left = 22+186;
	region_rank_top = EDIT_2ndLINE_LARGE;
	region_repeat_left = 22+186+16*11;
	region_repeat_top = EDIT_2ndLINE_LARGE;
	region_repeat_width = 14*F16_WIDTH+24;
	region_repeat_height = 3*F16_HEIGHT+4;
	region_repeat_label_left = region_repeat_left-8*F16_WIDTH-4;
	region_repeat_label_top = region_repeat_top+2*F16_HEIGHT+4;
	region_repeat_interval_left = region_repeat_left+150;
	region_repeat_interval_top = region_repeat_top+2*F16_HEIGHT;
	region_label_left = 22+526;
	region_label_top = EDIT_2ndLINE_LARGE;
	break;

	case DIALOG_SMALL:
	description_cols = 23;
	description_rows = 2;
	region_dialog_width = 212;
	region_dialog_height = 201;
	region_title_left = (region_dialog_width-(F16_WIDTH*strlen(dialogTitle[dialog_mode])))/2;
	region_title_top = 6;
	region_description_left = 10;
	region_description_top = EDIT_1stLINE_SMALL;
	region_start_date_left = 10;
	region_start_date_top = EDIT_2ndLINE_SMALL;
	region_end_date_left = 10+16;
	region_end_date_top = EDIT_3rdLINE_SMALL;
	region_start_time_left = 10;
	region_start_time_top = EDIT_4thLINE_SMALL;
	region_end_time_left = 10+94;
	region_end_time_top = EDIT_4thLINE_SMALL;
	region_rank_left = 10;
	region_rank_top = EDIT_3rdLINE_SMALL;
	region_repeat_left = 10;
	region_repeat_top = EDIT_5thLINE_SMALL;
	region_repeat_width = 14*F12_WIDTH+27;
	region_repeat_height = 3*F12_HEIGHT+6;
	region_repeat_label_left = region_repeat_left-8*F12_WIDTH-4;
	region_repeat_label_top = region_repeat_top+2*F12_HEIGHT+4;
	region_repeat_interval_left = region_repeat_left+115;
	region_repeat_interval_top = region_repeat_top+2*F12_HEIGHT+2-2;
	region_label_left = 125;
	region_label_top = EDIT_5thLINE_SMALL;
	break;
    }

    region_dialog_left = (640 - region_dialog_width)/2;
    region_dialog_top = (240 - region_dialog_height)/2 + 1;
    region_dialog_right = region_dialog_left + region_dialog_width - 1;
    region_dialog_bottom = region_dialog_top + region_dialog_height - 1;

    return true;
}

/* ȥν */
static void
AddDlg_InitControls(void)
{
    uint16 year, month, day, dayWeek;
    char *buf = bufGeneric;
    mnwEvent e;

    /* ҥȥν */
    memset(bufDescription, 0, BUF_DESCRIPTION_LEN);
    if (isAddMode(dialog_mode)){
	buf[0] = '\0';
	GenDlg_InitEditControl(&gEditDescription, bufDescription, BUF_DESCRIPTION_LEN, buf);
    }else{
	memcpy(buf, editRecord->descript, editRecord->descript_len);
	buf[editRecord->descript_len] = '\0';
	GenDlg_InitEditControl(&gEditDescription, bufDescription, BUF_DESCRIPTION_LEN, buf);
    }

    /* եȥν */
    if (isAddMode(dialog_mode)){
	Calendar_GetDateByNo(gCursorDate, &year, &month, &day);
	sprintf(buf, "%d", year);
	GenDlg_InitEditControl(&gEditStartYear, bufStartYear, BUF_START_YEAR_LEN, buf);
	sprintf(buf, "%d", month);
	GenDlg_InitEditControl(&gEditStartMonth, bufStartMonth, BUF_START_MONTH_LEN, buf);
	sprintf(buf, "%d", day);
	GenDlg_InitEditControl(&gEditStartDay, bufStartDay, BUF_START_DAY_LEN, buf);
	if (hasEndDate(dialog_mode)){
	    sprintf(buf, "%d", year);
	    GenDlg_InitEditControl(&gEditEndYear, bufEndYear, BUF_END_YEAR_LEN, buf);
	    sprintf(buf, "%d", month);
	    GenDlg_InitEditControl(&gEditEndMonth, bufEndMonth, BUF_END_MONTH_LEN, buf);
	    sprintf(buf, "%d", day);
	    GenDlg_InitEditControl(&gEditEndDay, bufEndDay, BUF_END_DAY_LEN, buf);
	}
    }else{
	Calendar_GetDateByNo(editRecord->start_date, &year, &month, &day);
	sprintf(buf, "%d", year);
	GenDlg_InitEditControl(&gEditStartYear, bufStartYear, BUF_START_YEAR_LEN, buf);
	sprintf(buf, "%d", month);
	GenDlg_InitEditControl(&gEditStartMonth, bufStartMonth, BUF_START_MONTH_LEN, buf);
	sprintf(buf, "%d", day);
	GenDlg_InitEditControl(&gEditStartDay, bufStartDay, BUF_START_DAY_LEN, buf);
	if (hasEndDate(dialog_mode)){
	    Calendar_GetDateByNo(editRecord->end_date, &year, &month, &day);
	    sprintf(buf, "%d", year);
	    GenDlg_InitEditControl(&gEditEndYear, bufEndYear, BUF_END_YEAR_LEN, buf);
	    sprintf(buf, "%d", month);
	    GenDlg_InitEditControl(&gEditEndMonth, bufEndMonth, BUF_END_MONTH_LEN, buf);
	    sprintf(buf, "%d", day);
	    GenDlg_InitEditControl(&gEditEndDay, bufEndDay, BUF_END_DAY_LEN, buf);
	}
    }
    
    /* Υȥ */
    if (isAddMode(dialog_mode)){
	dayWeek = Calendar_GetDayOfWeekByNo(gCursorDate);
	mnwEvent_SetAll(&e, kEvent_SetBuffer,
			bufStartDayWeek, BUF_START_DAYWEEK_LEN, 0);
	mnwEvent_SendTo(&e, (mnwWindow *)&gLabelStartDayWeek);
	mnwEvent_SetAll(&e, kEvent_SetText, 
			nameDayWeek[dayWeek], sizeof(nameDayWeek[dayWeek]), 0);
	mnwEvent_SendTo(&e, (mnwWindow *)&gLabelStartDayWeek);
	if (hasEndDate(dialog_mode)){
	    mnwEvent_SetAll(&e, kEvent_SetBuffer,
			    bufEndDayWeek, BUF_END_DAYWEEK_LEN, 0);
	    mnwEvent_SendTo(&e, (mnwWindow *)&gLabelEndDayWeek);
	    mnwEvent_SetAll(&e, kEvent_SetText, 
			    nameDayWeek[dayWeek],
			    sizeof(nameDayWeek[dayWeek]), 0);
	    mnwEvent_SendTo(&e, (mnwWindow *)&gLabelEndDayWeek);
	}
    }else{
	dayWeek = Calendar_GetDayOfWeekByNo(editRecord->start_date);
	mnwEvent_SetAll(&e, kEvent_SetBuffer,
			bufStartDayWeek, BUF_START_DAYWEEK_LEN, 0);
	mnwEvent_SendTo(&e, (mnwWindow *)&gLabelStartDayWeek);
	mnwEvent_SetAll(&e, kEvent_SetText, 
			nameDayWeek[dayWeek], sizeof(nameDayWeek[dayWeek]), 0);
	mnwEvent_SendTo(&e, (mnwWindow *)&gLabelStartDayWeek);
	if (hasEndDate(dialog_mode)){
	    dayWeek = Calendar_GetDayOfWeekByNo(editRecord->end_date);
	    mnwEvent_SetAll(&e, kEvent_SetBuffer,
			    bufEndDayWeek, BUF_END_DAYWEEK_LEN, 0);
	    mnwEvent_SendTo(&e, (mnwWindow *)&gLabelEndDayWeek);
	    mnwEvent_SetAll(&e, kEvent_SetText, 
			    nameDayWeek[dayWeek],
			    sizeof(nameDayWeek[dayWeek]), 0);
	    mnwEvent_SendTo(&e, (mnwWindow *)&gLabelEndDayWeek);
	}
    }

    /* 拾ȥν */
    if (hasTime(dialog_mode) && isAddMode(dialog_mode)){
	if (View_HasTimeTable()){
	    if (gCursorHour + gCursorHourRange < 24){
		sprintf(buf, "%d", gCursorHour);
		GenDlg_InitEditControl(&gEditStartHour, bufStartHour, BUF_START_HOUR_LEN, buf);
		sprintf(buf, "%d", gCursorHour+gCursorHourRange);
		GenDlg_InitEditControl(&gEditEndHour, bufEndHour, BUF_END_HOUR_LEN, buf);
		sprintf(buf, "0");
		GenDlg_InitEditControl(&gEditStartMin, bufStartMin, BUF_START_MIN_LEN, buf);
		GenDlg_InitEditControl(&gEditEndMin, bufEndMin, BUF_END_MIN_LEN, buf);
	    }else{
		sprintf(buf, "%d", gCursorHour);
		GenDlg_InitEditControl(&gEditStartHour, bufStartHour, BUF_START_HOUR_LEN, buf);
		sprintf(buf, "24");
		GenDlg_InitEditControl(&gEditEndHour, bufEndHour, BUF_END_HOUR_LEN, buf);
		sprintf(buf, "0");
		GenDlg_InitEditControl(&gEditStartMin, bufStartMin, BUF_START_MIN_LEN, buf);
		sprintf(buf, "0");
		GenDlg_InitEditControl(&gEditEndMin, bufEndMin, BUF_END_MIN_LEN, buf);
	    }
	}else{
	    sprintf(buf, "--");
	    GenDlg_InitEditControl(&gEditStartHour, bufStartHour, BUF_START_HOUR_LEN, buf);
	    GenDlg_InitEditControl(&gEditEndHour, bufEndHour, BUF_END_HOUR_LEN, buf);
	    GenDlg_InitEditControl(&gEditStartMin, bufStartMin, BUF_START_MIN_LEN, buf);
	    GenDlg_InitEditControl(&gEditEndMin, bufEndMin, BUF_END_MIN_LEN, buf);
	}
    }else if (hasTime(dialog_mode) && isEditMode(dialog_mode)){
	if (editRecord->u.sche.end_time_h == 0 && editRecord->u.sche.end_time_h == 0){
	    sprintf(buf, "--");
	    GenDlg_InitEditControl(&gEditStartHour, bufStartHour, BUF_START_HOUR_LEN, buf);
	    GenDlg_InitEditControl(&gEditEndHour, bufEndHour, BUF_END_HOUR_LEN, buf);
	    GenDlg_InitEditControl(&gEditStartMin, bufStartMin, BUF_START_MIN_LEN, buf);
	    GenDlg_InitEditControl(&gEditEndMin, bufEndMin, BUF_END_MIN_LEN, buf);
	}else{
	    sprintf(buf, "%d", editRecord->u.sche.start_time_h);
	    GenDlg_InitEditControl(&gEditStartHour, bufStartHour, BUF_START_HOUR_LEN, buf);
	    sprintf(buf, "%d", editRecord->u.sche.start_time_m);
	    GenDlg_InitEditControl(&gEditStartMin, bufStartMin, BUF_START_MIN_LEN, buf);
	    sprintf(buf, "%d", editRecord->u.sche.end_time_h);
	    GenDlg_InitEditControl(&gEditEndHour, bufEndHour, BUF_END_HOUR_LEN, buf);
	    sprintf(buf, "%d", editRecord->u.sche.end_time_m);
	    GenDlg_InitEditControl(&gEditEndMin, bufEndMin, BUF_END_MIN_LEN, buf);
	}
    }

    /* 󥯥ȥν */
    if (hasRank(dialog_mode) && isAddMode(dialog_mode)){
	sprintf(buf, "%d", 3);
	GenDlg_InitEditControl(&gEditRank, bufRank, BUF_RANK_LEN, buf);
    }else if (hasRank(dialog_mode) && isEditMode(dialog_mode)){
	sprintf(buf, "%d", editRecord->u.task.rank);
	GenDlg_InitEditControl(&gEditRank, bufRank, BUF_RANK_LEN, buf);
    }    

    /* ֤ȥ */
    if (hasRepeat(dialog_mode)){
	if (dialog_size == DIALOG_SMALL){
	    mnwEvent_SetAll(&e, kEvent_SetFont, nil, kFont_12, 0);
	    mnwEvent_SendTo(&e, (mnwWindow *)&gListRepeat);
	}
	if (isAddMode(dialog_mode)){
	    local_repeat_type = REPEAT_TYPE_NONE;
	    AddDlg_InitRepeatControl(gCursorDate);
	    sprintf(buf, "%d", 1);
	    GenDlg_InitEditControl(&gEditRepeatInterval, bufRepeatInterval,
				   BUF_REPEAT_INTERVAL_LEN, buf);
	}else if (isEditMode(dialog_mode)){
	    local_repeat_type = editRecord->repeat_type;
	    AddDlg_InitRepeatControl(editRecord->start_date);
	    if (editRecord->repeat_every < 1)
		editRecord->repeat_every = 1;
	    sprintf(buf, "%d", editRecord->repeat_every);
	    GenDlg_InitEditControl(&gEditRepeatInterval, bufRepeatInterval,
				   BUF_REPEAT_INTERVAL_LEN, buf);
	}
    }

    /* ٥ν */
    mnwEvent_SetAll(&e, kEvent_SetBuffer,
		    bufLabel, BUF_LABEL_LEN, 0);
    mnwEvent_SendTo(&e, (mnwWindow *)&gLabelLabel);
    if (isAddMode(dialog_mode)){
	if (gOpt_Label1Default){
	    AddDlg_SetLabel(1);
	}else{
	    if (gLabel < 5){
		AddDlg_SetLabel(gLabel);
	    }else{
		AddDlg_SetLabel(0);
	    }
	}
    }else{
	AddDlg_SetLabel(editRecord->label);
    }
}

/* Addդ */
static bool
AddDlg_Destroy(mnwDialog *self)
{
    D(mnwDPrintf("Add destroy\n"));

    if (mnwIsIMEOn()){
	mnwToggleIME();			      /* OFF */
    }
 
    mnwWindow_UnRegister((mnwWindow *)&gEditDescription);

    mnwWindow_UnRegister((mnwWindow *)&gEditStartYear);
    mnwWindow_UnRegister((mnwWindow *)&gEditStartMonth);
    mnwWindow_UnRegister((mnwWindow *)&gEditStartDay);
    if (hasEndDate(dialog_mode)){
	mnwWindow_UnRegister((mnwWindow *)&gEditEndYear);
	mnwWindow_UnRegister((mnwWindow *)&gEditEndMonth);
	mnwWindow_UnRegister((mnwWindow *)&gEditEndDay);
    }

    mnwWindow_UnRegister((mnwWindow *)&gLabelStartDayWeek);
    if (hasEndDate(dialog_mode)){
	mnwWindow_UnRegister((mnwWindow *)&gLabelEndDayWeek);
    }

    if (hasTime(dialog_mode)){
	mnwWindow_UnRegister((mnwWindow *)&gEditStartHour);
	mnwWindow_UnRegister((mnwWindow *)&gEditStartMin);
	mnwWindow_UnRegister((mnwWindow *)&gEditEndHour);
	mnwWindow_UnRegister((mnwWindow *)&gEditEndMin);
    }

    if (hasRank(dialog_mode)){
	mnwWindow_UnRegister((mnwWindow *)&gEditRank);
    }    

    if (hasRepeat(dialog_mode)){
	mnwWindow_UnRegister((mnwWindow *)&gListRepeat);
	mnwWindow_UnRegister((mnwWindow *)&gEditRepeatInterval);
    }    

    mnwWindow_UnRegister((mnwWindow *)&gLabelLabel);

    /* ե󥯥󥭡ͭ */
    FuncKey_SetMainMode();

    gMode = MODE_VIEW;

    return true;
}

/* ֤ȥν */
static void
AddDlg_InitRepeatControl(uint16 date)
{
    mnwEvent e;

    mnwEvent_SetAll(&e, kEvent_SetBuffer, bufRepeat, 32, 7);
    mnwEvent_SendTo(&e, (mnwWindow *)&gListRepeat);

    /* Ƥν */
    AddDlg_ResetRepeatControl(date);
}

/* ֤ȥκ */
static void
AddDlg_ResetRepeatControl(uint16 date)
{
    int no;
    mnwEvent e;
    uint16 year, month, day, dayWeek, nthWeek, numOfDays;
    char *kanjiNum[] = {
	"", "", "", "", "", "",
    };
    static char bufWeekly[16];
    static char bufMonthlyDay[16];
    static char bufMonthlyWeek[16];
    static char bufYearlyDay[16];
    static char bufYearlyWeek[16];
    char *p;

    /* 3/13/1998ξ		ɽ
       REPEAT_TYPE_NONE		ʤ
       REPEAT_TYPE_DAILY	
       REPEAT_TYPE_WEEKLY	
       REPEAT_TYPE_MONTHLYDAY	13
       REPEAT_TYPE_MONTHLYWEEK	2
       REPEAT_TYPE_YEARLYDAY	313
       REPEAT_TYPE_YEARLYWEEK	32
       */

    Calendar_GetDateByNo(date, &year, &month, &day);
    dayWeek = Calendar_GetDayOfWeekByNo(date);
    nthWeek = (day / 7)+((day%7)?1:0);
    numOfDays = Calendar_GetNumOfDays(year, month);

    no = 0;

    /* REPEAT_TYPE_NONE */
    mnwEvent_SetAll(&e, kEvent_SetText, "ʤ", no++, 4);
    mnwEvent_SendTo(&e, (mnwWindow *)&gListRepeat);
    
    /* REPEAT_TYPE_DAILY */
    mnwEvent_SetAll(&e, kEvent_SetText, "", no++, 2);
    mnwEvent_SendTo(&e, (mnwWindow *)&gListRepeat);
    
    /* REPEAT_TYPE_WEEKLY */
    p = bufWeekly;
    sprintf(p, "%s", nameDayWeek[dayWeek]);
    mnwEvent_SetAll(&e, kEvent_SetText, p, no++, strlen(p));
    mnwEvent_SendTo(&e, (mnwWindow *)&gListRepeat);

    /* REPEAT_TYPE_MONTHLYDAY */
    p = bufMonthlyDay;
    sprintf(p, "%d", day);
    mnwEvent_SetAll(&e, kEvent_SetText, p, no++, strlen(p));
    mnwEvent_SendTo(&e, (mnwWindow *)&gListRepeat);

    /* REPEAT_TYPE_MONTHLYWEEK */
    p = bufMonthlyWeek;
    if (numOfDays-day >= 7){
	sprintf(p, "%s%s", kanjiNum[nthWeek], nameDayWeek[dayWeek]);
	mnwEvent_SetAll(&e, kEvent_SetText, p, no++, strlen(p));
	mnwEvent_SendTo(&e, (mnwWindow *)&gListRepeat);
    }else{
	sprintf(p, "ǽ%s", nameDayWeek[dayWeek]);
	mnwEvent_SetAll(&e, kEvent_SetText, p, no++, strlen(p));
	mnwEvent_SendTo(&e, (mnwWindow *)&gListRepeat);
    }

    /* REPEAT_TYPE_YEARLYDAY */
    p = bufYearlyDay;
    sprintf(p, "%d%d", month, day);
    mnwEvent_SetAll(&e, kEvent_SetText, p, no++, strlen(p));
    mnwEvent_SendTo(&e, (mnwWindow *)&gListRepeat);

    /* REPEAT_TYPE_YEARLYWEEK */
    p = bufYearlyWeek;
    if (numOfDays-day >= 7){
	sprintf(p, "%d%s%s", month, kanjiNum[nthWeek], nameDayWeek[dayWeek]);
	mnwEvent_SetAll(&e, kEvent_SetText, p, no++, strlen(p));
	mnwEvent_SendTo(&e, (mnwWindow *)&gListRepeat);
    }else{
	sprintf(p, "%dǽ%s", month, nameDayWeek[dayWeek]);
	mnwEvent_SetAll(&e, kEvent_SetText, p, no++, strlen(p));
	mnwEvent_SendTo(&e, (mnwWindow *)&gListRepeat);
    }

    /* ߤͤ˥å */
    mnwEvent_SetAll(&e, kEvent_SetCursor, nil, local_repeat_type, 0);
    mnwEvent_SendTo(&e, (mnwWindow *)&gListRepeat);

    /*  */
    mnwEvent_SetAll(&e, kEvent_Redraw, nil, 0, 0);
    mnwEvent_SendTo(&e, (mnwWindow *)&gListRepeat);
}

/* ֤ȥͼ */
static void
AddDlg_GetRepeatControl(void)
{
    mnwEvent e;
    mnwEvent_SetAll(&e, kEvent_GetResult, &local_repeat_type, 0, 0);
    mnwEvent_SendToDirect(&e, (mnwWindow *)&gListRepeat);
}

/* ٥ */
static void
AddDlg_SetLabel(uint16 label)
{
    mnwEvent e;
    local_label = label;
    mnwEvent_SetAll(&e, kEvent_SetText,
		    Context_GetLabelName(local_label),
		    strlen(Context_GetLabelName(local_label)), 0);
    mnwEvent_SendTo(&e, (mnwWindow *)&gLabelLabel);
    mnwEvent_SetAll(&e, kEvent_Redraw, nil, 0, 0);
    mnwEvent_SendTo(&e, (mnwWindow *)&gLabelLabel);
}

/* Addɥ */
static bool
AddDlg_Redraw(mnwDialog *self)
{
    mnwRect r;
    int left, top;

    if (!dialog_visible){
	return false;
    }

    left = region_dialog_left;
    top = region_dialog_top;

    /* ط */
    mnwRect_SetXYWH(&r, left, top, region_dialog_width, region_dialog_height);
    mnwSetForeColor(kColor_LtGray);
    mnwFillRect(&r);

    /*  */
    mnwSetForeColor(kColor_Black);
    mnwDrawRect(&r);
    mnwRect_Inset(&r, 1, 1);
    mnwDrawFrame3D(&r);

    /* ȥ */
    mnwSetFont(kFont_16);
    mnwSetForeColor(kColor_Black);
    mnwDrawText(left+region_title_left, top+region_title_top,
		dialogTitle[dialog_mode], strlen(dialogTitle[dialog_mode]));

    /*  */
    mnwDrawLine(left+20, top+F16_HEIGHT+10,
		region_dialog_right-20, top+F16_HEIGHT+10);

    /* դδ */
    mnwSetFont(kFont_16);
    mnwSetForeColor(kColor_Black);
    mnwDrawText(left+region_start_date_left+4*F16_WIDTH+1*8-2,
		top+region_start_date_top+2, "ǯ", 2);
    mnwDrawText(left+region_start_date_left+8*F16_WIDTH+2*8-2,
		top+region_start_date_top+2, "", 2);
    mnwDrawText(left+region_start_date_left+12*F16_WIDTH+3*8-2,
		top+region_start_date_top+2, "", 2);
    mnwDrawText(left+region_start_date_left+14*F16_WIDTH+3*8-2,
		top+region_start_date_top+2, "(", 1);
    mnwDrawText(left+region_start_date_left+17*F16_WIDTH+3*8,
		top+region_start_date_top+2, ")", 1);
    if (hasEndDate(dialog_mode)){
	mnwDrawText(left+region_start_date_left+17*F16_WIDTH+4*8,
		    top+region_start_date_top+2, "", 2);
	mnwDrawText(left+region_end_date_left+4*F16_WIDTH+1*8-2,
		    top+region_end_date_top+2, "ǯ", 2);
	mnwDrawText(left+region_end_date_left+8*F16_WIDTH+2*8-2,
		    top+region_end_date_top+2, "", 2);
	mnwDrawText(left+region_end_date_left+12*F16_WIDTH+3*8-2,
		    top+region_end_date_top+2, "", 2);
	mnwDrawText(left+region_end_date_left+14*F16_WIDTH+3*8-2,
		    top+region_end_date_top+2, "(", 1);
	mnwDrawText(left+region_end_date_left+17*F16_WIDTH+3*8,
		    top+region_end_date_top+2, ")", 1);
    }

    /* δ */
    if (hasTime(dialog_mode)){
	mnwSetFont(kFont_16);
	mnwSetForeColor(kColor_Black);
	mnwDrawText(left+region_start_time_left+2*F16_WIDTH+1*8-2,
		    top+region_start_time_top+2, "", 2);
	mnwDrawText(left+region_start_time_left+6*F16_WIDTH+2*8-2,
		    top+region_start_time_top+2, "ʬ", 4);
	mnwDrawText(left+region_end_time_left+2*F16_WIDTH+1*8-2,
		    top+region_end_time_top+2, "", 2);
	mnwDrawText(left+region_end_time_left+6*F16_WIDTH+2*8-2,
		    top+region_end_time_top+2, "ʬ", 4);
    }

    /*  */
    if (hasRank(dialog_mode)){
	mnwSetFont(kFont_16);
	mnwSetForeColor(kColor_Black);
	mnwDrawText(left+region_rank_left,
		    top+region_rank_top+2, "", 6);
    }

    /* ֤ */
    if (hasRepeat(dialog_mode)){
	mnwSetFont(kFont_16);
	mnwSetForeColor(kColor_Black);
	if (dialog_size != DIALOG_SMALL){
	    mnwDrawText(left+region_repeat_label_left,
			top+region_repeat_label_top, "֤", 8);
	}
	mnwDrawText(left+region_repeat_interval_left+F16_WIDTH*2+6,
		    top+region_repeat_interval_top+2, "Ĥ", 6);
    }
    return true;
}

/* դͤϰϤ */
static bool
AddDlg_FixDateRange(bool fix_end)
{
    uint16 start_date, end_date;
    mnwEvent e;

    D(mnwDPrintf("fixing value range"));

    /* å */
    start_date = getStartDateByBuf();
    end_date = 0;			      /* dummy */
    if (hasEndDate(dialog_mode)){
	end_date = getEndDateByBuf();
    }

    /*  */
    if (hasEndDate(dialog_mode)){
	if (start_date > end_date){
	    if (!fix_end){
		GenDlg_ResetControl(&gEditStartYear, bufEndYear);
		GenDlg_ResetControl(&gEditStartMonth, bufEndMonth);
		GenDlg_ResetControl(&gEditStartDay, bufEndDay);
		start_date = end_date;
	    }else{
		GenDlg_ResetControl(&gEditEndYear, bufStartYear);
		GenDlg_ResetControl(&gEditEndMonth, bufStartMonth);
		GenDlg_ResetControl(&gEditEndDay, bufStartDay);
		end_date = start_date;
	    }
	}
    }
    
    /*  */
    mnwEvent_SetAll(&e, kEvent_SetText,
		    nameDayWeek[Calendar_GetDayOfWeekByNo(start_date)],
		    strlen(nameDayWeek[Calendar_GetDayOfWeekByNo(start_date)]),
		    0);
    mnwEvent_SendTo(&e, (mnwWindow *)&gLabelStartDayWeek);
    mnwEvent_SetAll(&e, kEvent_Redraw, nil, 0, 0);
    mnwEvent_SendTo(&e, (mnwWindow *)&gLabelStartDayWeek);
    if (hasEndDate(dialog_mode)){
	mnwEvent_SetAll(&e, kEvent_SetText, 
			nameDayWeek[Calendar_GetDayOfWeekByNo(end_date)],
			strlen(nameDayWeek[Calendar_GetDayOfWeekByNo(end_date)]),
			0);
	mnwEvent_SendTo(&e, (mnwWindow *)&gLabelEndDayWeek);
	mnwEvent_SetAll(&e, kEvent_Redraw, nil, 0, 0);
	mnwEvent_SendTo(&e, (mnwWindow *)&gLabelEndDayWeek);
    }

    return false;
}

/* ͤϰϤ */
static bool
AddDlg_FixTimeRange(bool fix_end)
{
    uint16 start_hour, end_hour;
    uint16 start_min, end_min;

    start_hour = atoi(bufStartHour);
    start_min = atoi(bufStartMin);
    end_hour = atoi(bufEndHour);
    end_min = atoi(bufEndMin);

    /* å */
    if (start_hour == 24 && start_min > 0){
	GenDlg_ResetControl(&gEditStartMin, "0");
	start_min = 0;
    }
    if (end_hour == 24 && end_min > 0){
	GenDlg_ResetControl(&gEditEndMin, "0");
	end_min = 0;
    }

    /* طå */
    if (start_hour * 60+start_min <= end_hour * 60+end_min){
	return true;
    }

    /*  */
    if (!fix_end){
	if (end_hour == 0){
	    GenDlg_ResetControl(&gEditEndHour, "0");
	}
	if (end_min == 0){
	    GenDlg_ResetControl(&gEditEndMin, "0");
	}
	GenDlg_ResetControl(&gEditStartHour, bufEndHour);
	GenDlg_ResetControl(&gEditStartMin, bufEndMin);
    }else{
	if (start_hour == 0){
	    GenDlg_ResetControl(&gEditStartHour, "0");
	}
	if (start_min ==0){
	    GenDlg_ResetControl(&gEditStartMin, "0");
	}
	GenDlg_ResetControl(&gEditEndHour, bufStartHour);
	GenDlg_ResetControl(&gEditEndMin, bufStartMin);
    }

    return false;
}

/* եʤʤäȤν */
static bool
AddDlg_LostFocusNotify(mnwDialog *self, mnwEvent *event)
{
    bool r;
    static bool checking = false;
    uint16 start_date, end_date;
    mnwWindow *win;

    win = event->param0;
    if (!win){
	return false;
    }

    if (checking){
	/* ťåɻ */
	return true;
    }

    /* ե줿ȥ° */
    GenDlg_MoveFocus(win->id);

    /* ͤå򤹤 */
    switch (win->id){
	case ID_LIST_REPEAT:
	AddDlg_GetRepeatControl();
	if (local_repeat_type != REPEAT_TYPE_NONE
	    && getStartDateByBuf() == getEndDateByBuf()){
	    /* ֤ꤵƤΤ˴֤ */
	    /* λǯ򣱤䤹 */
	    char buf[10];
	    sprintf(buf, "%d", atoi(bufEndYear)+1);
	    GenDlg_ResetControl(&gEditEndYear, buf);
	}
	checking = false;
	return true;
	break;
	case ID_EDIT_DESCRIPTION:
	checking = false;
	return true;
	break;
    }
    checking = true;
    r = GenDlg_CheckValueRange((mnwEdit *)win);
    checking = false;
    if (!r){
	return false;
    }

    start_date = getStartDateByBuf();
    end_date = getEndDateByBuf();
    if (start_date == prev_start_date && end_date == prev_end_date){
	/* դѹʤ */

	/* ͤϰϤ */
	switch (win->id){
	    case ID_EDIT_START_HOUR:
	    case ID_EDIT_START_MIN:
	    AddDlg_FixTimeRange(true);
	    break;
	    case ID_EDIT_END_HOUR:
	    case ID_EDIT_END_MIN:
	    AddDlg_FixTimeRange(false);
	    break;
	}
    }else{
	/* դѹ */

	/* ͤϰϤ */
	switch (win->id){
	    case ID_EDIT_START_YEAR:
	    case ID_EDIT_START_MONTH:
	    case ID_EDIT_START_DAY:
	    AddDlg_FixDateRange(true);
	    break;
	    case ID_EDIT_END_YEAR:
	    case ID_EDIT_END_MONTH:
	    case ID_EDIT_END_DAY:
	    AddDlg_FixDateRange(false);
	    break;
	}

	start_date = getStartDateByBuf();

	/* ֤ꥹȤι */
	if (hasRepeat(dialog_mode)){
	    if (start_date != prev_start_date){
		AddDlg_ResetRepeatControl(start_date);
	    }
	}

	/* դ¸ */
	prev_start_date = start_date;
	prev_end_date = end_date;
    }

    return true;
}

/* եȤν */
static bool
AddDlg_GainFocusNotify(mnwDialog *self, mnwEvent *event)
{
    mnwWindow *win;
    mnwEvent e;

    win = event->param0;
    if (!win){
	return false;
    }

    /* ٤ǤʤȤ */
    if (should_focus != nil){
	/* ե᤹ */
	mnwEvent_SetFocusWindow((mnwWindow *)should_focus);
	should_focus = nil;
	return false;
    }

    /* ե줿ȥ° */
    GenDlg_MoveFocus(win->id);

    /* ˤ */
    mnwEvent_SetAll(&e, kEvent_SetCursor, nil, 0, -1);
    mnwEvent_SendTo(&e, win);

    /* ̾ѴON/OFF */
    switch (win->id){
	case ID_EDIT_DESCRIPTION:
	if (!mnwIsIMEOn()){
	    mnwToggleIME();		      /* ON */
	}
	break;

	default:
	if (mnwIsIMEOn()){
	    mnwToggleIME();		      /* OFF */
	}
	break;
    }
    return true;
}

/* եȤν */
static bool
AddDlg_ChangedNotify(mnwDialog *self, mnwEvent *event)
{
    mnwWindow *win;

    win = event->param0;
    if (!win){
	return false;
    }

    return GenDlg_ValueChanged(win);
}

/* Ͽ */
static bool
AddDlg_Register(void)
{
    Record *rec;
    bool r;

    D(mnwDPrintf("try register"));

    /* ͤå */
    if (value_invalid){
	D(mnwDPrintf("value invalid"));
	return false;
    }
    if (strlen(bufDescription) <= 0){
	D(mnwDPrintf("value invalid"));
	return false;
    }

    D(mnwDPrintf("allocate record"));

    /* 쥳ɳ */
    rec = Record_AllocateRecord(1);
    if (rec == nil){
	return false;
    }

    /* 쥳ɤν */
    if (isAddMode(dialog_mode)){
	memset(rec, 0, sizeof(Record));
    }else{
	memcpy(rec, editRecord, sizeof(Record));
    }

    rec->len = sizeof(Record);		      /* NOTE: This may be error. */

    /*  */
    rec->descript_len = strlen(bufDescription);
    rec->descript = Record_AllocateByte(rec->descript_len);
    if (rec->descript == nil){
	return false;
    }
    memcpy(rec->descript, bufDescription, rec->descript_len);

    /* ա */
    switch (dialog_mode){
	case ADDITEM_SCHEDULE:
	case EDITITEM_SCHEDULE:
	rec->type = RECORD_TYPE_SCHEDULE;
	rec->start_date = getStartDateByBuf();
	rec->end_date = getEndDateByBuf();
	rec->u.sche.start_time_h = (uint8)atoi(bufStartHour);
	rec->u.sche.start_time_m = (uint8)atoi(bufStartMin);
	rec->u.sche.end_time_h = (uint8)atoi(bufEndHour);
	rec->u.sche.end_time_m = (uint8)atoi(bufEndMin);
	break;

	case ADDITEM_TASK:
	case EDITITEM_TASK:
	rec->type = RECORD_TYPE_TASK;
	rec->start_date = getStartDateByBuf();
	rec->end_date = DATE_THE_END;
	rec->u.task.rank = (uint8)atoi(bufRank);
	break;

	case ADDITEM_HOLIDAY:
	case EDITITEM_HOLIDAY:
	rec->type = RECORD_TYPE_HOLIDAY;
	rec->start_date = getStartDateByBuf();
	rec->end_date = getEndDateByBuf();
	break;

	default:
	break;
    }

    /* ֤ */
    if (hasRepeat(dialog_mode)){
	uint16 year, month, day, dayWeek, nthWeek, numOfDays;

	Calendar_GetDateByNo(rec->start_date, &year, &month, &day);
	dayWeek = Calendar_GetDayOfWeekByNo(rec->start_date);
	nthWeek = (day / 7)+((day%7)?1:0);
	numOfDays = Calendar_GetNumOfDays(year, month);

	AddDlg_GetRepeatControl();
	if (numOfDays-day < 7){
	    nthWeek = 5;
	}
	rec->repeat_type = local_repeat_type;
	rec->repeat_every = (uint8)atoi(bufRepeatInterval);
	switch (rec->repeat_type){
	    case REPEAT_TYPE_WEEKLY:
	    rec->repeat_arg1 = gDayOfWeekBit[dayWeek];
	    break;
	    case REPEAT_TYPE_MONTHLYWEEK:
	    case REPEAT_TYPE_YEARLYWEEK:
	    rec->repeat_arg1 = gNthWeekBit[nthWeek];
	    rec->repeat_arg2 = gDayOfWeekBit[dayWeek];
	    break;
	}
    }else{
	rec->repeat_type = REPEAT_TYPE_NONE;
    }

    /* ٥ */
    rec->label = local_label;

    /* 쥳ɤϿ */
    r = Record_Register(rec);
    if (!r){
	D(mnwDPrintf("Record_Register failed"));
	return false;
    }
    File_SetDBDirty();

    D(mnwDPrintf("Record_Register success"));

    /* å̵ */
    MonthRec_Invalidate();

    return true;
}

/* ƥԽ */
bool
AddDlg_EditItem(uint16 date, int no)
{
    uint16 year, month, day;
    MonthRec *monthRec;
    Record *rec;
    mnwRect r;
    mnwEvent e;

    /* 쥳ɼФ */
    Calendar_GetDateByNo(date, &year, &month, &day);
    monthRec = MonthRec_GetByMonthNo(Calendar_GetMonthNo(year, month));
    rec = monthRec->rec[day][no];

    /* Խ٤쥳ɤ */
    editRecord = rec;

    /* Խݥåץå */
    switch (rec->type){
	case RECORD_TYPE_SCHEDULE:
	dialog_mode = EDITITEM_SCHEDULE;
	break;
	case RECORD_TYPE_TASK:
	dialog_mode = EDITITEM_TASK;
	break;
	default:
	case RECORD_TYPE_HOLIDAY:
	dialog_mode = EDITITEM_HOLIDAY;
	break;
    }

    /*  */
    if (gCurrentView == VIEW_BROWSER){
	dialog_size = DIALOG_SMALL;
    }else if (gOpt_LargeDialog){
	dialog_size = DIALOG_LARGE;
    }else{
	dialog_size = DIALOG_NORMAL;
    }
    AddDlg_InitRegion();

    /*  */
    mnwRect_SetXYWH(&r,
		    region_dialog_left, region_dialog_top, 
		    region_dialog_width, region_dialog_height);
    mnwWindow_Register((mnwWindow *)&gAddDialog,
		       (mnwWindowCallback)AddDlg_Callback,
		       (mnwWindow *)gRootWindow, &r);

    /* ե */
    mnwEvent_SetFocusWindow((mnwWindow *)&gAddDialog);

    /* modal dialog */
    mnwEvent_SetAll(&e, kEvent_DoModal, nil, 0, 0);
    mnwEvent_SendToDirect(&e, (mnwWindow *)&gAddDialog);

    /* ξõ */
    mnwWindow_UnRegister((mnwWindow *)&gAddDialog);

    if (dialog_result){			      /* ѹΤΤϿ줿 */
	D(mnwDPrintf("Dialog says add/mod succeeded"));
	/*  */
	Record_Delete(rec);
	/* TODO: ֤ͤΥå */
	File_SetDBDirty();
	/* å̵ */
	MonthRec_Invalidate();
    }else{
	D(mnwDPrintf("Dialog says add/mod failed"));
    }

    return true;
}

/* ƥɲ */
bool
AddDlg_AddItem(int type)
{
    mnwRect r;
    mnwEvent e;

    switch (type){
	case ID_FUNC_ADD_SCHEDULE:
	dialog_mode = ADDITEM_SCHEDULE;
	break;
	case ID_FUNC_ADD_TASK:
	dialog_mode = ADDITEM_TASK;
	break;
	case ID_FUNC_ADD_HOLIDAY:
	dialog_mode = ADDITEM_HOLIDAY;
	break;
    }

    /*  */
    if (gCurrentView == VIEW_BROWSER){
	dialog_size = DIALOG_SMALL;
    }else if (gOpt_LargeDialog){
	dialog_size = DIALOG_LARGE;
    }else{
	dialog_size = DIALOG_NORMAL;
    }
    AddDlg_InitRegion();

    /*  */
    mnwRect_SetXYWH(&r,
		    region_dialog_left, region_dialog_top, 
		    region_dialog_width, region_dialog_height);
    mnwWindow_Register((mnwWindow *)&gAddDialog,
		       (mnwWindowCallback)AddDlg_Callback,
		       (mnwWindow *)gRootWindow, &r);

    /* ե */
    mnwEvent_SetFocusWindow((mnwWindow *)&gAddDialog);

    /* modal dialog */
    mnwEvent_SetAll(&e, kEvent_DoModal, nil, 0, 0);
    mnwEvent_SendToDirect(&e, (mnwWindow *)&gAddDialog);

    /* MsgBoxξõ */
    mnwWindow_UnRegister((mnwWindow *)&gAddDialog);

    mnwEvent_SetAll(&e, kEvent_Redraw, nil, 0, 0);
    mnwEvent_SendTo(&e, gMainWin);
    return true;
}

/* ƥκ */
bool
AddDlg_DeleteItem(uint16 date, int no)
{
    uint16 year, month, day;
    MonthRec *monthRec;
    Record *rec;

    /* 쥳ɼФ */
    Calendar_GetDateByNo(date, &year, &month, &day);
    monthRec = MonthRec_GetByMonthNo(Calendar_GetMonthNo(year, month));
    rec = monthRec->rec[day][no];

    /*  */
    Record_Delete(rec);
    /* TODO: ֤ͤΥå */
    File_SetDBDirty();

    /* å̵ */
    MonthRec_Invalidate();

    return true;
}

/* ƥDONEȥ */
bool
AddDlg_ToggleDoneItem(uint16 date, int no)
{
    uint16 year, month, day;
    MonthRec *monthRec;
    Record *rec;

    /* 쥳ɼФ */
    Calendar_GetDateByNo(date, &year, &month, &day);
    monthRec = MonthRec_GetByMonthNo(Calendar_GetMonthNo(year, month));
    rec = monthRec->rec[day][no];

    if (rec->type != RECORD_TYPE_TASK){
	/* ʳϴطʤ */
	return false;
    }

    if (rec->done_len > 0){
	/* ̤λˤ */
	rec->done_len = 0;
	rec->done = nil;
    }else{
	/* λˤ */
	rec->done_len = sizeof(uint16);
	rec->done = (uint16 *)Record_AllocateByte(sizeof(uint16));
	rec->done[0] = date;
    }
    /* NOTE: ʣDONEˤ̤б */

    File_SetDBDirty();

    /* å̵ */
    MonthRec_Invalidate();

    return true;
}

/* ϿԤ */
static bool
AddDlg_DoRegister(mnwDialog *self, mnwEvent *event)
{
    mnwEvent e;
    int ret;

    mnwEvent_SetFocusWindow((mnwWindow *)self);
    ret = AddDlg_Register();
    if (ret){
	dialog_visible = false;
	dialog_result = true;
	mnwEvent_SetAll(&e, kEvent_EndModal, nil, 0, 0);
	mnwEvent_SendTo(&e, (mnwWindow *)self);
	return true;
    }else{
	return true;
    }
}

/* Ͽä */
static bool
AddDlg_CancelRegister(mnwDialog *self, mnwEvent *event)
{
    mnwEvent e;

    mnwEvent_SetFocusWindow((mnwWindow *)self);
    dialog_visible = false;
    dialog_result = false;
    mnwEvent_SetAll(&e, kEvent_EndModal, nil, 0, 0);
    mnwEvent_SendTo(&e, (mnwWindow *)self);
    return true;
}

/* Add KeyDown */
static bool
AddDlg_KeyDown(mnwDialog *self, mnwEvent *event)
{
    switch (event->param1){
	case kKey_RETURN:
	D(mnwDPrintf("register by RETURN key"));
	return AddDlg_DoRegister(self, event);
	break;

	case kKey_ESCAPE:
	D(mnwDPrintf("cancel by ESC key"));
	return AddDlg_CancelRegister(self, event);
	break;

	case 'd':
	if (mnwEvent_TestModifier(event, kKey_CONTROL)){ /* CTRL+D */
	    mnwEvent_SetFocusWindow((mnwWindow *)&gEditDescription);
	    return true;
	}
	break;
	case 's':
	if (mnwEvent_TestModifier(event, kKey_CONTROL)){ /* CTRL+S */
	    mnwEvent_SetFocusWindow((mnwWindow *)&gEditStartYear);
	    return true;
	}
	break;
	case 'e':
	if (mnwEvent_TestModifier(event, kKey_CONTROL)){ /* CTRL+E */
	    if (hasEndDate(dialog_mode)){
		mnwEvent_SetFocusWindow((mnwWindow *)&gEditEndYear);
		return true;
	    }
	}
	break;
	case 't':
	if (mnwEvent_TestModifier(event, kKey_CONTROL)){ /* CTRL+T */
	    if (hasEndDate(dialog_mode)){
		mnwEvent_SetFocusWindow((mnwWindow *)&gEditStartHour);
		return true;
	    }
	}
	break;
	case 'r':
	if (mnwEvent_TestModifier(event, kKey_CONTROL)){ /* CTRL+R */
	    if (hasRepeat(dialog_mode)){
		mnwEvent_SetFocusWindow((mnwWindow *)&gListRepeat);
		return true;
	    } else if (hasRank(dialog_mode)){
		mnwEvent_SetFocusWindow((mnwWindow *)&gEditRank);
		return true;
	    }
	}
	break;

	case kKey_UP:
	if (focus_inc_type != INC_TYPE_NONE){
	    GenDlg_ChangeByArrow(true);
	    return true;
	}
	break;
	case kKey_DOWN:
	if (focus_inc_type != INC_TYPE_NONE){
	    GenDlg_ChangeByArrow(false);
	    return true;
	}
	break;
    }
    return false;
}

/* Add Command */
static bool
AddDlg_Command(mnwDialog *self, mnwEvent *event)
{
    switch (event->param1){
	case ID_FUNC_OK:
	D(mnwDPrintf("register by OK key"));
	return AddDlg_DoRegister(self, event);
	break;

	case ID_FUNC_CANCEL:
	D(mnwDPrintf("Cancel by CANCEL key"));
	return AddDlg_CancelRegister(self, event);
	break;

	case ID_FUNC_LABEL0:
	AddDlg_SetLabel(0);
	return true;
	break;
	case ID_FUNC_LABEL1:
	AddDlg_SetLabel(1);
	return true;
	break;
	case ID_FUNC_LABEL2:
	AddDlg_SetLabel(2);
	return true;
	break;
	case ID_FUNC_LABEL3:
	AddDlg_SetLabel(3);
	return true;
	break;
	case ID_FUNC_LABEL4:
	AddDlg_SetLabel(4);
	return true;
	break;
    }
    return true;
}

/* Add window callback */
static bool
AddDlg_Callback(mnwDialog *self, mnwEvent *event)
{
    switch (event->type){
	case kEvent_Create:
	mnwDialog_Callback((mnwDialog *)self, event); /* super */
	return AddDlg_Create(self);
	break;
	case kEvent_Destroy:
	AddDlg_Destroy(self);
	return mnwDialog_Callback((mnwDialog *)self, event); /* super */
	break;
	case kEvent_Redraw:
	mnwDialog_Callback((mnwDialog *)self, event); /* super */
	return AddDlg_Redraw(self);
	break;
	case kEvent_KeyDown:
	if (AddDlg_KeyDown(self, event)){
	    return true;
	}else{
	    return mnwDialog_Callback((mnwDialog *)self, event); /* super */
	}
	break;
	case kEvent_Command:
	return AddDlg_Command(self, event);
	break;
	case kEvent_GainFocusNotify:
	return AddDlg_GainFocusNotify(self, event);
	break;
	case kEvent_LostFocusNotify:
	return AddDlg_LostFocusNotify(self, event);
	break;
	case kEvent_ChangedNotify:
	return AddDlg_ChangedNotify(self, event);
	break;
	default:
	/* superdelegate */
	return mnwDialog_Callback((mnwDialog *)self, event);
	break;
    }

    /* ٥Ȥʤ */
    return false;
}
