/*
   generic dialog
   Copyright (c) 1997,98 FURUKAWA Yo.
   $Id: gendlg.c,v 1.2 1998/12/27 16:26:20 furukawa Exp $
   */

#define GENDLG
#include "global.h"
#include "taskmg.h"
#include "taskid.h"
#include "arch.h"
#include "calendar.h"
#include "gendlg.h"
#include "funckey.h"
#include <string.h>
#include <stdlib.h>
#include <stdio.h>

/* -- file local macros */
#define REGION_DIALOG_WIDTH	160
#define REGION_DIALOG_HEIGHT	70
#define REGION_DIALOG_LEFT	((640-REGION_DIALOG_WIDTH)/2)
#define REGION_DIALOG_TOP	((240-REGION_DIALOG_HEIGHT)/2)
#define REGION_DIALOG_RIGHT	(REGION_DIALOG_LEFT+REGION_DIALOG_WIDTH-1)
#define REGION_DIALOG_BOTTOM	(REGION_DIALOG_TOP+REGION_DIALOG_HEIGHT-1)

#define EDIT_1stLINE_TOP	(40+28*0)
#define REGION_START_DATE_LEFT	12

#define BUF_DESCRIPTION_LIMIT	13

/* -- file local variables */

static int16 string_len;
static char titleGenDlg[80];

/* -- file local methods */
static bool
GenDlg_Create(mnwDialog *self, int16 mode);
static bool
GenDlg_Destroy(mnwDialog *self);
static bool
GenDlg_Redraw(mnwDialog *self);
static bool
GenDlg_LostFocusNotify(mnwWindow *win);

/* -- methods */

/* GenDlg */
static bool
GenDlg_Create(mnwDialog *self, int16 mode)
{
    mnwRect r;
    mnwEvent e;
    uint16 year, month, day;
    char buf[10];

    D(mnwDPrintf("GenDlg create\n"));

    /* ѿ */
    gMode = MODE_DIALOG;
    dialog_mode  = mode;
    string_len = 16;			      /* TODO */
    value_invalid = false;
    focus = next_focus = should_focus = nil;
    focus_min_val = focus_max_val = 0;
    focus_inc_type = INC_TYPE_NONE;
    focus_not_move = false;

    /* ե󥯥󥭡 */
    FuncKey_SetAddMode();

    if (dialog_mode == GENDLG_STRING){
	/* ҥȥκ */
	mnwRect_SetXYWH(&r,
			(REGION_DIALOG_WIDTH-(string_len*8+4))/2,
			EDIT_1stLINE_TOP,
			string_len*8+4, 20);
	mnwWindow_Register((mnwWindow *)&gEditDescription,
			   (mnwWindowCallback)mnwEdit_Callback,
			   (mnwWindow *)&gGenDialog, &r);
	mnwEvent_SetAll(&e, kEvent_SetID, nil, ID_EDIT_DESCRIPTION, 0);
	mnwEvent_SendTo(&e, (mnwWindow *)&gEditDescription);
	GenDlg_InitEditControl(&gEditDescription,
			       bufDescription,
			       BUF_DESCRIPTION_LIMIT,
			       bufDescription);
	mnwEvent_SetFocusWindow((mnwWindow *)&gEditDescription);
    }else if (dialog_mode == GENDLG_DATE){
	/* եȥκ */
	mnwRect_SetXYWH(&r,
			REGION_START_DATE_LEFT, EDIT_1stLINE_TOP,
			BUF_START_YEAR_LEN*8+4, 20);
	mnwWindow_Register((mnwWindow *)&gEditStartYear,
			   (mnwWindowCallback)mnwEdit_Callback,
			   (mnwWindow *)&gGenDialog, &r);
	mnwEvent_SetAll(&e, kEvent_SetTabStop, &gEditStartYear, 0, 0);
	mnwEvent_SendTo(&e, (mnwWindow *)(mnwWindow *)&gGenDialog);
	mnwEvent_SetAll(&e, kEvent_SetID, nil, ID_EDIT_START_YEAR, 0);
	mnwEvent_SendTo(&e, (mnwWindow *)&gEditStartYear);
	mnwRect_SetXYWH(&r,
			REGION_START_DATE_LEFT+56, EDIT_1stLINE_TOP,
			BUF_START_MONTH_LEN*8+4, 20);
	mnwWindow_Register((mnwWindow *)&gEditStartMonth,
			   (mnwWindowCallback)mnwEdit_Callback,
			   (mnwWindow *)&gGenDialog, &r);
	mnwEvent_SetAll(&e, kEvent_SetTabStop, &gEditStartMonth, 0, 0);
	mnwEvent_SendTo(&e, (mnwWindow *)(mnwWindow *)&gGenDialog);
	mnwEvent_SetAll(&e, kEvent_SetID, nil, ID_EDIT_START_MONTH, 0);
	mnwEvent_SendTo(&e, (mnwWindow *)&gEditStartMonth);
	mnwRect_SetXYWH(&r,
			REGION_START_DATE_LEFT+96, EDIT_1stLINE_TOP,
			BUF_START_DAY_LEN*8+4, 20);
	mnwWindow_Register((mnwWindow *)&gEditStartDay,
			   (mnwWindowCallback)mnwEdit_Callback,
			   (mnwWindow *)&gGenDialog, &r);
	mnwEvent_SetAll(&e, kEvent_SetTabStop, &gEditStartDay, 0, 0);
	mnwEvent_SendTo(&e, (mnwWindow *)(mnwWindow *)&gGenDialog);
	mnwEvent_SetAll(&e, kEvent_SetID, nil, ID_EDIT_START_DAY, 0);
	mnwEvent_SendTo(&e, (mnwWindow *)&gEditStartDay);

	Calendar_GetDateByNo(gCursorDate, &year, &month, &day);
	sprintf(buf, "%d", year);
	GenDlg_InitEditControl(&gEditStartYear, bufStartYear,
			       BUF_START_YEAR_LEN, buf);
	sprintf(buf, "%d", month);
	GenDlg_InitEditControl(&gEditStartMonth, bufStartMonth,
			       BUF_START_MONTH_LEN, buf);
	sprintf(buf, "%d", day);
	GenDlg_InitEditControl(&gEditStartDay, bufStartDay,
			       BUF_START_DAY_LEN, buf);
	mnwEvent_SetFocusWindow((mnwWindow *)&gEditStartYear);
    }

    return true;
}

/* GenDlgդ */
static bool
GenDlg_Destroy(mnwDialog *self)
{
    D(mnwDPrintf("GenDlg destroy\n"));

    if (mnwIsIMEOn()){
	mnwToggleIME();
    }
 
    if (dialog_mode == GENDLG_STRING){
	mnwWindow_UnRegister((mnwWindow *)&gEditDescription);
    }else{
	mnwWindow_UnRegister((mnwWindow *)&gEditStartYear);
	mnwWindow_UnRegister((mnwWindow *)&gEditStartMonth);
	mnwWindow_UnRegister((mnwWindow *)&gEditStartDay);
    }

    /* ե󥯥󥭡ͭ */
    FuncKey_SetMainMode();

    gMode = MODE_VIEW;

    return true;
}

/* ȥΥå */
void
GenDlg_SetTitle(char *title)
{
    sprintf(titleGenDlg, title);
}

/* ⡼ɤΥå */
void
GenDlg_SetMode(int mode)
{
    dialog_mode = mode;
}

/* ʸΥå */
void
GenDlg_SetString(char *str)
{
    sprintf(bufDescription, str);
}

/* ʸμ */
char *
GenDlg_GetString(void)
{
    return bufDescription;
}

/* դμ */
uint16
GenDlg_GetDate(void)
{
    return getStartDateByBuf();
}

/* ǥåȥȥν */
void
GenDlg_InitEditControl(mnwEdit *win, char *buf, uint16 size, char *init_str)
{
    mnwEvent e;
    memset(buf, 0, size+1);
    mnwEvent_SetAll(&e, kEvent_SetBuffer, buf, size+1, 0);
    mnwEvent_SendToDirect(&e, (mnwWindow *)win);
    mnwEvent_SetAll(&e, kEvent_SetText, init_str, strlen(init_str), 0);
    mnwEvent_SendToDirect(&e, (mnwWindow *)win);
}

/* ǥåȥȥʸκ */
void
GenDlg_ResetControl(mnwEdit *win, char *buf)
{
    mnwEvent e;
    focus_not_move = true;
    mnwEvent_SetAll(&e, kEvent_SetText, buf, strlen(buf), 0);
    mnwEvent_SendToDirect(&e, (mnwWindow *)win);
    mnwEvent_SetAll(&e, kEvent_Redraw, nil, 0, 0);
    mnwEvent_SendTo(&e, (mnwWindow *)win);
    focus_not_move = false;
}

/* GenDlgɥ */
static bool
GenDlg_Redraw(mnwDialog *self)
{
    mnwRect r;

    /* ط */
    mnwRect_SetXYXY(&r,
		    REGION_DIALOG_LEFT, REGION_DIALOG_TOP,
		    REGION_DIALOG_RIGHT, REGION_DIALOG_BOTTOM);
    mnwSetForeColor(kColor_LtGray);
    mnwFillRect(&r);

    /*  */
    mnwSetForeColor(kColor_Black);
    mnwDrawRect(&r);
    mnwRect_Inset(&r, 1, 1);
    mnwDrawFrame3D(&r);

    /*  */
    mnwSetForeColor(kColor_Black);
    mnwDrawLine(REGION_DIALOG_LEFT+20, REGION_DIALOG_TOP+30,
		REGION_DIALOG_RIGHT-20, REGION_DIALOG_TOP+30);

    /* ȥ */
    mnwSetFont(kFont_16);
    mnwDrawText(REGION_DIALOG_LEFT + (REGION_DIALOG_WIDTH - (8*strlen(titleGenDlg)))/2,
		REGION_DIALOG_TOP + 8,
		titleGenDlg, strlen(titleGenDlg));

    if (dialog_mode == GENDLG_DATE){
	/* դδ */
	mnwDrawText(REGION_DIALOG_LEFT+REGION_START_DATE_LEFT+38,
		    REGION_DIALOG_TOP+EDIT_1stLINE_TOP+2, "ǯ", 2);
	mnwDrawText(REGION_DIALOG_LEFT+REGION_START_DATE_LEFT+78,
		    REGION_DIALOG_TOP+EDIT_1stLINE_TOP+2, "", 2);
	mnwDrawText(REGION_DIALOG_LEFT+REGION_START_DATE_LEFT+118,
		    REGION_DIALOG_TOP+EDIT_1stLINE_TOP+2, "", 2);
    }

    return true;
}

/* Ǥͤ */
bool
GenDlg_ChangeByArrow(bool inc)
{
    uint16 val;
    char buf[10];
    mnwEvent e;

    D(mnwDPrintf("GenDlg_ChangeByArrow()"));

    val = atoi(focus_buf);
    if (focus_inc_type == INC_TYPE_1){
	if (inc){
	    if (val >= focus_max_val){
		return false;
	    }
	    val++;
	}else{
	    if (val == focus_min_val){
		return false;
	    }
	    val--;
	}
    }else if (focus_inc_type == INC_TYPE_15){
	if (inc){
	    val = ((val / 15) * 15 + 15) % 60;
	}else{
	    val = (val / 15) * 15;
	    if (val == 0){
		val = 45;
	    }else{
		val = val - 15;
	    }
	}
    }
    sprintf(buf, "%d", val);
    GenDlg_ResetControl((mnwEdit *)focus, buf);

    /* ˤ */
    mnwEvent_SetAll(&e, kEvent_SetCursor, nil, 0, -1);
    mnwEvent_SendTo(&e, focus);

    /* եưʤ */
    focus_not_move = true;

    return true;
}

/* ͤϰϥå */
bool
GenDlg_CheckValueRange(mnwEdit *win)
{
    mnwEvent e;
    uint16 val;

    val = atoi(focus_buf);
    D(mnwDPrintf("  Checking value range (%d-%d) value = %d\n",
		 focus_min_val, focus_max_val, val));
    if (val < focus_min_val || val > focus_max_val){
	char buf[80];
	/* Ǿ᤹ͤ */
	sprintf(buf, "%d", focus_min_val);
	GenDlg_ResetControl((mnwEdit *)win, buf);
	/*  */
	sprintf(buf, "ͤǤ\n%d  %d ޤ",
		focus_min_val, focus_max_val);
	mnwMsgBox(buf, kMsgBox_Type_OK);
	/* κ */
	mnwEvent_SetAll(&e, kEvent_Redraw, nil, 0, 0);
	mnwEvent_SendTo(&e, win->parent);
	/* Υȥ */
	should_focus = (mnwWindow *)win;
	value_invalid = true;
	return false;
    }else{
	value_invalid = false;
	return true;
    }
}

/* եʤʤäȤν */
static bool
GenDlg_LostFocusNotify(mnwWindow *win)
{
    bool r;
    static bool checking = false;
    mnwEvent e;

    if (checking){
	/* ťåɻ */
	return true;
    }

    /* ͤå򤹤 */
    switch (win->id){
	case ID_EDIT_DESCRIPTION:
	checking = false;
	return true;
	break;
    }
    checking = true;
    r = GenDlg_CheckValueRange((mnwEdit *)win);
    checking = false;
    if (r == false){
	char buf[5];
	sprintf(buf, "%d", focus_min_val);
	GenDlg_ResetControl((mnwEdit *)win, buf);
	/* ˤ */
	mnwEvent_SetAll(&e, kEvent_SetCursor, nil, 0, -1);
	mnwEvent_SendTo(&e, win);
	return false;
    }

    return true;
}

/* ե줿Ȥν */
bool
GenDlg_GainFocusNotify(mnwWindow *win)
{
    mnwEvent e;

    /* ٤ǤʤȤ */
    if (should_focus != 0){
	/* ե᤹ */
	mnwEvent_SetFocusWindow((mnwWindow *)should_focus);
	should_focus = 0;
	return false;
    }

    /* ե줿ȥ° */
    GenDlg_MoveFocus(win->id);

    /* ˤ */
    mnwEvent_SetAll(&e, kEvent_SetCursor, nil, 0, -1);
    mnwEvent_SendTo(&e, win);

    /* ̾ѴON/OFF */
    switch (win->id){
	case ID_EDIT_DESCRIPTION:
	if (!mnwIsIMEOn()){
	    mnwToggleIME();		      /* ON */
	}
	break;

	default:
	if (mnwIsIMEOn()){
	    mnwToggleIME();		      /* OFF */
	}
	break;
    }
    
    return true;
}

/* եư */
void
GenDlg_MoveFocus(int id)
{
    uint16 year, month;

    switch (id){
	case ID_EDIT_DESCRIPTION:
	focus = (mnwWindow *)&gEditDescription;
	if (dialog_mode == GENDLG_STRING){
	    next_focus = (mnwWindow *)&gEditDescription;
	}else{
	    next_focus = (mnwWindow *)&gEditStartYear;
	}
	focus_min_val = 0;
	focus_max_val = 0;
	focus_buf = bufDescription;
	focus_inc_type = INC_TYPE_NONE;
	break;
	case ID_EDIT_START_YEAR:
	focus = (mnwWindow *)&gEditStartYear;
	next_focus = (mnwWindow *)&gEditStartMonth;
	focus_min_val = 1970;
	focus_max_val = 2050;
	focus_buf = bufStartYear;
	focus_inc_type = INC_TYPE_1;
	break;
	case ID_EDIT_START_MONTH:
	focus = (mnwWindow *)&gEditStartMonth;
	next_focus = (mnwWindow *)&gEditStartDay;
	focus_min_val = 1;
	focus_max_val = 12;
	focus_buf = bufStartMonth;
	focus_inc_type = INC_TYPE_1;
	break;
	case ID_EDIT_START_DAY:
	focus = (mnwWindow *)&gEditStartDay;
	if (hasEndDate(dialog_mode)){
	    next_focus = (mnwWindow *)&gEditEndYear;
	}else if (hasRank(dialog_mode)){
	    next_focus = (mnwWindow *)&gEditRank;
	}else if (dialog_mode == GENDLG_DATE){
	    next_focus = (mnwWindow *)&gEditStartYear;
	}
	year = atoi(bufStartYear);
	month = atoi(bufStartMonth);
	focus_min_val = 1;
	focus_max_val = Calendar_GetNumOfDays(year, month);
	focus_buf = bufStartDay;
	focus_inc_type = INC_TYPE_1;
	break;
	case ID_EDIT_END_YEAR:
	focus = (mnwWindow *)&gEditEndYear;
	next_focus = (mnwWindow *)&gEditEndMonth;
	focus_min_val = 1970;
	focus_max_val = 2050;
	focus_buf = bufEndYear;
	focus_inc_type = INC_TYPE_1;
	break;
	case ID_EDIT_END_MONTH:
	focus = (mnwWindow *)&gEditEndMonth;
	next_focus = (mnwWindow *)&gEditEndDay;
	focus_min_val = 1;
	focus_max_val = 12;
	focus_buf = bufEndMonth;
	focus_inc_type = INC_TYPE_1;
	break;
	case ID_EDIT_END_DAY:
	focus = (mnwWindow *)&gEditEndDay;
	if (hasTime(dialog_mode)){
	    next_focus = (mnwWindow *)&gEditStartHour;
	}else if (hasRepeat(dialog_mode)){
	    next_focus = (mnwWindow *)&gListRepeat;
	}else if (dialog_mode == GENDLG_DATE){
	    next_focus = (mnwWindow *)&gEditStartYear;
	}
	year = atoi(bufEndYear);
	month = atoi(bufEndMonth);
	focus_min_val = 1;
	focus_max_val = Calendar_GetNumOfDays(year, month);
	focus_buf = bufEndDay;
	focus_inc_type = INC_TYPE_1;
	break;
	case ID_EDIT_START_HOUR:
	focus = (mnwWindow *)&gEditStartHour;
	next_focus = (mnwWindow *)&gEditStartMin;
	focus_min_val = 0;
	focus_max_val = 24;
	focus_buf = bufStartHour;
	focus_inc_type = INC_TYPE_1;
	break;
	case ID_EDIT_START_MIN:
	focus = (mnwWindow *)&gEditStartMin;
	next_focus = (mnwWindow *)&gEditEndHour;
	focus_min_val = 0;
	focus_max_val = 59;
	focus_buf = bufStartMin;
	focus_inc_type = INC_TYPE_15;
	break;
	case ID_EDIT_END_HOUR:
	focus = (mnwWindow *)&gEditEndHour;
	next_focus = (mnwWindow *)&gEditEndMin;
	focus_min_val = 0;
	focus_max_val = 24;
	focus_buf = bufEndHour;
	focus_inc_type = INC_TYPE_1;
	break;
	case ID_EDIT_END_MIN:
	focus = (mnwWindow *)&gEditEndMin;
	next_focus = (mnwWindow *)&gListRepeat;
	focus_min_val = 0;
	focus_max_val = 59;
	focus_buf = bufEndMin;
	focus_inc_type = INC_TYPE_15;
	break;
	case ID_EDIT_RANK:
	focus = (mnwWindow *)&gEditRank;
	next_focus = (mnwWindow *)&gEditDescription;
	focus_min_val = 1;
	focus_max_val = 9;
	focus_buf = bufRank;
	focus_inc_type = INC_TYPE_1;
	break;
	case ID_LIST_REPEAT:
	focus = (mnwWindow *)&gListRepeat;
	next_focus = (mnwWindow *)&gEditRepeatInterval;
	focus_min_val = 0;
	focus_max_val = 0;
	focus_buf = bufRepeat;
	focus_inc_type = INC_TYPE_NONE;
	break;
	case ID_EDIT_REPEAT_INTERVAL:
	focus = (mnwWindow *)&gEditRepeatInterval;
	next_focus = (mnwWindow *)&gEditDescription;
	focus_min_val = 1;
	focus_max_val = 99;
	focus_buf = bufRepeatInterval;
	focus_inc_type = INC_TYPE_NONE;
	break;
    }
}

/* ͤѹ줿Ȥν */
bool
GenDlg_ValueChanged(mnwWindow *win)
{
    uint16 val, len;

    if (focus != win){
	D(mnwDPrintf("  GenDlg_ValueChanged() -- return"));
	return false;
    }else if (focus_not_move){
	D(mnwDPrintf("  GenDlg_ValueChanged() -- not check & move"));
	focus_not_move = false;
	return false;
    }else{
	D(mnwDPrintf("  GenDlg_ValueChanged() -- checking values"));
    }

    val = atoi(focus_buf);
    len = strlen(focus_buf);
    D(mnwDPrintf("                        -- val = %d, len = %d", val, len));

    /* ͤå򤹤 */
    if (len == 0){
	return true;
    }
    switch (win->id){
	case ID_EDIT_START_YEAR:
	case ID_EDIT_END_YEAR:
	case ID_EDIT_RANK:
	if (val >= focus_min_val && val <= focus_max_val){
	    should_focus = next_focus;
	    mnwEvent_SetFocusWindow(next_focus);
	}
	break;
	case ID_EDIT_START_MONTH:
	case ID_EDIT_END_MONTH:
	if (val >= 2 && val <= focus_max_val){
	    should_focus = next_focus;
	    mnwEvent_SetFocusWindow(next_focus);
	}
	break;
	case ID_EDIT_START_DAY:
	case ID_EDIT_END_DAY:
	if (val >= 4 && val <= focus_max_val){
	    should_focus = next_focus;
	    mnwEvent_SetFocusWindow(next_focus);
	}
	break;
	case ID_EDIT_START_HOUR:
	case ID_EDIT_END_HOUR:
	if (val == 0 || (val >= 3 && val <= focus_max_val)){
	    should_focus = next_focus;
	    mnwEvent_SetFocusWindow(next_focus);
	}
	break;
	case ID_EDIT_START_MIN:
	case ID_EDIT_END_MIN:
	if (val == 0 || (val >= 6 && val <= focus_max_val)){
	    should_focus = next_focus;
	    mnwEvent_SetFocusWindow(next_focus);
	}
	break;
	case ID_EDIT_REPEAT_INTERVAL:
	if (val >= 10 && val <= focus_max_val){
	    should_focus = next_focus;
	    mnwEvent_SetFocusWindow(next_focus);
	}
	break;
    }
    return true;
}

bool
GenDlg_KeyDown(mnwDialog *self, mnwEvent *event)
{
    mnwEvent e;

    switch (event->param1){
	case kKey_RETURN:
	mnwEvent_SetAll(&e, kEvent_EndModal, nil, true, 0);
	mnwEvent_SendTo(&e, (mnwWindow *)self);
	return true;
	break;

	case kKey_ESCAPE:
	mnwEvent_SetAll(&e, kEvent_EndModal, nil, false, 0);
	mnwEvent_SendTo(&e, (mnwWindow *)self);
	return true;
	break;

	case kKey_UP:
	if (focus_inc_type != INC_TYPE_NONE){
	    GenDlg_ChangeByArrow(true);
	    return true;
	}
	break;

	case kKey_DOWN:
	if (focus_inc_type != INC_TYPE_NONE){
	    GenDlg_ChangeByArrow(false);
	    return true;
	}
	break;
    }
    return false;
}

bool
GenDlg_Command(mnwDialog *self, mnwEvent *event)
{
    mnwEvent e;

    switch (event->param1){
	case ID_FUNC_OK:
	mnwEvent_SetAll(&e, kEvent_EndModal, nil, 0, 0);
	mnwEvent_SendTo(&e, (mnwWindow *)self);
	return true;
	break;
	
	case ID_FUNC_CANCEL:
	mnwEvent_SetAll(&e, kEvent_EndModal, nil, 0, 0);
	mnwEvent_SendTo(&e, (mnwWindow *)self);
	return true;
	break;

	case ID_KEY_ESCAPE:
	D(mnwDPrintf("got ESCAPE key"));
	mnwEvent_SetAll(&e, kEvent_EndModal, nil, 0, 0);
	mnwEvent_SendTo(&e, (mnwWindow *)self);
	return true;
	break;

	case ID_KEY_RETURN:
	D(mnwDPrintf("got RETURN key"));
	mnwEvent_SetFocusWindow((mnwWindow *)next_focus);
	return true;
	break;
    }
    return false;
}

/* GenDlgɥץ */
bool
GenDlg_Callback(mnwDialog *self, mnwEvent *event)
{
    switch (event->type){
	case kEvent_Create:
	mnwDialog_Callback((mnwDialog *)self, event); /* super */
	return GenDlg_Create(self, dialog_mode);
	break;
	case kEvent_Destroy:
	GenDlg_Destroy(self);
	return mnwDialog_Callback((mnwDialog *)self, event); /* super */
	break;
	case kEvent_Redraw:
	return GenDlg_Redraw(self);
	break;
	case kEvent_KeyDown:
	if (GenDlg_KeyDown(self, event)){
	    return true;
	}else{
	    return mnwDialog_Callback((mnwDialog *)self, event); /* super */
	}
	break;
	case kEvent_Command:
	return GenDlg_Command(self, event);
	break;
#ifdef TMP
	case kEvent_GainFocusNotify:
	return AddDlg_GainFocusNotify(self, event);
	break;
	case kEvent_LostFocusNotify:
	return AddDlg_LostFocusNotify(self, event);
	break;
	case kEvent_ChangedNotify:
	return AddDlg_ChangedNotify(self, event);
	break;
#endif
	default:
	/* superdelegate */
	return mnwDialog_Callback((mnwDialog *)self, event);
	break;
    }

    /* ٥Ȥʤ */
    return false;
}
