/*
   global variables, misc functions
   Copyright (c) 1997,98 FURUKAWA Yo.
   $Id: global.h,v 1.1.1.1 1998/12/15 03:42:49 furukawa Exp $
   */

#ifndef _GLOBAL_H_
#define _GLOBAL_H_

#include "arch.h"
#define MNW_USE_SHORTCUT
#include "mnw.h"

#ifdef GLOBAL
#define global 
#else
#define global extern
#endif

/* -- global macros */
#define mmax(x, y) ((x)>(y)?(x):(y))
#define mmin(x, y) ((x)<(y)?(x):(y))

#ifdef DEBUG
#define D(x) x
#else
#define D(x)
#endif

#define MODE_VIEW	1
#define MODE_ADD	2
#define MODE_APCHANGE	3
#define MODE_HELP	4
#define MODE_DIALOG	5
#define MODE_ENV	6

#define TASK_RECORD_FILE	"record"
#define TASK_CONTEXT_FILE	"continue"
#define TASK_LABEL_FILE 	"label"
#define TASK_CSV_FILE		"task.csv"

/* -- global variables */
global uint16 gTodayDate, gTodayYear, gTodayMonth, gTodayDay;
global uint16 gCursorDate, gCursorHour, gCursorHourRange;
global uint16 gMode, gLabel, gCoopMode;
global bool gDBDirty, gDBMadeBackup, gDebug, gNotUpdateView;

global mnwWindow *gMainWin;

global bool gOpt_PowerOnToday;
global bool gOpt_WeeksStartsFromMonday;
global bool gOpt_TimeTableStartsNine;
global bool gOpt_SaturdayIsHoliday;
global bool gOpt_Label1Default;
global bool gOpt_SelectItemByPageUpDown;
global bool gOpt_LargeDialog;
global bool gOpt_SaveDBOnDirty;

global char gSelectedFolder[64];
global char gSelectedFile[64+13];

#ifndef GLOBAL
global char *nameDayWeek[];
#endif

#endif
