/*
   3 weeks view
   Copyright (c) 1997,98 FURUKAWA Yo.
   $Id: view3w.c,v 1.2 1999/02/01 04:51:06 furukawa Exp $
   */

#include "global.h"
#include "calendar.h"
#include "month.h"
#include "taskmg.h"
#include "taskid.h"
#include "view.h"
#include "view3w.h"
#include "viewitem.h"
#include "viewcal.h"
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

/* -- file local macros */
#define DAYCELL_ROWS		3
#define DAYCELL_COLS		7
#define DAYCELL_WIDTH		(12*5+2+2)
#define DAYCELL_HEIGHT		(12*5+2)
#define ITEM_PER_DAY		4

#define REGION_DAYWEEK_WIDTH	(DAYCELL_WIDTH*DAYCELL_COLS)
#define REGION_DAYWEEK_HEIGHT	(12*1+3)
#define REGION_WEEKS_WIDTH	(DAYCELL_WIDTH*DAYCELL_COLS)
#define REGION_WEEKS_HEIGHT	(DAYCELL_HEIGHT*DAYCELL_ROWS)

#define ITEMCELL_ROWS		12
#define ITEMCELL_COLS		1
#define ITEMCELL_WIDTH		(REGION_USER_WIDTH-REGION_WEEKS_WIDTH-1)
#define ITEMCELL_HEIGHT		(12+3)

#define REGION_DATE_WIDTH	(ITEMCELL_WIDTH)
#define REGION_DATE_HEIGHT	(16*1+5)
#define REGION_DATE_LEFT	(REGION_WEEKS_WIDTH+1)
#define REGION_DATE_TOP		(REGION_USER_TOP)
#define REGION_ITEMS_WIDTH	(ITEMCELL_WIDTH*ITEMCELL_COLS)
#define REGION_ITEMS_HEIGHT	(ITEMCELL_HEIGHT*ITEMCELL_ROWS)

/* -- file local variables */

/* -- file local methods */

/* -- methods */

/* View3W */
bool
View3W_Create(void)
{
    D(mnwDPrintf("View3W create\n"));

    /* Viewͭѿ */
    cursor_focus = FOCUS_CALENDAR;
    cursor_prev_focus = FOCUS_CALENDAR;
    ViewItem_Init(REGION_DATE_LEFT, REGION_DATE_TOP,
		  REGION_DATE_WIDTH, REGION_DATE_HEIGHT,
		  REGION_ITEMS_WIDTH, REGION_ITEMS_HEIGHT,
		  ITEMCELL_WIDTH, ITEMCELL_HEIGHT,
		  ITEMCELL_COLS, ITEMCELL_ROWS,
		  kFont_12, 7+24, false);
    ViewItem_InitCursor();
    ViewCal_Init(REGION_USER_LEFT, REGION_USER_TOP,
		 REGION_DAYWEEK_WIDTH, REGION_DAYWEEK_HEIGHT,
		 REGION_WEEKS_WIDTH, REGION_WEEKS_HEIGHT,
		 DAYCELL_WIDTH, DAYCELL_HEIGHT,
		 DAYCELL_COLS, DAYCELL_ROWS,
		 ITEM_PER_DAY,
		 kFont_12, 10);
    ViewCal_InitCursor();

    return true;
}

/* View3Wդ */
bool
View3W_Destroy(void)
{
    D(mnwDPrintf("View3W destroy\n"));
    return true;
}

/* View3W */
void
View3W_Redraw(void)
{
    /*  */
    mnwSetForeColor(kColor_Black);
    mnwDrawLine(REGION_USER_LEFT+REGION_DAYWEEK_WIDTH, REGION_USER_TOP,
		REGION_USER_LEFT+REGION_DAYWEEK_WIDTH, REGION_USER_BOTTOM);

    ViewCalDayWeek_Redraw();
    ViewCalWeeks_Redraw();
    ViewItemDate_Redraw();
    ViewItem_Redraw();
    ViewCal_InvertCursor();		      /* ON */
    if (cursor_focus == FOCUS_ITEMLIST)
	ViewItem_InvertCursor();	      /* ON */
}

/* View3Wٱ */
void
View3W_DelayedRedraw(void)
{
    ViewItemDate_Redraw();
    ViewItem_Redraw();
    if (cursor_focus == FOCUS_ITEMLIST)
	ViewItem_InvertCursor();
}

/* ɽ */
bool
View3W_KeyDown(mnwEvent *event)
{
    switch (event->param1){
	case kKey_LEFT:			      /*  */
	case kUKey_LEFT:		      /*  */
	ViewCal_InvertCursor();		      /* OFF */
	ViewCal_Left();
	ViewCal_InvertCursor();		      /* ON */
	/* ե򥢥ƥꥹȤ˰ư */
	if (cursor_focus == FOCUS_ITEMLIST){
	    ViewItem_InitCursor();
	    cursor_focus = FOCUS_CALENDAR;
	}
	/* ٱ䥢åץǡ */
	View_SetTimer();
	break;

	case kKey_RIGHT:		      /*  */
	case kUKey_RIGHT:		      /*  */
	ViewCal_InvertCursor();		      /* OFF */
	ViewCal_Right();
	ViewCal_InvertCursor();		      /* ON */
	/* ե򥢥ƥꥹȤ˰ư */
	if (cursor_focus == FOCUS_ITEMLIST){
	    ViewItem_InitCursor();
	    cursor_focus = FOCUS_CALENDAR;
	}
	/* ٱ䥢åץǡ */
	View_SetTimer();
	break;

	case kKey_UP:			      /*  */
	case kUKey_UP:			      /*  */
	ViewCal_InvertCursor();		      /* OFF */
	ViewCal_Up();
	ViewCal_InvertCursor();		      /* ON */
	/* ե򥢥ƥꥹȤ˰ư */
	if (cursor_focus == FOCUS_ITEMLIST){
	    ViewItem_InitCursor();
	    cursor_focus = FOCUS_CALENDAR;
	}
	/* ٱ䥢åץǡ */
	View_SetTimer();
	break;

	case kKey_DOWN:			      /*  */
	case kUKey_DOWN:		      /*  */
	ViewCal_InvertCursor();		      /* OFF */
	ViewCal_Down();
	ViewCal_InvertCursor();		      /* ON */
	/* ե򥢥ƥꥹȤ˰ư */
	if (cursor_focus == FOCUS_ITEMLIST){
	    ViewItem_InitCursor();
	    cursor_focus = FOCUS_CALENDAR;
	}
	/* ٱ䥢åץǡ */
	View_SetTimer();
	break;

	case kKey_PRIOR:		      /*  */
	ViewCal_WeekUp(3);
	ViewCal_InvertCursor();		      /* ON */
	/* ե򥢥ƥꥹȤ˰ư */
	if (cursor_focus == FOCUS_ITEMLIST){
	    ViewItem_InitCursor();
	    cursor_focus = FOCUS_CALENDAR;
	}
	/* ٱ䥢åץǡ */
	View_SetTimer();
	break;

	case kKey_NEXT:			      /*  */
	ViewCal_WeekDown(3);
	ViewCal_InvertCursor();		      /* ON */
	/* ե򥢥ƥꥹȤ˰ư */
	if (cursor_focus == FOCUS_ITEMLIST){
	    ViewItem_InitCursor();
	    cursor_focus = FOCUS_CALENDAR;
	}
	/* ٱ䥢åץǡ */
	View_SetTimer();
	break;

	case kUKey_ITEMUP:		      /* ƥ */
	if (cursor_focus == FOCUS_CALENDAR){
	    D(mnwDPrintf("focus ITEMLIST"));
	    ViewItem_InvertCursor();	      /* ON */
	    cursor_focus = FOCUS_ITEMLIST;
	}else{
	    ViewItem_InvertCursor();	      /* OFF */
	    ViewItem_Up();
	    ViewItem_InvertCursor();	      /* ON */
	}
	break;

	case kUKey_ITEMDOWN:		      /* ƥ಼ */
	if (cursor_focus == FOCUS_CALENDAR){
	    D(mnwDPrintf("focus ITEMLIST"));
	    ViewItem_InvertCursor();	      /* ON */
	    cursor_focus = FOCUS_ITEMLIST;
	}else{
	    ViewItem_InvertCursor();	      /* OFF */
	    ViewItem_Down();
	    ViewItem_InvertCursor();	      /* ON */
	}
	break;

	default:
	/* ʤ */
	return false;
	break;
    }

    /*  */
    return true;
}

/* ޥɽ */
bool
View3W_Command(mnwEvent *event)
{
    switch (event->param1){
	case ID_FUNC_NOW:
	ViewCal_InitCursor();
	View_Redraw();
	break;

	default:
	/* ʤ */
	return false;
	break;
    }

    /*  */
    return true;
}
