/*
   day view (large size)
   Copyright (c) 1997,98 FURUKAWA Yo.
   $Id: viewdl.c,v 1.3 1999/02/01 04:51:06 furukawa Exp $
   */

#include "global.h"
#include "calendar.h"
#include "month.h"
#include "taskmg.h"
#include "taskid.h"
#include "view.h"
#include "viewdl.h"
#include "viewitem.h"
#include "viewtime.h"
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

/* -- file local macros */
#define HOURCELL_ROWS		11
#define HOURCELL_COLS		1
#define HOURCELL_WIDTH		(16*10+3)
#define HOURCELL_HEIGHT		(16*1+2)

#define REGION_HOUR_WIDTH	(6*5+2)
#define REGION_HOUR_HEIGHT	(HOURCELL_HEIGHT*HOURCELL_ROWS)
#define REGION_TIMETABLE_WIDTH	(HOURCELL_WIDTH*HOURCELL_COLS)
#define REGION_TIMETABLE_HEIGHT	(HOURCELL_HEIGHT*HOURCELL_ROWS)

#define ITEMCELL_ROWS		10
#define ITEMCELL_COLS		1
#define ITEMCELL_WIDTH		(REGION_USER_WIDTH-REGION_HOUR_WIDTH-REGION_TIMETABLE_WIDTH-2)
#define ITEMCELL_HEIGHT		(16+2)

#define REGION_DATE_WIDTH	(ITEMCELL_WIDTH)
#define REGION_DATE_HEIGHT	(16*1+5)
#define REGION_DATE_LEFT	(REGION_HOUR_WIDTH+REGION_TIMETABLE_WIDTH+2)
#define REGION_DATE_TOP		(REGION_USER_TOP)
#define REGION_ITEMS_WIDTH	(ITEMCELL_WIDTH)
#define REGION_ITEMS_HEIGHT	(ITEMCELL_HEIGHT*ITEMCELL_ROWS)

/* -- file local variables */

/* -- file local methods */

/* -- methods */

/* ViewDL */
bool
ViewDL_Create(void)
{
    D(mnwDPrintf("ViewDL create\n"));

    /* Viewͭѿ */
    cursor_focus = FOCUS_TIMETABLE;
    cursor_prev_focus = FOCUS_TIMETABLE;
    ViewItem_Init(REGION_DATE_LEFT, REGION_DATE_TOP,
		  REGION_DATE_WIDTH, REGION_DATE_HEIGHT,
		  REGION_ITEMS_WIDTH, REGION_ITEMS_HEIGHT,
		  ITEMCELL_WIDTH, ITEMCELL_HEIGHT,
		  ITEMCELL_COLS, ITEMCELL_ROWS,
		  kFont_16, 7+48, true);
    ViewItem_InitCursor();
    ViewTime_Init(REGION_USER_LEFT+1, REGION_USER_TOP+1,
		  REGION_HOUR_WIDTH, REGION_HOUR_HEIGHT,
		  0, 0,
		  REGION_TIMETABLE_WIDTH, REGION_TIMETABLE_HEIGHT,
		  0, 0,
		  HOURCELL_WIDTH, HOURCELL_HEIGHT,
		  HOURCELL_COLS, HOURCELL_ROWS,
		  0,
		  kFont_16, 20);
    ViewTime_InitCursor();

    return true;
}

/* ViewDLդ */
bool
ViewDL_Destroy(void)
{
    D(mnwDPrintf("ViewDL destroy\n"));
    return true;
}

/* ViewDL */
void
ViewDL_Redraw(void)
{
    int left, top, right, bottom;
    mnwRect rect;

    ViewTimeHour_Redraw();
    ViewTimeWeek_Redraw();
    ViewItemDate_Redraw();
    ViewItem_Redraw();
    ViewTime_InvertCursor();		      /* ON */
    if (cursor_focus == FOCUS_ITEMLIST)
	ViewItem_InvertCursor();	      /* ON */

    /*  */
    top = REGION_USER_TOP;
    bottom = REGION_USER_BOTTOM;
    left = REGION_USER_LEFT;
    right = left + REGION_HOUR_WIDTH + REGION_TIMETABLE_WIDTH + 1;

    /*  */
    mnwSetForeColor(kColor_Black);
    mnwRect_SetXYXY(&rect, left, top, right, bottom);
    mnwDrawRect(&rect);
}

/* ViewDLٱ */
void
ViewDL_DelayedRedraw(void)
{
    /* NOTTHING TO DO */
}

/* ɽ */
bool
ViewDL_KeyDown(mnwEvent *event)
{
    switch (event->param1){
	case kKey_LEFT:			      /*  */
	case kUKey_LEFT:		      /*  */
	ViewTime_InvertCursor();	      /* OFF */
	gCursorDate--;
	ViewTime_Left();
	/* 򥫡򸵤 */
	if (gCursorHourRange > 1){
	    gCursorHour = gCursorHour + gCursorHourRange - 1;
	    gCursorHourRange = 1;
	}
	/* ե򥿥ơ֥˰ư */
	if (cursor_focus == FOCUS_ITEMLIST){
	    ViewItem_InitCursor();
	    cursor_focus = FOCUS_TIMETABLE;
	}
	ViewTimeWeek_Redraw();
	ViewItemDate_Redraw();
	ViewItem_Redraw();
	ViewTime_InvertCursor();	      /* ON */
	View_UpdateTitle();
	break;

	case kKey_RIGHT:		      /*  */
	case kUKey_RIGHT:		      /*  */
	ViewTime_InvertCursor();	      /* OFF */
	gCursorDate++;
	ViewTime_Right();
	/* 򥫡򸵤 */
	if (gCursorHourRange > 1){
	    gCursorHour = gCursorHour + gCursorHourRange - 1;
	    gCursorHourRange = 1;
	}
	/* ե򥿥ơ֥˰ư */
	if (cursor_focus == FOCUS_ITEMLIST){
	    ViewItem_InitCursor();
	    cursor_focus = FOCUS_TIMETABLE;
	}
	ViewTimeWeek_Redraw();
	ViewItemDate_Redraw();
	ViewItem_Redraw();
	ViewTime_InvertCursor();	      /* ON */
	View_UpdateTitle();
	break;

	case kKey_UP:			      /*  */
	case kUKey_UP:			      /*  */
	ViewTime_InvertCursor();	      /* OFF */
	/* 򥫡򸵤 */
	if (gCursorHourRange > 1){
	    gCursorHour = gCursorHour + gCursorHourRange - 1;
	    gCursorHourRange = 1;
	}
	/* ư */
	if (gCursorHour > 0){
	    gCursorHour--;
	}
	ViewTime_Up();
	ViewTime_InvertCursor();	      /* ON */
	/* ե򥢥ƥꥹȤư */
	if (cursor_focus == FOCUS_ITEMLIST){
	    ViewItem_InvertCursor();
	    ViewItem_InitCursor();
	    cursor_focus = FOCUS_TIMETABLE;
	}
	break;

	case kKey_DOWN:			      /*  */
	case kUKey_DOWN:		      /*  */
	ViewTime_InvertCursor();	      /* OFF */
	/* 򥫡򸵤 */
	if (gCursorHourRange > 1){
	    gCursorHour = gCursorHour + gCursorHourRange - 1;
	    gCursorHourRange = 1;
	}
	/* ư */
	if (gCursorHour < 23){
	    gCursorHour++;
	}
	ViewTime_Down();
	ViewTime_InvertCursor();	      /* ON */
	/* ե򥢥ƥꥹȤư */
	if (cursor_focus == FOCUS_ITEMLIST){
	    ViewItem_InvertCursor();
	    ViewItem_InitCursor();
	    cursor_focus = FOCUS_TIMETABLE;
	}
	break;

	case kUKey_HOURUP:		      /* ־ */
	ViewTime_InvertCursor();	      /* OFF */
	/* 򥫡̾ */
	if (gCursorHourRange > 1){
	    gCursorHourRange--;
	}else{
	    if (gCursorHour > 0){
		gCursorHour--;
	    }
	}
	ViewTime_Up();
	ViewTime_InvertCursor();	      /* ON */
	/* ե򥢥ƥꥹȤư */
	if (cursor_focus == FOCUS_ITEMLIST){
	    ViewItem_InvertCursor();
	    ViewItem_InitCursor();
	    cursor_focus = FOCUS_TIMETABLE;
	}
	break;

	case kUKey_HOURDOWN:		      /* ֲ */
	ViewTime_InvertCursor();	      /* OFF */
	/* 򥫡 */
	if (gCursorHour + gCursorHourRange < 24){
	    gCursorHourRange++;
	}
	ViewTime_Down();
	ViewTime_InvertCursor();	      /* ON */
	/* ե򥢥ƥꥹȤư */
	if (cursor_focus == FOCUS_ITEMLIST){
	    ViewItem_InvertCursor();
	    ViewItem_InitCursor();
	    cursor_focus = FOCUS_TIMETABLE;
	}
	break;

	case kUKey_ITEMUP:		      /* ƥ */
	if (cursor_focus == FOCUS_TIMETABLE){
	    D(mnwDPrintf("focus ITEMLIST"));
	    ViewItem_InvertCursor();	      /* ON */
	    cursor_focus = FOCUS_ITEMLIST;
	}else{
	    ViewItem_InvertCursor();	      /* OFF */
	    ViewItem_Up();
	    ViewItem_InvertCursor();	      /* ON */
	}
	break;

	case kUKey_ITEMDOWN:		      /* ƥ಼ */
	if (cursor_focus == FOCUS_TIMETABLE){
	    D(mnwDPrintf("focus ITEMLIST"));
	    ViewItem_InvertCursor();	      /* ON */
	    cursor_focus = FOCUS_ITEMLIST;
	}else{
	    ViewItem_InvertCursor();	      /* OFF */
	    ViewItem_Down();
	    ViewItem_InvertCursor();	      /* ON */
	}
	break;

	default:
	/* ʤ */
	return false;
	break;
    }

    /*  */
    return true;
}

/* ޥɽ */
bool
ViewDL_Command(mnwEvent *event)
{
    switch (event->param1){
	case ID_FUNC_NOW:
	ViewTime_InitCursor();
	ViewItem_InitCursor();
	View_Redraw();
	break;

	default:
	/* ʤ */
	return false;
	break;
    }

    /*  */
    return true;
}
