/*
   make sample data
   */

#include "arch.h"
#include "record.h"
#include "index.h"
#include "month.h"
#include "db.h"
#include "calendar.h"
#include <stdlib.h>
#include <stdio.h>

static uint16 gTodayDate, gTodayYear, gTodayMonth, gTodayDay;

int add_data_test(int n)
{
    Record *rec;
    char descript[256];
    int i;

    for (i = 0; i < n; i++){
	rec = Record_AllocateRecord(1);
	if (rec == nil){
	    return -1;
	}
	memset(rec, 0, sizeof(Record));
#ifdef ARCH_POSIX
	sprintf(descript, "TEST%06d", random()%1000000);
#else
	sprintf(descript, "TEST%06d", (uint16)rand()%10000U);
#endif
	rec->descript_len = strlen(descript);
	rec->descript = Record_AllocateByte(rec->descript_len);
	if (rec->descript == nil){
	    return -1;
	}
	memcpy(rec->descript, descript, rec->descript_len);
	rec->type = RECORD_TYPE_HOLIDAY;
#ifdef ARCH_POSIX
	rec->start_date = gTodayDate + (random() % 600 - 300);
	rec->end_date = rec->start_date + (random() % 3);
#else
	rec->start_date = gTodayDate + (rand() % 600 - 300);
	rec->end_date = rec->start_date + (rand() % 3);
	if (rec->start_date == 0 || rec->end_date == 0){
	    printf("fatal 0 start date at rand()\n");
	    exit(1);
	}
#endif
	rec->except_len = 0;
	rec->done_len = 0;
	rec->link_len = 0;
	rec->except = nil;
	rec->done = nil;
	rec->link = nil;

	Record_Register(rec);
    }

    return 0;
}

int add_data_real(void)
{
    Record *rec;
    char descript[256];

    rec = Record_AllocateRecord(1);
    if (rec == nil){
	return -1;
    }
    memset(rec, 0, sizeof(Record));
    sprintf(descript, "ΰ");
    rec->descript_len = strlen(descript);
    rec->descript = Record_AllocateByte(rec->descript_len);
    if (rec->descript == nil){
	return -1;
    }
    memcpy(rec->descript, descript, rec->descript_len);
    rec->len = sizeof(Record);
    rec->type = RECORD_TYPE_HOLIDAY;
    rec->start_date = Calendar_GetDayNo(1900, 10, 10);
    rec->end_date = DATE_THE_END;
    rec->repeat_type = REPEAT_TYPE_YEARLYDAY;
    rec->repeat_every = 1;
    rec->except_len = 0;
    rec->done_len = 0;
    rec->link_len = 0;
    rec->except = nil;
    rec->done = nil;
    rec->link = nil;
    Record_Register(rec);

    rec = Record_AllocateRecord(1);
    if (rec == nil){
	return -1;
    }
    memset(rec, 0, sizeof(Record));
    sprintf(descript, "ʸ");
    rec->descript_len = strlen(descript);
    rec->descript = Record_AllocateByte(rec->descript_len);
    if (rec->descript == nil){
	return -1;
    }
    memcpy(rec->descript, descript, rec->descript_len);
    rec->len = sizeof(Record);
    rec->type = RECORD_TYPE_HOLIDAY;
    rec->start_date = Calendar_GetDayNo(1900, 11, 3);
    rec->end_date = DATE_THE_END;
    rec->repeat_type = REPEAT_TYPE_YEARLYDAY;
    rec->repeat_every = 1;
    rec->except_len = 0;
    rec->done_len = 0;
    rec->link_len = 0;
    rec->except = nil;
    rec->done = nil;
    rec->link = nil;
    Record_Register(rec);

    rec = Record_AllocateRecord(1);
    memset(rec, 0, sizeof(Record));
    sprintf(descript, "ϫդ");
    rec->descript_len = strlen(descript);
    rec->descript = Record_AllocateByte(rec->descript_len);
    if (rec->descript == nil){
	return -1;
    }
    memcpy(rec->descript, descript, rec->descript_len);
    rec->len = sizeof(Record);
    rec->type = RECORD_TYPE_HOLIDAY;
    rec->start_date = Calendar_GetDayNo(1900, 11, 23);
    rec->end_date = DATE_THE_END;
    rec->repeat_type = REPEAT_TYPE_YEARLYDAY;
    rec->repeat_every = 1;
    rec->except_len = 0;
    rec->done_len = 0;
    rec->link_len = 0;
    rec->except = nil;
    rec->done = nil;
    rec->link = nil;
    Record_Register(rec);

    rec = Record_AllocateRecord(1);
    if (rec == nil){
	return -1;
    }
    memset(rec, 0, sizeof(Record));
    sprintf(descript, "ŷ");
    rec->descript_len = strlen(descript);
    rec->descript = Record_AllocateByte(rec->descript_len);
    if (rec->descript == nil){
	return -1;
    }
    memcpy(rec->descript, descript, rec->descript_len);
    rec->len = sizeof(Record);
    rec->type = RECORD_TYPE_HOLIDAY;
    rec->start_date = Calendar_GetDayNo(1900, 12, 23);
    rec->end_date = DATE_THE_END;
    rec->repeat_type = REPEAT_TYPE_YEARLYDAY;
    rec->repeat_every = 1;
    rec->except_len = 0;
    rec->done_len = 0;
    rec->link_len = 0;
    rec->except = nil;
    rec->done = nil;
    rec->link = nil;
    Record_Register(rec);

    rec = Record_AllocateRecord(1);
    if (rec == nil){
	return -1;
    }
    memset(rec, 0, sizeof(Record));
    sprintf(descript, "");
    rec->descript_len = strlen(descript);
    rec->descript = Record_AllocateByte(rec->descript_len);
    if (rec->descript == nil){
	return -1;
    }
    memcpy(rec->descript, descript, rec->descript_len);
    rec->len = sizeof(Record);
    rec->type = RECORD_TYPE_HOLIDAY;
    rec->start_date = Calendar_GetDayNo(1900, 1, 1);
    rec->end_date = DATE_THE_END;
    rec->repeat_type = REPEAT_TYPE_DAILY;
    rec->repeat_every = 2;
    rec->except_len = 0;
    rec->done_len = 0;
    rec->link_len = 0;
    rec->except = nil;
    rec->done = nil;
    rec->link = nil;
    Record_Register(rec);

    rec = Record_AllocateRecord(1);
    if (rec == nil){
	return -1;
    }
    memset(rec, 0, sizeof(Record));
    sprintf(descript, "ֽ");
    rec->descript_len = strlen(descript);
    rec->descript = Record_AllocateByte(rec->descript_len);
    if (rec->descript == nil){
	return -1;
    }
    memcpy(rec->descript, descript, rec->descript_len);
    rec->len = sizeof(Record);
    rec->type = RECORD_TYPE_HOLIDAY;
    rec->start_date = Calendar_GetDayNo(1900, 1, 1);
    rec->end_date = DATE_THE_END;
    rec->repeat_type = REPEAT_TYPE_WEEKLY;
    rec->repeat_every = 2;
    rec->repeat_arg1 = 0x20;
    rec->except_len = 0;
    rec->done_len = 0;
    rec->link_len = 0;
    rec->except = nil;
    rec->done = nil;
    rec->link = nil;
    Record_Register(rec);

    rec = Record_AllocateRecord(1);
    if (rec == nil){
	return -1;
    }
    memset(rec, 0, sizeof(Record));
    sprintf(descript, "");
    rec->descript_len = strlen(descript);
    rec->descript = Record_AllocateByte(rec->descript_len);
    if (rec->descript == nil){
	return -1;
    }
    memcpy(rec->descript, descript, rec->descript_len);
    rec->len = sizeof(Record);
    rec->type = RECORD_TYPE_HOLIDAY;
    rec->start_date = Calendar_GetDayNo(1900, 1, 29);
    rec->end_date = DATE_THE_END;
    rec->repeat_type = REPEAT_TYPE_MONTHLYDAY;
    rec->repeat_every = 1;
    rec->except_len = 0;
    rec->done_len = 0;
    rec->link_len = 0;
    rec->except = nil;
    rec->done = nil;
    rec->link = nil;
    Record_Register(rec);

    rec = Record_AllocateRecord(1);
    if (rec == nil){
	return -1;
    }
    memset(rec, 0, sizeof(Record));
    sprintf(descript, "");
    rec->descript_len = strlen(descript);
    rec->descript = Record_AllocateByte(rec->descript_len);
    if (rec->descript == nil){
	return -1;
    }
    memcpy(rec->descript, descript, rec->descript_len);
    rec->len = sizeof(Record);
    rec->type = RECORD_TYPE_HOLIDAY;
    rec->start_date = Calendar_GetDayNo(1997, 10, 8);
    rec->end_date = DATE_THE_END;
    rec->repeat_type = REPEAT_TYPE_MONTHLYWEEK;
    rec->repeat_every = 1;
    rec->repeat_arg1 = 0x02;
    rec->repeat_arg2 = 0x08;
    rec->except_len = 0;
    rec->done_len = 0;
    rec->link_len = 0;
    rec->except = nil;
    rec->done = nil;
    rec->link = nil;
    Record_Register(rec);

    return 0;
}

int register_holiday(char *des, uint16 year, uint16 month, uint16 day)
{
    Record *rec;

    rec = Record_AllocateRecord(1);
    memset(rec, 0, sizeof(Record));
    rec->descript_len = strlen(des);
    rec->descript = Record_AllocateByte(rec->descript_len);
    memcpy(rec->descript, des, rec->descript_len);
    rec->len = sizeof(Record);
    rec->type = RECORD_TYPE_HOLIDAY;
    rec->start_date = Calendar_GetDayNo(year, month, day);
    rec->end_date = DATE_THE_END;
    rec->repeat_type = REPEAT_TYPE_YEARLYDAY;
    rec->repeat_every = 1;
    Record_Register(rec);
}

int add_data_holiday(void)
{
    register_holiday("", 1989, 1, 1);
    register_holiday("ͤ", 1989, 1, 15);
    register_holiday("ǰ", 1989, 2, 11);
    register_holiday("ߤɤ", 1989, 4, 29);
    register_holiday("ˡǰ", 1989, 5, 3);
    register_holiday("̱ε", 1989, 5, 4);
    register_holiday("ɤ", 1989, 5, 5);
    register_holiday("", 1996, 7, 20);
    register_holiday("Ϸ", 1989, 9, 15);
    register_holiday("ΰ", 1989, 10, 10);
    register_holiday("ʸ", 1989, 11, 3);
    register_holiday("ϫդ", 1989, 11, 23);
    register_holiday("ŷ", 1989, 12, 23);
    return 0;
}

int delete_first(void)
{
    Record *rec;
    uint16 cookie;

    cookie = Index_Rewind();
    while (nil != (rec = Index_FindNext(&cookie))){
	if (rec->type != RECORD_TYPE_DELETED){
	    /* delete the first undeleted entry */
	    Record_Delete(rec);
	    return 0;
	}
    }
    return 0;
}

int initialize(void)
{
    uint8 hour, min;

    DB_Init();
    DB_SetMode(DB_MODE_PSEUDO_SERVER);
    DB_SetUser(RECORD_USER_ANONYMOUS);
    DB_SetFileName("task.rec");

    /* get today */
    gTodayDate = DB_GetDate(&gTodayYear, &gTodayMonth, &gTodayDay,
			    &hour, &min);

    return 0;
}

int finalize(void)
{
    DB_Tidy();

    return 0;
}

int main(int argc, char *argv[])
{
    int r, i;

    r = initialize();
    if (r < 0)
	return 1;

    RecordFile_Load();
    for (i = 1; i < argc; i++){
	switch (argv[i][1]){
	    case 'r':
	    add_data_real();
	    break;

	    case 'h':
	    add_data_holiday();
	    break;

	    case 't':
	    add_data_test(atoi(argv[++i]));
	    break;

	    case 'd':
	    delete_first();
	    break;

	    default:
	    break;
	}
    }
    RecordFile_Save();

    r = finalize();
    if (r < 0)
	return 1;

    return 0;
}
